textOnFail = "Sorry, your web browser isn't able to read this animation. Please try to download <a href='http://mozilla.org/firefox/'>Firefox</a>, a free, open source and standart-compliant browser.";

canvas = document.getElementById('animation_name');

//Code ici pour tester. Quiconque d'autre que moi ne devrait jamais lire cela
animation_width = canvas.width;
animation_height = canvas.height;
animation_framerate=10;
animation_background_color="rgb(12,210,140)";

if (canvas.getContext){
    ctx = canvas.getContext('2d');
}else{
    document.getElementById('alert_message').innerHTML = textOnFail;
}

//Définition des objets à afficher:
obj1 = {
    type : "bitmap",
    src  : 1, //le nombre représente l'adresse dans le tableau imagesList de l'image à charger (attention, commence à 0)
    x    : 72, //abscisse en pixels en partant de la gauche
    y    : 55,//abscisse en pixels en partant du haut
    width  : 306,//largeur en px
    height : 96,//hauteur en px
    alpha  : 0.9,//inutile pour le moment, pas encore implémenté
}
obj2 = {
    type : "rectangle",
    x    : 162, //abscisse en pixels en partant de la gauche
    y    : 55,//abscisse en pixels en partant du haut
    width  : 36,//largeur en px
    height : 36,//hauteur en px
    fillStyle : "rgba(255,12,255,0.2)",//Couleur de remplissage du rectangle (si la transparence est inutile, on peut se contenter de rgb())
    strokeStyle: "rgba(255,155,255,1)",//Couleur du contour
}

obj3 = {
    type : "text",
    x    : 112, //abscisse en pixels en partant de la gauche
    y    : 65,//abscisse en pixels en partant du haut
    font : "16pt Times",
    text : "Hello World",
    color : "rgb(122,55,88)",
}

obj4 ={
	type : "sound", //Tout simplement ;)
	src  : 0, //le nombre représente l'adresse dans le tableau soundsList de l'image à charger (attention, commence à 0)
}

readyState = 0;
//Images pre-loading system
	imagesList = ["tralala.png", "B1.jpg"]; //Important
	readyState += imagesList.length;
	for(i=imagesList.length-1;i>=0;i--){
		var img = new Image();
		img.onload = function(){readyState--;}
		img.src=imagesList[i];
		imagesList[i]=img;
	}
//End of image pre-loading system

//Sound pre-load system
	soundsList = ["fsf song.ogg"]; //Important
	readyState += soundsList.length;
	for(i=soundsList.length-1;i>=0;i--){
		var snd = document.createElement("audio");
		snd.addEventListener("load", function() {readyState--;}, true);
		snd.setAttribute("src", soundsList[i]);
		soundsList[i] = snd;
	}
//End of image pre-load system

function draw_object(object){
    switch (object.type){
        case "bitmap":
            ctx.globalAlpha = object.alpha;
            ctx.drawImage(imagesList[object.src], object.x, object.y, object.width, object.height);
        break;
        case "sound":
            soundsList[object.src].play();
        break;
        case "rectangle":
            ctx.fillStyle = object.fillStyle;
            ctx.fillRect(object.x, object.y, object.width, object.height);
            ctx.strokeStyle = object.strokeStyle;
            ctx.strokeRect(object.x, object.y, object.width, object.height);
        break;
        case "text":
            ctx.font=object.font;
            ctx.fillStyle=object.color;
            ctx.fillText(object.text, object.x, object.y);
        break;
        }
}

frame = 0;
function main_loop (){
/*
    //Code à écrire seulement si il y a une couleur de fond
        ctx.fillStyle(animation_background_color);
        ctx.fillRect(0,0,animation_width,animation_height);
        */
    //Code à écrire sinon (fond transparent)
        ctx.clearRect(0,0,animation_width,animation_height);

	//Tous les objets à dessiner:
	draw_object(obj1);draw_object(obj4);
    frame++;
    setTimeout("main_loop()", 1000/animation_framerate);
}

function wait_for_images_to_load (){
    if (readyState==0){
        main_loop();
    }else{
        ctx.clearRect(0,0,animation_width,animation_height);
        draw_object(obj3); draw_object(obj2);//Of course, the objects drawn here cannot be images :(
        setTimeout("wait_for_images_to_load()", 1000/animation_framerate);
    }
}

wait_for_images_to_load ();
