/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/

//translations
#include <locale.h>
#include <libintl.h>

/********************************
 * module consacré à la gestion
 * de la bibliothèque d'objets
 * *****************************/
#include <stdlib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <assert.h>
#include <zip.h>
#include "string.h"
#include "ellasyms.h" 


/* icons */
#include "./icones_rcs/symbol.xpm"
#include "./icones_rcs/sound.xpm"
/* variables globales */
//GtkWidget *buttonBiblioRemove;/* obligatoirement externe ! et déclaré dans le .h*/
GtkListStore *pBiblio;
GtkWidget *pListViewBiblio;/* permet d'afficher les objets */
gint BiblioItemsCount=0;/* compteur nombre objets utilisés */
/* Chargement des images non exportées */
    GdkPixbuf *pIco_dessin;
    GdkPixbuf *pIco_image;
    GdkPixbuf *pIco_son;
	GdkPixbuf *pIco_symbol;
	

enum {
    BIBLIO_TYPE_COLUMN,
    BIBLIO_NAME_COLUMN,
    BIBLIO_PATH_NAME_COLUMN,
	BIBLIO_VISIBLE_COLUMN,
	BIBLIO_MEMO_COLUMN,  
	BIBLIO_VISIBLE_TEXT,
	BIBLIO_ATOM,
    BIBLIO_N_COLUMN
};

enum
    {
		BIBLIO_ATOM_BITMAP,
		BIBLIO_ATOM_SVG,
		BIBLIO_ATOM_WAV,
		BIBLIO_ATOM_SYMBOL
	};
/***************************
 * drag n drop
 * ************************/
enum
    {
      BTARGET_STRING,
      BTARGET_URL,
	  BTARGET_TYPE_PIXMAP
    };

/* ci-dessous, 0 signifie aucune restriction */ 
static GtkTargetEntry Btargetentries[] =
    {
      { "STRING",        0, BTARGET_STRING },
      { "text/plain",    0, BTARGET_STRING },
      { "text/uri-list", 0, BTARGET_URL },
	  { "image/x-xpixmap", 0, BTARGET_TYPE_PIXMAP},
    };

/***************************
 pixmaps 
***************************/

/* XPM */
static char * image_xpm[] = {
"24 24 179 2",
"  	c None",
". 	c #FC8628",
"+ 	c #FC872C",
"@ 	c #FC8A30",
"# 	c #FC8C33",
"$ 	c #FA8D37",
"% 	c #FC8F39",
"& 	c #FD8628",
"* 	c #FC8528",
"= 	c #FC872B",
"- 	c #FC882D",
"; 	c #FB8A31",
"> 	c #FB8B34",
", 	c #FB8E38",
"' 	c #FB8F3A",
") 	c #FB923E",
"! 	c #FA9241",
"~ 	c #FA9545",
"{ 	c #F8974B",
"] 	c #FB8D37",
"^ 	c #FB913D",
"/ 	c #FA9444",
"( 	c #FA9647",
"_ 	c #FA984A",
": 	c #F9994E",
"< 	c #F99B51",
"[ 	c #FA9E55",
"} 	c #FC8B31",
"| 	c #FB8B33",
"1 	c #FB8F39",
"2 	c #FA9240",
"3 	c #FA9646",
"4 	c #F9994D",
"5 	c #F99C53",
"6 	c #F99F57",
"7 	c #F9A05A",
"8 	c #F8A25D",
"9 	c #F8A461",
"0 	c #FB903C",
"a 	c #FA9343",
"b 	c #FA9749",
"c 	c #F99A50",
"d 	c #F99E56",
"e 	c #F8A15D",
"f 	c #F8A360",
"g 	c #F8A563",
"h 	c #F8A767",
"i 	c #F7A86A",
"j 	c #F7A96B",
"k 	c #FB923F",
"l 	c #FA913F",
"m 	c #FA9D53",
"n 	c #FAEBDD",
"o 	c #FAE0CB",
"p 	c #F9E0CC",
"q 	c #F9E5D5",
"r 	c #F9C8A1",
"s 	c #F9A059",
"t 	c #F8A35F",
"u 	c #F8A766",
"v 	c #F7AA6C",
"w 	c #F7AC70",
"x 	c #F7AE73",
"y 	c #F6AF76",
"z 	c #F7AC71",
"A 	c #FA913E",
"B 	c #FA9748",
"C 	c #FA994C",
"D 	c #F9AA6D",
"E 	c #F9D3B4",
"F 	c #F99E55",
"G 	c #F8B078",
"H 	c #F8D5B8",
"I 	c #F8A462",
"J 	c #F7A769",
"K 	c #F7AB6F",
"L 	c #F7AF76",
"M 	c #F6B079",
"N 	c #F6B27C",
"O 	c #F6B480",
"P 	c #F6B682",
"Q 	c #F8A968",
"R 	c #FA984B",
"S 	c #F99A4F",
"T 	c #F9BC8B",
"U 	c #F9ECE2",
"V 	c #F8DAC3",
"W 	c #F8A25E",
"X 	c #F8B47F",
"Y 	c #F7E9DD",
"Z 	c #F7E2D1",
"` 	c #F7E3D2",
" .	c #F7E3D3",
"..	c #F7E4D4",
"+.	c #F6E3D4",
"@.	c #F6E4D5",
"#.	c #F6E4D6",
"$.	c #F6E5D6",
"%.	c #F5E4D6",
"&.	c #F5B989",
"*.	c #F5BB8C",
"=.	c #F6B988",
"-.	c #F99D54",
";.	c #F99F58",
">.	c #F8A05B",
",.	c #F8CAA6",
"'.	c #F8C297",
").	c #F8F2ED",
"!.	c #F8E8DA",
"~.	c #F7E7DA",
"{.	c #F7EDE4",
"].	c #F7D3B6",
"^.	c #F7A462",
"/.	c #FA9546",
"(.	c #FB8D36",
"_.	c #FC8426",
":.	c #FD7E1B",
"<.	c #FE7D18",
"[.	c #FDDEC6",
"}.	c #FE750A",
"|.	c #FE7306",
"1.	c #FF7000",
"2.	c #F99B52",
"3.	c #F8A664",
"4.	c #F8CDAB",
"5.	c #F7C093",
"6.	c #F7AB6E",
"7.	c #F7A869",
"8.	c #FB892F",
"9.	c #FD8527",
"0.	c #FFA55F",
"a.	c #FFAD6D",
"b.	c #FF8B31",
"c.	c #FFDDC3",
"d.	c #F9A35E",
"e.	c #F7AA6D",
"f.	c #F7CEAE",
"g.	c #FAB57E",
"h.	c #FC8120",
"i.	c #FF7102",
"j.	c #FF8B30",
"k.	c #FFDEC5",
"l.	c #FFA864",
"m.	c #FF9E52",
"n.	c #FFCDA5",
"o.	c #FFB67C",
"p.	c #FF6F00",
"q.	c #FB8A32",
"r.	c #FFB67D",
"s.	c #FF9A4B",
"t.	c #FFD6B6",
"u.	c #FF7A12",
"v.	c #FFC79C",
"w.	c #FF8A2E",
"x.	c #F8A868",
"y.	c #FC872A",
"z.	c #FE7000",
"A.	c #FFB378",
"B.	c #FF7408",
"C.	c #FFA056",
"D.	c #FFAA67",
"E.	c #FF7407",
"F.	c #FFDCC0",
"G.	c #FF7306",
"H.	c #FFBC87",
"I.	c #FF923C",
"J.	c #FF9B4C",
"K.	c #FFD4B3",
"L.	c #FF8E35",
"M.	c #FF8321",
"N.	c #FFCBA2",
"O.	c #FF8C32",
"P.	c #FFBF8C",
"Q.	c #FFC99E",
"R.	c #FFA660",
"S.	c #FFAC6B",
"T.	c #FFEFE3",
"U.	c #FFD9BB",
"V.	c #FFEEE0",
"                  . + @ # $ %                   ",
"            & * = - ; > , ' ) ! ~ {             ",
"          = - @ > ] ' ^ ! / ( _ : < [           ",
"        } | ] 1 ^ 2 / 3 _ 4 < 5 6 7 8 9         ",
"      1 1 0 2 a 3 b 4 c 5 d 7 e f g h i j       ",
"    k l a m n o p q r s e t g u i v w x y z     ",
"  A ~ B C D E F s G H I u J v K x L M N O P Q   ",
"  R S < T U V W I X Y Z `  ...+.@.#.$.%.&.*.=.  ",
"  -.;.>.,.'.).!.~.{.].K ^.-./.(._.:.<.[.}.|.1.  ",
"2.8 9 3.4.5.6.7.4 8.9.0.a.b.1.1.1.1.1.c.1.1.1.1.",
"d.h i e.f.g.h.i.1.j.k.l.m.n.o.1.1.1.1.c.1.1.1.p.",
"i w f q.r.s.1.1.1.t.u.1.1.1.v.w.1.1.1.c.1.1.1.1.",
"x.y.z.1.A.s.1.1.B.t.1.1.1.1.C.D.1.1.1.c.1.1.1.1.",
"E.1.1.1.A.s.1.1.1.F.G.1.1.1.H.I.1.1.1.c.1.1.1.1.",
"1.1.1.1.A.s.1.1.1.J.K.L.M.A.N.1.1.1.1.c.1.1.1.p.",
"  1.1.1.A.s.1.1.1.1.O.P.Q.R.i.1.1.1.1.c.1.1.1.  ",
"  1.1.1.A.s.1.1.1.1.1.1.1.1.1.1.1.1.1.c.1.1.1.  ",
"  1.1.1.S.T.U.U.U.U.U.U.U.U.U.U.U.U.U.V.1.1.p.  ",
"    1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.    ",
"      1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.      ",
"        1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.        ",
"          1.1.1.1.1.1.1.1.1.1.1.1.1.1.          ",
"            1.1.1.1.1.1.1.1.1.1.1.1.            ",
"                  1.p.1.1.p.1.                  "};
/* XPM */
static char * dessin_xpm[] = {
"24 24 183 2",
"  	c None",
". 	c #FC8628",
"+ 	c #FC862B",
"@ 	c #FC892F",
"# 	c #FC8A32",
"$ 	c #FA8C36",
"% 	c #FC8E39",
"& 	c #FB8527",
"* 	c #FC8528",
"= 	c #FC872B",
"- 	c #FC882D",
"; 	c #FB8A31",
"> 	c #FB8B34",
", 	c #FB8E38",
"' 	c #FB8F3A",
") 	c #FB923E",
"! 	c #FA9241",
"~ 	c #FA9545",
"{ 	c #FA9849",
"] 	c #FC8A30",
"^ 	c #FB8D37",
"/ 	c #FB913D",
"( 	c #FA9444",
"_ 	c #FA9647",
": 	c #FA984A",
"< 	c #F9994E",
"[ 	c #F99B51",
"} 	c #F99C53",
"| 	c #FC8B31",
"1 	c #FB8B33",
"2 	c #FB8F39",
"3 	c #FA9240",
"4 	c #FA9646",
"5 	c #F9994D",
"6 	c #F99F57",
"7 	c #F9A05A",
"8 	c #F8A25D",
"9 	c #F8A35F",
"0 	c #FB903C",
"a 	c #FA9343",
"b 	c #FA9749",
"c 	c #F99A50",
"d 	c #F99E56",
"e 	c #F8A15D",
"f 	c #F8A360",
"g 	c #F8A563",
"h 	c #F8A767",
"i 	c #F7A86A",
"j 	c #F7A96B",
"k 	c #FA913F",
"l 	c #FA9649",
"m 	c #FA994C",
"n 	c #F99C52",
"o 	c #F99F59",
"p 	c #F9E3D1",
"q 	c #F8E9DD",
"r 	c #F8A766",
"s 	c #F7AA6C",
"t 	c #F7AC70",
"u 	c #F7AE73",
"v 	c #F6AF76",
"w 	c #F7AB70",
"x 	c #FA9748",
"y 	c #FAECE0",
"z 	c #F9C9A4",
"A 	c #F99D53",
"B 	c #F99E55",
"C 	c #F9A059",
"D 	c #F8A15C",
"E 	c #F8D0B0",
"F 	c #F8E0CC",
"G 	c #F7A96C",
"H 	c #F7AB6F",
"I 	c #F7AF76",
"J 	c #F6B079",
"K 	c #F6B27C",
"L 	c #F6B480",
"M 	c #F6B682",
"N 	c #F6A566",
"O 	c #FA984B",
"P 	c #F99A4F",
"Q 	c #F9DFC9",
"R 	c #F9F9F8",
"S 	c #F8CAA7",
"T 	c #F8A25E",
"U 	c #F8A462",
"V 	c #F8A665",
"W 	c #F7A769",
"X 	c #F7AD72",
"Y 	c #F6B078",
"Z 	c #F6BF93",
"` 	c #F6E2D1",
" .	c #F6E8DB",
"..	c #F5B786",
"+.	c #F5B989",
"@.	c #F5BB8C",
"#.	c #F6B988",
"$.	c #F99D54",
"%.	c #F99F58",
"&.	c #F8A05B",
"*.	c #F8C499",
"=.	c #F8F8F7",
"-.	c #F8F7F6",
";.	c #F8BF91",
">.	c #F7AB6E",
",.	c #F7A462",
"'.	c #FA9546",
").	c #FB8D36",
"!.	c #FCBD8B",
"~.	c #FDFAF8",
"{.	c #FDFAF9",
"].	c #FD9443",
"^.	c #FF770B",
"/.	c #FF7408",
"(.	c #FF7101",
"_.	c #F99C55",
":.	c #F8A461",
"<.	c #F8A664",
"[.	c #F8AB6E",
"}.	c #F7F2EC",
"|.	c #F7F7F6",
"1.	c #F7EFE8",
"2.	c #FB892F",
"3.	c #FD7B15",
"4.	c #FF7000",
"5.	c #FF7306",
"6.	c #FFB57A",
"7.	c #FFCBA2",
"8.	c #F8A35E",
"9.	c #F7AA6D",
"0.	c #FAC59A",
"a.	c #FCFCFC",
"b.	c #FFFFFF",
"c.	c #FFC597",
"d.	c #F7A86B",
"e.	c #FB8B32",
"f.	c #FF7509",
"g.	c #FFEEE0",
"h.	c #FFFDFB",
"i.	c #FF8628",
"j.	c #FF7407",
"k.	c #FF913B",
"l.	c #FF9039",
"m.	c #FF7C15",
"n.	c #F8A96B",
"o.	c #FC872A",
"p.	c #FE7000",
"q.	c #FF9746",
"r.	c #FFFEFE",
"s.	c #FFCBA3",
"t.	c #FFB174",
"u.	c #FFFCFA",
"v.	c #FFFCF9",
"w.	c #FFF6EF",
"x.	c #FFC699",
"y.	c #FF8D34",
"z.	c #FFF8F2",
"A.	c #FFF6F0",
"B.	c #FFF6EE",
"C.	c #FFDCC1",
"D.	c #FFAD6D",
"E.	c #FF7B14",
"F.	c #FF9B4C",
"G.	c #FF8424",
"H.	c #FF6F00",
"I.	c #FF780F",
"J.	c #FFEFE2",
"K.	c #FFFBF9",
"L.	c #FFD4B2",
"M.	c #FF9949",
"N.	c #FFDBBF",
"O.	c #FFFDFC",
"P.	c #FF9848",
"Q.	c #FF8A30",
"R.	c #FFFEFD",
"S.	c #FFA763",
"T.	c #FF811D",
"U.	c #FFF2E8",
"V.	c #FF7911",
"W.	c #FFD7B7",
"X.	c #FFD0AB",
"Y.	c #FF9847",
"Z.	c #FF7100",
"                  . + @ # $ %                   ",
"            & * = - ; > , ' ) ! ~ {             ",
"          = - ] > ^ ' / ! ( _ : < [ }           ",
"        | 1 ^ 2 / 3 ( 4 : 5 [ } 6 7 8 9         ",
"      ^ 2 0 3 a 4 b 5 c } d 7 e f g h i j       ",
"    / k l ~ b m c n o p q 9 g r i s t u v w     ",
"  3 ~ x y z A B C D 9 E F G s H u I J K L M N   ",
"  O P [ Q R S T U V W j H X I Y Z `  ...+.@.#.  ",
"  $.%.&.*.=.-.;.j >.X H ,.$.'.).!.~.{.].^./.(.  ",
"_.8 :.<.[.}.|.1.%.2.3.(.4.4.4.4.5.6.7./.4.4.4.4.",
"8.h i 9.>.0.a.b.c.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.",
"d.t f e.f./.g.b.h.i.4.4.4.j.k.l.m.4.4.4.4.4.4.4.",
"n.o.p.4.4.4.q.r.b.s.4.4.4.t.u.v.w.4.4.4.4.4.4.4.",
"j.4.4.4.4.4.4.x.b.v.m.4.4.y.z.A.B.4.4.4.4.4.4.4.",
"4.4.4.4.4.4.4.5.C.b.D.4.4.4.E.F.G.4.4.4.4.4.4.H.",
"  4.4.4.4.4.4.4.I.J.K.L.M.4.4.4.4.4.4.4.4.4.4.  ",
"  4.4.4.4.4.4.4.4.N.b.b.O.P.4.4.4.4.4.4.4.4.4.  ",
"  H.4.4.4.4.4.4.Q.R.b.b.b.S.4.4.4.4.4.4.4.4.4.  ",
"    4.4.4.4.4.4.T.B.b.b.U.V.4.4.4.4.4.4.4.4.    ",
"      4.4.4.4.4.4.l.W.h.X.4.4.4.4.4.4.4.4.      ",
"        4.4.4.4.4.4.4.G.Y.4.4.4.4.4.4.4.        ",
"          4.4.4.4.4.4.4.4.4.4.4.4.4.4.          ",
"            Z.4.4.4.4.4.4.4.4.4.4.4.            ",
"                  4.H.4.4.H.4.                  "};


/* forwards */
void add_tree_list_biblio(GtkListStore *pListStore,gint categorie,gchar *nom,gchar *path,gboolean actif);	
/*******************************
 fonction copie en binaire
 copie de source vers dest
*******************************/
int copier_fichier_biblio(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char buffer[512];
    int NbLus;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
      {
        return 1;
      }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
      {
        fclose(fSrc);
        return 2;
      }    
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0)
        fwrite(buffer, 1, NbLus, fDest);
    
    fclose(fDest);
    fclose(fSrc);
    
    return 0;
}
	
/**********************************
 * effacer tous les éléments de la
 * bibliothèque
 * *******************************/
void biblio_clear_items(GtkTreeView *pListView)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter iter;
 gint count;
 
  if (BiblioItemsCount<=0)
       return;
  //printf("BiblioItemsCount %d\n",BiblioItemsCount);
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListView));  
  path1=g_strdup_printf ("%d:%d",0,0);/* astuce, car l'ordre de la pile est progressivement détruit ! */
  path=gtk_tree_path_new_from_string(path1);
  for (count=0;count<BiblioItemsCount;count++)
     {    	  
	   gtk_tree_model_get_iter(model, &iter, path);	   
	   gtk_list_store_remove(GTK_LIST_STORE(model),&iter); 
     }/* next count */       	
  g_free(path1);
  gtk_tree_path_free(path);  
  BiblioItemsCount=0;   
} 	
/**********************************
 * sauvegarder la biblio
 * *******************************/
void biblio_save_biblio(gchar *path_to_file,GtkTreeView     *treeview)
{
    GtkTreeModel *model;
    GtkTreePath *path;
    gchar *path1;
    GtkTreeIter iter;
    gint count,atom,err;
    gchar *path_temp,*path_temp_archive,*command,*nom_item,*path_to_tmp_file,*memo;
	gchar buf[512];
	FILE *f;
    struct zip *archive;
    struct zip_source *zs;
    struct zip_file *fpz=NULL;
    struct zip_stat sb;
  	
	command = g_strdup_printf("rm %s/.ella/*.*",getenv("HOME"));
	err = system(command);
	g_free(command);
	path_temp=g_strdup_printf("%s/.ella/archive.lst",getenv("HOME"));
    path_temp_archive=g_strdup_printf("%s/.ella/ella.zip",getenv("HOME"));
	/* passer en revue toute la liste */
	if (BiblioItemsCount>0)
	  {
		    model=gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));  
			/* créer le descripteur du contenu */
			f=fopen(path_temp,"w");
			for (count=0;count<BiblioItemsCount;count++)
			  {
				 path1=g_strdup_printf ("%d:%d",count,0);
			     path=gtk_tree_path_new_from_string(path1); 
				 gtk_tree_model_get_iter(model, &iter, path);
			     gtk_tree_model_get (model, &iter, BIBLIO_ATOM, &atom, -1);  
				 gtk_tree_model_get (model, &iter, BIBLIO_NAME_COLUMN, &nom_item, -1); 
				 gtk_tree_model_get (model, &iter, BIBLIO_MEMO_COLUMN, &memo, -1); 
				 switch (atom)
				   {
					   case BIBLIO_ATOM_BITMAP:
					     {
							 fprintf(f,"[BIBBTM]%s\n",g_strescape(nom_item,NULL));
							 break;
						 }
					   case BIBLIO_ATOM_SVG:
					     {
							 fprintf(f,"[BIBVCT]%s\n",g_strescape(nom_item,NULL));							 
							 break;
						 }
					   case BIBLIO_ATOM_WAV:
					     {
							 fprintf(f,"[BIBSND]%s\n",g_strescape(nom_item,NULL));							 
							 break;
						 }
					   case BIBLIO_ATOM_SYMBOL:
					     {
							 fprintf(f,"[BIBSYM]%s\n",g_strescape(nom_item,NULL));							 
							 break;
						 } 
					   default:printf("atom inconnu ! \n");	 
				   }/*end switch*/
				if (strlen(memo)>0)
				    fprintf(f,"[REMARK]%s\n",g_strescape(memo,NULL));   
				g_free(nom_item);   
			    g_free(path1);
				if (memo!=NULL)
				     g_free(memo);
                gtk_tree_path_free(path);   		
			  }/* next */
			fclose(f);
	    /* créer un ZIP et y ajouter les fichiers */
		   err=0;
	       archive=zip_open(path_temp_archive,ZIP_CREATE,&err);/* avec ce mode, le fichier est écrasé ! */	
		   if(err != 0 || !archive)
             {
               zip_error_to_str(buf, sizeof buf, err, errno);
               fprintf(stderr,"«%s» %d in function «%s» ,err=%d\n«%s»\n",__FILE__,__LINE__,__FUNCTION__,err,buf);
               exit(EXIT_FAILURE);
             }
		   zs = zip_source_file(archive,path_temp,0,0); /* lit par défaut tout le fichier */
           if (zs==NULL)
            {
              printf("erreur source \n");
              return;
            } 
           /* ajouter à l'archive le fichier texte de description */ 
           err = zip_add(archive,"archive.lst",zs);	  
		   for (count=0;count<BiblioItemsCount;count++)
			  {
				 path1=g_strdup_printf ("%d:%d",count,0);
			     path=gtk_tree_path_new_from_string(path1); 
				 gtk_tree_model_get_iter(model, &iter, path);	
				 /* ajouter éléments à l'archive */
				 gtk_tree_model_get (model, &iter, BIBLIO_PATH_NAME_COLUMN, &path_to_tmp_file, -1); 
				 gtk_tree_model_get (model, &iter, BIBLIO_NAME_COLUMN, &nom_item, -1); 
				 zs = zip_source_file(archive,path_to_tmp_file,0,0); /* lit par défaut tout le fichier */
				 if (zs==NULL)
                   {
                     printf("erreur source \n");
				     return;
			       }
				 err = zip_add(archive,g_path_get_basename(path_to_tmp_file),zs);					 
				 g_free(path1);
                 gtk_tree_path_free(path); 
				 g_free(path_to_tmp_file);
				 g_free(nom_item);   
			 }/* next */
		   /* utilisation terminée, fermeture de l'archive */
           zip_close(archive); 	 
		   /* transfert du fichier .zip vers sa cible */
		   copier_fichier_biblio(path_temp_archive,path_to_file);
	  }/* endif */
	g_free(path_to_file);	
	g_free(path_temp);
    g_free(path_temp_archive);	
}
/**********************************
 * dialogue de sauvegarde d'une
 * archive
 * *******************************/

GtkWidget*
create_dialogSaveArchiveBiblio (void)
{
  GtkWidget *dialogSaveArchiveBiblio;
  GtkWidget *dialog_vbox11;
  GtkWidget *dialog_action_area11;
  GtkWidget *button10;
  GtkWidget *button11;
  GtkFileFilter *filter;
		
  filter = gtk_file_filter_new ();
  dialogSaveArchiveBiblio = gtk_file_chooser_dialog_new (gettext("Save library as ..."), 
      NULL, GTK_FILE_CHOOSER_ACTION_SAVE,NULL,NULL, NULL);
  gtk_file_filter_add_pattern (filter, "*.bibella");
  gtk_file_filter_set_name (filter,gettext("libraries"));  		
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(dialogSaveArchiveBiblio),filter);	  
  gtk_container_set_border_width (GTK_CONTAINER (dialogSaveArchiveBiblio), 5);
  gtk_window_set_position (GTK_WINDOW (dialogSaveArchiveBiblio), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogSaveArchiveBiblio), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogSaveArchiveBiblio), "gtk-save");
  gtk_window_set_type_hint (GTK_WINDOW (dialogSaveArchiveBiblio), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox11 = GTK_DIALOG (dialogSaveArchiveBiblio)->vbox;
  gtk_widget_show (dialog_vbox11);

  dialog_action_area11 = GTK_DIALOG (dialogSaveArchiveBiblio)->action_area;
  gtk_widget_show (dialog_action_area11);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area11), GTK_BUTTONBOX_END);

  button10 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button10);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogSaveArchiveBiblio), button10, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button10, GTK_CAN_DEFAULT);

  button11 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button11);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogSaveArchiveBiblio), button11, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button11, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button11);
  return dialogSaveArchiveBiblio;
}

/**********************************
 * dialogue d'ouverture d'une 
 * archive
 * *******************************/
GtkWidget*
create_dialogOpenArchiveBiblio (void)
{
  GtkWidget *dialogOpenArchiveBiblio;
  GtkWidget *dialog_vbox10;
  GtkWidget *dialog_action_area10;
  GtkWidget *button8;
  GtkWidget *button9;
  GtkFileFilter *filter;
		
  filter = gtk_file_filter_new ();
  dialogOpenArchiveBiblio = gtk_file_chooser_dialog_new (gettext("Import a library content"), 
                      NULL, GTK_FILE_CHOOSER_ACTION_OPEN,NULL,NULL, NULL);
	
  gtk_file_filter_add_pattern (filter, "*.bibella");
  gtk_file_filter_set_name (filter,gettext("libraries"));  		
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(dialogOpenArchiveBiblio),filter);
    			  
  gtk_container_set_border_width (GTK_CONTAINER (dialogOpenArchiveBiblio), 5);
  gtk_window_set_position (GTK_WINDOW (dialogOpenArchiveBiblio), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogOpenArchiveBiblio), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogOpenArchiveBiblio), "gtk-open");
  gtk_window_set_type_hint (GTK_WINDOW (dialogOpenArchiveBiblio), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox10 = GTK_DIALOG (dialogOpenArchiveBiblio)->vbox;
  gtk_widget_show (dialog_vbox10);

  dialog_action_area10 = GTK_DIALOG (dialogOpenArchiveBiblio)->action_area;
  gtk_widget_show (dialog_action_area10);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area10), GTK_BUTTONBOX_END);

  button8 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button8);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogOpenArchiveBiblio), button8, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button8, GTK_CAN_DEFAULT);

  button9 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button9);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogOpenArchiveBiblio), button9, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button9, GTK_CAN_DEFAULT);

  gtk_widget_grab_default (button9);
  return dialogOpenArchiveBiblio;
} 	
/*********************************
 * callbacks de la bibliothèque
 * ******************************/
/********************************
 * archiver une bibliothèque
 * *****************************/
void
on_buttonBiblioArchive_clicked         (GtkButton       *button,
                                        GtkTreeView     *treeview)
{
	GtkWidget *dlg;
    gint reponse;
	gchar *path_to_file;
	
	dlg=create_dialogSaveArchiveBiblio ();
    gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dlg), getenv("HOME"));
    gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dlg), gettext("noname.bibella"));	
    gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dlg),TRUE);/* contrôle overwrite */	
	reponse=gtk_dialog_run(GTK_DIALOG(dlg));
	if (reponse!=GTK_RESPONSE_OK)
      {
           gtk_widget_destroy(dlg);
           return;
      }
	/* quel fichier ? */
	path_to_file= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dlg));
	gtk_widget_destroy(dlg);	
	/* archiver */
    biblio_save_biblio(path_to_file,treeview);		
}

/*******************************
 * ouvrir une archive
 * ****************************/
void
on_buttonBiblioOpenArchive_clicked     (GtkButton       *button,
                                        GtkTreeView     *treeview)
{
    gint reponse,err,nto,i;
	GtkWidget *dlg;
	gchar *path_to_file,*p;
    gchar *path_temp,*path_temp_archive,*nom_item,*path_to_tmp_file,*memo,*instr,*param;
    struct zip *archive;
    struct zip_file *fpz=NULL;
    struct zip_stat sbzip;
	char buf[1024];
	FILE *fichier;
	gboolean existe;
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter iter;
 	
	dlg=create_dialogOpenArchiveBiblio();
    gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dlg), getenv("HOME"));	
	reponse=gtk_dialog_run(GTK_DIALOG(dlg));
	if (reponse!=GTK_RESPONSE_OK)
      {
           gtk_widget_destroy(dlg);
           return;
      }
	/* quel fichier ? */
	path_to_file= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dlg));
	gtk_widget_destroy(dlg);
    /* effacer le contenu actuel */
	biblio_clear_items(treeview);
	/* ouvrir l'archive */
	err=0;
    archive=zip_open(path_to_file,ZIP_CHECKCONS,&err);
    if(err != 0 || !archive)
        {
          zip_error_to_str(buf, sizeof buf, err, errno);
          fprintf(stderr,"«%s» %d in function «%s» ,err=%d\n«%s»\n",__FILE__,__LINE__,__FUNCTION__,err,buf);
          exit;/* fonction sans retour de valeur !!! */
        }    	
	/* déterminer le nombre de fichiers contenus */
    nto = zip_get_num_files(archive);
	for (i=0;i<nto;i++)
      {
		 zip_stat_index(archive, i, 0, &sbzip);       
         /*pour savoir la taille du fichier et ainsi pouvoir le lire en entier*/
         if(zip_stat(archive, sbzip.name, 0, &sbzip) == -1)
           {
              strcpy(buf,zip_strerror(archive));
              fprintf(stderr,"«%s» %d in function «%s»\n«%s»\n",__FILE__,__LINE__,__FUNCTION__,buf);
              zip_fclose(fpz);
              zip_close(archive);
              exit;
           }/* if erreur */
		 fpz=zip_fopen(archive,sbzip.name,ZIP_FL_UNCHANGED);  
		 if(!fpz)
            {
              strcpy(buf,zip_strerror(archive));
			  fprintf(stderr,"«%s» %d in function «%s»\n«%s»\n",__FILE__,__LINE__,__FUNCTION__,buf);
			  zip_close(archive);
			  exit;
			}/* erreur */
		 p=g_malloc(sbzip.size*sizeof(gchar)+1);
         assert(p != NULL);
         /*lit le fichier*/
         if(zip_fread(fpz,p,sbzip.size) != sbzip.size)
           {
             fprintf(stderr,"«%s» %d in function «%s»\n«read error ...»\n",__FILE__,__LINE__,__FUNCTION__);
             g_free(p);
             zip_fclose(fpz);
             zip_close(archive);
             exit;
           }/* erreur */
		 /* écriture en mode binaire */
		 path_to_tmp_file=g_strdup_printf("%s/%s",(gchar *)g_get_tmp_dir(),sbzip.name);
         fichier = fopen(path_to_tmp_file,"w");
         fwrite(p,sizeof(gchar),sbzip.size,fichier);
         fclose(fichier);
         zip_fclose(fpz);
         free(p);
		 g_free(path_to_tmp_file);   	
	  }/* next i */
    /* lecture terminée, fermeture de l'archive */
    zip_close(archive);  
	/* maintenant, il faut décoder le fichier de description */	  
	path_temp=g_strdup_printf("%s/%s",(gchar *)g_get_tmp_dir(),"archive.lst");
	existe=g_file_test(path_temp,G_FILE_TEST_EXISTS);
	if (!existe)
	   {
		   printf("fichier de description absent \n");
		   g_free(path_to_file);
		   g_free(path_temp);
		   return;
	   }
	/* lire le fichier de description */  
	fichier=fopen(path_temp,"r");
	if (fichier==NULL)
	     printf("problème !\n");
	//printf("path temp:%s\n",path_temp);
	i=0;
	while (fgets(buf,1000,fichier)!=NULL)
	    {
			instr=	instr=g_strndup (buf,8);
			if (strlen(buf)>8)
      	           param=(gchar *)g_substr (buf, 8, strlen(buf)-2);
			//printf("instruction:%s<>opérande:%s\n",instr,g_strcompress(param));
			path_to_tmp_file=g_strdup_printf("%s/%s",(gchar *)g_get_tmp_dir(),g_strescape(param,NULL));
			//printf("fichier dans tmp:%s\n",path_to_tmp_file);
			if (g_strcmp0(instr,"[BIBBTM]")==0)
			   {
				  add_tree_list_biblio(pBiblio,1,param,path_to_tmp_file,FALSE);
				  i++; 
			   }
			if (g_strcmp0(instr,"[BIBVCT]")==0)
			   {
				  add_tree_list_biblio(pBiblio,2,param,path_to_tmp_file,FALSE);
				  i++;
			   }			   
			if (g_strcmp0(instr,"[BIBSND]")==0)
			   {
				  add_tree_list_biblio(pBiblio,3,param,path_to_tmp_file,FALSE); 
				  i++;
			   }
			if (g_strcmp0(instr,"[BIBSYM]")==0)
			   {
				  add_tree_list_biblio(pBiblio,4,param,path_to_tmp_file,FALSE); 
				  i++;
			   }   
			if (g_strcmp0(instr,"[REMARK]")==0)
			   {
				   model=gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));  
                   path1=g_strdup_printf ("%d:%d",i-1,0);/* astuce, car l'ordre de la pile est progressivement détruit ! */
                   path=gtk_tree_path_new_from_string(path1);
				   gtk_tree_model_get_iter(model, &iter, path);	  
				   gtk_list_store_set(GTK_LIST_STORE(model),&iter,BIBLIO_MEMO_COLUMN,param, -1); 	                				   
                   g_free(path1);
                   gtk_tree_path_free(path);  				   
			   }			   
			g_free(path_to_tmp_file);   			   
			g_free(instr);	
		}/* wend */
	fclose(fichier);	
	/* mettre à jour l'onglet bibliothèque */
	g_free(path_to_file);		
}

/****************************************
 * callback suite à l'édition d'un
 * commentaire
 * *************************************/
void on_biblio_comment_edited(GtkCellRendererToggle *cell, gchar *path,gchar *new_text,
 GtkTreeView     *treeview) 
{
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreePath *path_tree;
	GtkTreeIter iter;
	gchar *commentaire;
	
	/* récupérer la ligne concernée */
	selection = gtk_tree_view_get_selection ( treeview );
	gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );
	if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter,-1);/* &iter avec ampersand obligatoire */		
		/* lis le chemin */
		path_tree = gtk_tree_model_get_path(model,&iter);
		commentaire= gtk_tree_path_to_string (path_tree);		
		/* modifier le bouton à l'écran */
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, BIBLIO_MEMO_COLUMN, new_text,-1);
		g_free(commentaire);
		gtk_tree_path_free(path_tree);		
	}		
}
/**********************************
 * retirer un élément de la liste
 * *******************************/
void on_buttonBiblioRemove_clicked(GtkButton       *button,
                                        GtkTreeView     *treeview)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected (selection, &model, &iter ) )
	{	
		gtk_tree_model_get (model, &iter, -1);		
		gtk_list_store_remove(GTK_LIST_STORE(model),&iter);
	}
}

/**********************************
 * création dynamique du modèle
 * *******************************/
GtkListStore *init_store_biblio(void)
{
    GtkListStore *pListStore;   
    GType *types;
    
    /* création dynamique du modèle */
    types = g_new0 (GType, BIBLIO_N_COLUMN);
    types[0] = GDK_TYPE_PIXBUF;/* image de l'objet de la biblio */
    types[1] = G_TYPE_STRING;/* nom de l'objet sous forme courte */
    types[2] = G_TYPE_STRING;/* chemin d'accès au fichier réel */
	types[3] = G_TYPE_BOOLEAN;
    types[4] = G_TYPE_STRING;/* commentaire */  
	types[5] = G_TYPE_STRING;/* indicateur visible ou non */  
	types[6] = G_TYPE_INT; /* atom du type d'objet */
    pListStore = gtk_list_store_newv (7, types);
    g_free (types);
 return pListStore;			
}
/*************************************
 ajouter un élément à la bibliothèque
*************************************/
void add_tree_list_biblio(GtkListStore *pListStore,gint categorie,gchar *nom,gchar *path,gboolean actif)
{
   gchar *sLayerName, *sPathName;
   GtkTreeIter pIter;  
  
    /* création du contenu */   
    sLayerName = g_malloc(256);
    /* Insertion des elements */
    sprintf(sLayerName,"%s",nom);
	sPathName=g_strdup_printf("%s",path);
    /* Creation de la nouvelle ligne */
    gtk_list_store_append(pListStore, &pIter);
    /* Mise a jour des donnees */
    
    gtk_list_store_set(pListStore, &pIter,
            BIBLIO_NAME_COLUMN, sLayerName,
            BIBLIO_PATH_NAME_COLUMN, sPathName,  
			BIBLIO_MEMO_COLUMN,"", 
			BIBLIO_VISIBLE_COLUMN,FALSE,      
            -1);   
    /* choix de l'image à insérer */
    switch  (categorie)
      {
         case 1:/* image bitmap */
            {
		       gtk_list_store_set(pListStore, &pIter,BIBLIO_TYPE_COLUMN,pIco_image, -1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_ATOM,BIBLIO_ATOM_BITMAP,-1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_VISIBLE_COLUMN,actif,-1);
               break;
            }
         case 2:/* dessin vectoriel */
            {
               gtk_list_store_set(pListStore, &pIter,BIBLIO_TYPE_COLUMN,pIco_dessin, -1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_ATOM,BIBLIO_ATOM_SVG,-1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_VISIBLE_COLUMN,actif,-1);  
               break;
            }
         case 3:/* son */
            {
               gtk_list_store_set(pListStore, &pIter,BIBLIO_TYPE_COLUMN,pIco_son, -1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_ATOM,BIBLIO_ATOM_WAV,-1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_VISIBLE_COLUMN,actif,-1);  
               break;
            }
		case 4:/* symbol */
            {
               gtk_list_store_set(pListStore, &pIter,BIBLIO_TYPE_COLUMN,pIco_symbol, -1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_ATOM,BIBLIO_ATOM_SYMBOL,-1);
			   gtk_list_store_set(pListStore, &pIter,BIBLIO_VISIBLE_COLUMN,actif,-1);  
               break;
            }	
      }		  
   BiblioItemsCount++;  
   g_free(sLayerName);   
   g_free(sPathName);     	
}


/*********************************
 * créer la listree de type 
 * ListStore, donc sans
 * "enfants" (pas dépliables)
 * "ancetre" est un pointeur
 * sur l'item root de l'éditeur
 * ******************************/
GtkWidget *init_tree_list_biblio(GtkListStore *pListStore)
{
    GtkWidget *pListViewBib;
    GtkTreeViewColumn *pColumn;
    GtkCellRenderer *pCellRenderer;    

    /* vue des titres&flags des calques */
    pListViewBib = gtk_tree_view_new_with_model(GTK_TREE_MODEL(pListStore));
    /* interdire l'affichage des en-têtes */
    gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(pListViewBib), TRUE);   
    /* Creation de la 1ère colonne : image */
    pCellRenderer = gtk_cell_renderer_pixbuf_new ();  
    pColumn = gtk_tree_view_column_new_with_attributes(gettext("Type"),
        				pCellRenderer,
        				"pixbuf", BIBLIO_TYPE_COLUMN,
        				NULL);
    /* Ajout de la colonne <image> à la vue */
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewBib), pColumn);    
    /* Creation de la 2e colonne : nom court de l'objet */    
    pCellRenderer = gtk_cell_renderer_text_new();
    g_object_set(G_OBJECT(pCellRenderer),"font","sans 10",NULL);  /* forcer la police */     
    pColumn = gtk_tree_view_column_new_with_attributes(gettext("Name"),
        pCellRenderer,
        "text", BIBLIO_NAME_COLUMN,
        NULL);                           
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewBib), pColumn);        
    /* Ajout de la colonne <visible> à la vue */
	pCellRenderer = gtk_cell_renderer_toggle_new();
    pColumn = gtk_tree_view_column_new_with_attributes(gettext("Used"),
                                                       pCellRenderer,
        												"active", BIBLIO_VISIBLE_COLUMN, 
        												NULL);
    g_object_set(pCellRenderer,"activatable" ,TRUE,NULL); /* pour gérer la bascule, mais ne suffit pas, car nécessaire de l'imposer ensuite avec une call back */                           
    //g_signal_connect(pCellRenderer, "toggled", G_CALLBACK(on_layer_visible_toggled),pListViewLayers);
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewBib), pColumn);  
    /* colonne commentaire BIBLIO_MEMO_COLUMN*/
	pCellRenderer = gtk_cell_renderer_text_new();
    /* le rendre éditable  */
    g_object_set(G_OBJECT(pCellRenderer), "editable", TRUE,  NULL);  
    g_object_set(G_OBJECT(pCellRenderer), "width-chars",16, NULL);    
    g_object_set(G_OBJECT(pCellRenderer),"font","sans 8",NULL);  /* forcer la police */     
    pColumn = gtk_tree_view_column_new_with_attributes(gettext("Comments"),
        			pCellRenderer,
        			"text", BIBLIO_MEMO_COLUMN,
        			NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewBib), pColumn); 
	/* ajouter la callback */
    g_signal_connect(pCellRenderer, "edited",
	           G_CALLBACK(on_biblio_comment_edited),pListViewBib);
	/* création de la colonne destinée au texte "invisible", le nom réel du fichier */
    pCellRenderer = gtk_cell_renderer_text_new();
    pColumn = gtk_tree_view_column_new_with_attributes(gettext("Localization"),
        			pCellRenderer,"text", BIBLIO_PATH_NAME_COLUMN,
           			NULL);
   // gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewBib), pColumn);  
	/* initialiser le DnD - reste à gérer la destination */	
	gtk_drag_source_set(pListViewBib,GDK_BUTTON1_MASK,
	                    Btargetentries, 4,/* nbre valeurs déclarées */
                      GDK_ACTION_COPY|GDK_ACTION_MOVE|GDK_ACTION_LINK);	
	BiblioItemsCount=0;				  				   
    return pListViewBib;
}
/*************************
 * création icones de la
 * bibliothèque
 * *********************/
void init_ico_biblio(void)
{
	pIco_dessin= gdk_pixbuf_new_from_xpm_data((const char **)dessin_xpm);
    pIco_image=gdk_pixbuf_new_from_xpm_data((const char **)image_xpm);
    pIco_son=gdk_pixbuf_new_from_xpm_data((const char **)sound_xpm);
	pIco_symbol=gdk_pixbuf_new_from_xpm_data((const char **)symbol_xpm);
}

/****************************
 * initialisation de la
 * bibliothèque
 * ************************/
 GtkListStore *biblio_init(GtkWidget *win,GtkWidget *butRemove,GtkWidget *buttonBiblioArchive,
                           GtkWidget *buttonBiblioOpenArchive)
{
  /* stockage */
  GtkListStore *pListStoreBiblio;/* magasin de rangement des objets de la biblio */
  //GtkWidget *pListViewBiblio;/* permet d'afficher les objets */
  
  
  /* passer les stores */
  init_ico_biblio();
  pListStoreBiblio=init_store_biblio();
  pListViewBiblio=init_tree_list_biblio(pListStoreBiblio);	
  /* ajoute à la fenêtre voulue l'arbre */
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (win), pListViewBiblio); 
  g_signal_connect ((gpointer) butRemove, "clicked",
                    G_CALLBACK (on_buttonBiblioRemove_clicked),
                    G_OBJECT(pListViewBiblio));
  g_signal_connect ((gpointer) buttonBiblioArchive, "clicked",
                    G_CALLBACK (on_buttonBiblioArchive_clicked),
                    G_OBJECT(pListViewBiblio));
  g_signal_connect ((gpointer) buttonBiblioOpenArchive, "clicked",
                    G_CALLBACK (on_buttonBiblioOpenArchive_clicked),
                    G_OBJECT(pListViewBiblio));					
  return pListStoreBiblio;
}
/**********************************************
 * extract a substring from a string
 * *******************************************/

gchar *clean_svg_datas (const gchar *s, guint start, guint end)
{
   gchar *new_s = NULL;

   if (s != NULL && start < end)
   {
/* (1)*/
      new_s = g_malloc (sizeof (*new_s) * (end - start + 2));
      if (new_s != NULL)
      {
         gint i;

/* (2) */
         for (i = start; i <= end; i++)
         {
/* (3) */
            new_s[i-start] = s[i];
         }
         new_s[i-start] = '\0';
      }
      else
      {
         fprintf (stderr, "Memoire insuffisante\n");
         exit (0);
      }
   }
   return new_s;
}
/***********************************************
 * function to 'parse' a complex SVG file and
 * extract the first valid path ;
 * the path is returned by this function 
 * ********************************************/
gchar *biblio_parse_svg_file(gchar *nom_fich)
{
	FILE *fich;
	gboolean sortie=FALSE;
	gboolean path_found=FALSE;
	gboolean path_data_found=FALSE;
	gchar *resultat=NULL;
	gchar buf[LONG_STRING+1];
	gchar *chaine=NULL;
	gchar *debut,*fin;
	
	/* we read the entire SVG file, until EOF or found a complete <path */
	fich=fopen(nom_fich,"r");
	 while ((feof(fich)==0)&&(sortie==FALSE))
      {
      	fgets(buf,LONG_STRING,fich);	
		/* there is an <path instruction inside ? */
		if (path_found==FALSE)
		  {
			  resultat=g_strrstr((gchar *)buf,"<path");
			  if (resultat!=NULL)
			    path_found=TRUE;
		  }
		/* there is a data path structure inside ? */
		else
		  {
			  resultat=g_strrstr((gchar *)buf," d=\"");
			  if (resultat!=NULL)
			    {
			     /* we must clean the data field */
				 debut=g_strrstr((gchar *)buf,"=\"");
				 fin=g_strrstr((gchar *)buf,"z\"");
				 if (fin==NULL)
				    fin=g_strrstr((gchar *)buf,"z \"");
				 if ((debut!=NULL)&&(fin!=NULL))
				   {
				   /* we only use the string between 'debut+2' and fin-1 */				   
				    chaine=g_strdup_printf("%s",clean_svg_datas((gchar *)buf,debut+2-buf,fin-1-buf));
				   }
			     else
				   printf("error datas path !\n");				 
				 sortie=TRUE;
				 printf("trouve:%s\n",chaine);
			    }
		  } 
	  }
	/* close input file */
	fclose(fich);  	
	return chaine;
}
