/*****************************
 * gestion du clipboard ;
 * contiendra également les
 * fonctions d'annulation
 * ***************************/
#include <gtk/gtk.h>
#include <goocanvas.h>

enum {
	CLIP_EMPTY,
	CLIP_ITEMS };
/* opérations annulables */
enum {
	   UNDO_NOTHING,
	   UNDO_CUT_ITEMS,
	   UNDO_PASTE_ITEMS,
	   UNDO_ERASE_ITEMS,
	   UNDO_NEW_DRAWING,
	   UNDO_COLOR_CHANGE,
	   UNDO_FONT_CHANGE,
	   UNDO_MOVING,
	   UNDO_SIZING,
	   UNDO_ROTATING,
	   UNDO_ALIGN_ITEMS
     };
/* types des objets graphiques */	
enum {
	   ITEM_RECT,
	   ITEM_ELLIPSE,
	   ITEM_LINE,
	   ITEM_TXT,
	   ITEM_BITMAP,
	   ITEM_SVG,
	   ITEM_POLYLINE,
	   ITEM_PATH };
	 
typedef struct {
	gint atom;/* type de contenu */
    gdouble coin_x,coin_y;/* coordonnées coin supérieur de la sélection pour le changement d'origine */
	GList *content;/* pointeur sur les items */
    } clip;

typedef struct {
	gint atom; /* operation to undo */	
	GooCanvasItem *item;/* for undo of last drawing */
	gdouble coin_x,coin_y;/* coordonnées coin supérieur de la sélection pour le changement d'origine */
	GList *content; /* pointeur sur liste d'items */
    } cancel;

/* local type for describing and item */		
typedef struct{
	GooCanvasItem *item;/* for undo of last drawing, of movings */
	gint objet;/* rectangle, cercle ... */
	gdouble x,y;/* coin supérieur gauche */
	gdouble xr,yr;/* arrondis des rectangles */
	gdouble xc,yc;/* centre du cercle */
	gdouble rx,ry;/* rayons */
	gdouble w,h;/* largeur, hauteur */
	gdouble x1,y1,x2,y2;/* 2 points d'une ligne */
	guint32 contour,remplis;/* couleur contour, fill  avec alpha*/
	gdouble lw;/* épaisseur ligne */
	gint alpha;/* transparence */
	gdouble angle;/* si totation activée */
	gchararray texte;/* texte */
	gchararray fonte; /* fonte de l'objet texte */
	gchar *path;
	GdkPixbuf *pbi;/* pointeur sur le pixbuf de l'image */
	gchar *titre_item;
	PangoFontDescription *FntDesc;
	/* fonte */
    } ClipItem;/* items d'éditeur */

void clipboard_init(void);
void clipboard_reset(void);
void clipboard_copy(gint atom,GList *list,gdouble coin_x,gdouble coin_y);
gint clipboard_get_atom(void);
GList *clipboard_get_content(void);	
void clipboard_paste(gint atom,GooCanvasItem *root,gdouble x,gdouble y);
/* undos */
void undo_init(void);
void undo_store_variables(GtkWidget *undo_menu, GtkWidget *button_undo);
void undo_store_datas(gint operation, GooCanvasItem *objet, GList *list, gdouble cx,gdouble cy,gdouble angle_rotation);
gboolean undo_operation(void);
