/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/

//translations
#include <locale.h>
#include <libintl.h>

/**************************
/* en têtes des dialogues
 communs
/*************************/
#include <gtk/gtk.h>
#include <goocanvas.h>
#include "ellasyms.h"

/**********************
 * icones
 * *******************/
#include "./icones_rcs/logo.xpm"
#include "./icones_rcs/center_align.xpm"
#include "./icones_rcs/left_align.xpm"
#include "./icones_rcs/right_align.xpm"
#include "./icones_rcs/high_align.xpm"
#include "./icones_rcs/mid_align.xpm"
#include "./icones_rcs/low_align.xpm"
#include "./icones_rcs/scenery_align.xpm"
#include "./icones_rcs/select_align.xpm"
/* constantes */
#define NUM_REVISION "\n*0.3.1*\nRevision #217\n02/11/2010"

/* XPM */
static char * ecran_xpm[] = {
"128 128 17 1",
" 	c None",
".	c #141613",
"+	c #212220",
"@	c #2D2F2C",
"#	c #3B3C3A",
"$	c #454744",
"%	c #5A5C59",
"&	c #686A67",
"*	c #797B78",
"=	c #888A87",
"-	c #989A97",
";	c #A8AAA7",
">	c #B9BBB7",
",	c #C9CBC8",
"'	c #D8DAD7",
")	c #E7E9E6",
"!	c #FCFEFA",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"               ,,,,,,,,,''''''''''''''''''))))))))))))))))))))!!!!!!))))))))))))))))))))''''''''''''''''''',,,,,,,'             ",
"             !)'''''''''''')))))))))))))))))))))))))))))!!!!!!!!!!!!!!!!!!)))))))))))))))))))))))))))))'''''''''''')!           ",
"             >>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''',,,,,,,,,,,,,,>>>>>>>>,           ",
"            >>>>>>>>,,,,,,,,,,,,,,,,,,,,,,,,,,',''''''''''''''''''''''''''''''''''''',,,,,,,,,,,,,,,,,,,,,,,,,>>>>>>>           ",
"            >>>>>>,'',>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;>>>>>>>>>>,''>>>>>>           ",
"            >>>>>,'=$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%>'>>>>>           ",
"            >>>>>'-%==============================******************************&&&&&&&&&&&&&&&&&&&&&&&&&&&%%%$',>>>>           ",
"            >>>>>'&%>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;;--------------================********&$;,>>>>           ",
"            >>>>>'$%>>>>>>>>>>>>>>>>>>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;;;;--------------================*********&$=,>>>>           ",
"            >>>>>'$%>>>>>>>>>>>>>>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;;;;;;---------------================**********&$=,>>>>           ",
"            >>>>>'$%;;;;>>>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;;;;;;;;;;;----------------================***********&$=,>>>>           ",
"            >>>>>'$%;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;----------------=================************&$=,>>>>           ",
"            >>>>>'$%;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-----------------=================*************&$=,>>>>           ",
"            >>>>>'$%;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;------------------==================**************&$=,>>>>           ",
"            >>>>>'$%;;;;;;;;;;;;;;;;;;;;;;>',;;;;;>''''''''''';-----'''''''''''>=====>'',,,,,,,,,*****=,,;=*&&$=,>>>>           ",
"            >>>>>,$%;;;;;;;;;;;;;;;;;;;;>)!!);;;;;,!!!!!!!!!!!;-----!!!!!!!!!!!,====='!!!!!!!!!!!*****-!!!!>*&$*,>>>>           ",
"            >>>>>,$%;;;;;;;;;;;;;;;;;;;;!!!!);;---,!!!!!!!!!!!;-----!!!!!!!!!!!,=====,!!!!!!!!!!!*****-!!!!!,&$*,>>>>           ",
"            >>>>>,$%--;;;;;;;;;;;;;;;;;'!!!,;-----;>>>>>>>;;;;------;;;;;;;;;;;-=====-;----------******--,!!!=$*,>>>>           ",
"            >>>>>,$%-------------------!!!;----------------------======================****************&&&>!!>$*>>>>>           ",
"            >>>>>,$%------------------;!!)--------------------=======================****************&&&&&=!!'$*>>>>>           ",
"            >>>>>,$%------------------>!!'----------------=========================*****************&&&&&&&!!)$*>>>>>           ",
"            >>>>>,$%------------------>!!'-----------============================*****************&&&&&&&&&!!)$*>>>>>           ",
"            >>>>>,$%------------------;''>-----===============================******************&&&&&&&&&&&!!)$*>>>>>           ",
"            >>>>>,$%====-------------======================================*******************&&&&&&&&&&&&&>>;$*>>>>>           ",
"            >>>>>,$%====================================================********************&&&&&&&&&&&&&&&&&%$*>>>>>           ",
"            >>>>>>$%=================================================*********************&&&&&&&&&&&&&&&&&&%$$*>>>>>           ",
"            >>>>>>$%==============================================**********************&&&&&&&&&&&&&&&&&&%%$$$*>>>>>           ",
"            >>>>>>$%========================================*************************&&&&&&&&&&&&&&&&&&&%%%$$$$*>>>>>           ",
"            >>>>>>$%==================-,,;==============***************************&&&&&&&&&&&&&&&&&&&%%%%$$$$$*>>>>>           ",
"            >>>>>>$%==================;!!,=======***********&&&&&&&&&&&&********&&&&&&&&&&&&&&&&&&&&%%%%%$$>>;$*>>>>>           ",
"            >>>>>>$%***===============;!!,***************&&*;'-&&*!!!!!!!***>!!!!!!>&&&!!!!!!!&&&;!,=%%%$$$!!)$*>>>>>           ",
"            >>>>>>$%******************;!!,**************&&&>!!-&&*'''''''&&&;'''''';&&&'''''''&&%-)!!*%$$$$!!)$*>>>>>           ",
"            >>>>>>$%******************-!!,**************&&&!!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&%%%%%%-!;$$$$$!!)$*>>>>>           ",
"            >>>>>>$%******************-!!,*************&&&=!>&&&&&&&&&&%%%&&&&&&&&&&&&&&&&%%%%%%%%%%!)$$$$$!!)$*>>>>>           ",
"            >>>>>>$$******************-!!,*************&&&=);&&&&%%%%%%%%%%&&&&&&&&&&&&%%%%%%%%%%%%$))$$$$$!!)$*>>>>>           ",
"            >>>>>>$$******************-!!,**********&&&%%%%%%%%%%%%%%%%%%%%&&&&&&&&&%%%%%%%%%%%%%$$$;;$$$$$!!)$*>>>>>           ",
"            >>>>>>$$******************-!!,&&&&&&&&&&&&&%%%%%%%%%%%%%%%%%%%%&&&&&&%%%%%%%%%%%%%%$$$$$$$$$$$$!!)$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&-!!,&&&&&&&&&&&&%%%%%%%%%%%%%%%%%%%%%%&%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$!!)$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&-!!,&&&&&&&&&&&&%%%%*,=%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$$$!!)$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&-!!,&&&&&&&&&&&%%%%%=!;%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$,,$$$$$!!)$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&%%%%%=!;%%%%%%%%$$$$$$$%%%%%%%%%%%$$$$$$$$$$$$$))$$$$$!!)$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&%%%%%*!;$$$$$$$$$$$$$$$%%%%%%%%$$$$$$$$$$$$$$$$))$$$$$$$$$*>>>>>           ",
"            >>>>>>$$&&&&&&&&&&&&&&&&&&&&&&&&&&%%%%%%%%$$$$*!;$$$$$$$$$$$$$$$%%%%%$$$$$$$$$$$$$$$$$$$))$$$$$$$$$*>>>>>           ",
"            >>>>>>$$%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$*!;$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$))$$$$$$$$$*>>>>>           ",
"            >>>>>>$$%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$*!;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$))$$$$$$$$$*>>>>>           ",
"            >>>>>>$$%%%%%%%%%%%%%%%%%%%&&&%%%%%%%%%%%%$$$$%=&$$$$$$$$$$#####$$$$$$$$$$$$$$$$$$$$$$$$))$$$$$$$$$*>>>>>           ",
"            >>>>>>$$$$$$$%%%%%%%%%%%%%=!!>%%%%%%%%%%%%$$$$$$$$$$$##########$$$$$$$$$$$$$$$$$$$$$$$$$&&$$$$$&&&$*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$%%%%%%=!!>%%%%%%%%%%%%%$$##################$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$!!)$*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$####$$#############$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$#$!!)#*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$##&!-#############$$$$$$$$$$$$$$$$$$$$$$$###&&####$!!)#*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$##&!-############$$$$$$$$$$$$$$$$###########))####$!!)#*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$$#&!-############$$$$$$$$$##################))#####!!)#*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$$#&!-###########$$$$########################))#####!!)#*>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$$$*!-#######################################))#####!!)#&>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$$$*!-#######################################))#####!!)@&>>>>>           ",
"            >>>>>>$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$$$&)=#####################################@@))@@@@#!!)@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$$$$*!!>$$$$$$$$$$$$$$##################################@@@@@@@@@@>>@@@@#!!)@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$$$$%--*$$$$$$$$$##########@@@@@@@@###############@@@@@@@@@@@@@@@@@@@@@@#!!)@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$$$$$$$$$$$$$##########@@@@@@@@@@@@@@@@@@@@#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@==*@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$$$$$$$$$#########@##@@@%;&@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$$$$$###########@@@@@@@@&!-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@;;@@@@@@@@@&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$$$$###########@@#@@@@@@@@@&!-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@))@@+++++++&>>>>>           ",
"            >>>>>,$$$$$$$$$$$$$$#############@@@@@@@@@@@@@%!;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@++++@!'+++++++++&>>>>>           ",
"            >>>>>,$$$$$$$$$$$#########&,,-@#@@@@@@@@@@@@@@@)!%@@@@@@@@@@@@@@@@@@@+++++++++++++++++@-!=+++++++++&>>>>>           ",
"            >>>>>,$$$$$$$#############&!!>@@@@@@@@@@@@@@@@@-!!&@@@@@@@@@@@+@+++++++++++++++++++++-!!!#+++++''>+&,>>>>           ",
"            >>>>>,$$$$################&!!>@@@@@@@@@@@@@@@@@@%>%@@@@@@@@++++++++++++++++++++++++++='=@++++++!!)+&,>>>>           ",
"            >>>>>'$##################@&!!;@@@@@@@@@@@@@@@@@@@@@@@@@@@++++++++++++++++++++++++++++++++++++++!!)+&,>>>>           ",
"            >>>>>'$#################@@&!!>@@@@@@@@@@@@@@@@@@@@@++++++++++++++++++++++++++++++++++++++++++++!!).&,>>>>           ",
"            >>>>>'$###############@@@@%!!'@@@@@@@@@@@@@@@@@@@+++++++++++++++++++++++++++++++++++..........$!!,.&,>>>>           ",
"            >>>>>'$##############@@@@@@!!!&@@@@@@@@@@@@++++++++++++++++++++++++++++++++...................;!!-.&,>>>>           ",
"            >>>>>'#############@@@@@@@@-!!!;*@@@@@$===========#+++++*==********%+++..%***********.....+*=,!!!#.&,>>>>           ",
"            >>>>>'##########@@@@@@@@@@@@'!!!'@@@@+*!!!!!!!!!!!%+++++!!!!!!!!!!!;.....-!!!!!!!!!!!+....#!!!!!=..&,>>>>           ",
"            >>>>>'%######@@@@@@@@@@@@@@@#>!!'@@@++*!!!!!!!!!!!%+++++!!!!!!!!!!!;.....-!!!!!!!!!!!.....#!!!!&...=,>>>>           ",
"            >>>>>,-####@@@@@@@@@@@@@@@@@@@$**+++++$===========@+++++===========%.....%========***.....+**%+...+,,>>>>           ",
"            >>>>>,'=#@@@@@@@@@@@@@@@@@@@@@+++++++++++++++++++++++++..........................................@>'>>>>>           ",
"            >>>>>>,''>>>>>>>;;;;;;;;;;;;;;;;-------------------------------------------------;;;;;;;;;;;;;;;,',>>>>>>           ",
"            >>>>>>>>,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,'''''''''''''''''''''''''''''',,,,,,,,,,,,,,,,,,,,,,,,,,,,,,>>>>>>>           ",
"            >>>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''',,,,,,,,,,,,,>>>>>>>>>>           ",
"            >>>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''',,,,,,,,,,,,;')>>>>>>>>           ",
"            >>>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''',>',,>>,>,>,>),,>>>>>>>           ",
"            >>>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''','!,,!),,!,,>-;)>>>>>>>           ",
"             >>>>>>>>>>,,,,,,,,,,,,,,'''''''''''''))))))))))))))))))))))))))))))'''''''''''''',>>,,>,,>>,,,'),>>>>>>>           ",
"             -;>>>>>>>>>>>,,,,,,,,,,,,,,''''''''''''''))))))))))))))))))))))'''''''''''''',,,,,,,,,,,,,,>>>>>>>>>>>;*           ",
"              =---------------;;;;;;;;;;;;;;;;;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>;;;;;;;;;;;;;;;;;;;---------------*            ",
"                                                          -;>>>,,,>>>;;>                                                        ",
"                                                          &=-;;>,>>;;-==                                                        ",
"                                                          &=;>>,',,;;;==                                                        ",
"                                                         %=->>,')',>>;-=                                                        ",
"                                                         &;;,,,'))',,>;-                                                        ",
"                                                        **'>,,,'))',,>;-=*                                                      ",
"                                                 ->,'))))-''',,'))',,>;;>)))',>-*                                               ",
"                                            =;>,))''''''';))',,'))',,>;;;,'''''''',>-                                           ",
"                                         ;,'''''',,,,,>>>-!)),,'))',,>>;;>>>>,,,,,'''',>                                        ",
"                                       >''',,,,,>>>>>>;;;=)!!),'))',,>>;;;;;;;>>>>>,,,,,',;                                     ",
"                                     >')!,,,,>>>>;;;;;;;;;-)!)''))',,>>;;;;;;;;;;;>>>>>,,!'>=                                   ",
"                                    ,'!!'>>>>>>>>>>>>>>>>>;>')))))',,>;;>>>>>>>>>>>>>>>>>)!),;                                  ",
"                                   >))))'>>>,,,,,,,,,,,,,,>;;>,')',>;;;>,,,,,,,,,,,,,,,,>)))),;                                 ",
"                                  >,))))),,,,,''''''''))))',>;;-----;>>'))))))'''''''',,')))))>=                                ",
"                                 =>'))))))''''''))))))))))',>>;;---;;>>'))))))))))))'''')))))),;                                ",
"                                 ;>'))))))))))))))))))))))'>>;;----;;;>''')))))))))))))))))))),-                                ",
"                                 =;,')))))))))))))))))'''',>;;;-----;;>,'''''')))))!!!)))))))',=                                ",
"                                  -;'')))))))!!)))))''''',,>;;-------;;,,,,''''')))))!!)))))),*=                                ",
"                                  *=-,))))))!))))))''''',,,>;;------;;;,,,,''''')))))))!))));**                                 ",
"                                   *=*-'))))))))))'''''',,,>;;;;;--;;;>,,,,,'''''')))))))),=&&                                  ",
"                                     *&&=>)))))))))'''''''',>>;;;;;;>>,,'''''''''))))))'>=**&                                   ",
"                                      &&&&*->,)))))))))'''',,>>>>>>>>,'''''''))))))',>;=***%                                    ",
"                                        %&**==-;>,'))))))))'',,,,,,,,,'))))))')'',,>;;-=*                                       ",
"                                           &=--;>>,')))))''',,,,,,,,,,''''))))))',,>;=*                                         ",
"                                               *->,')))))''',,>>>>>>,,'''))))))',;                                              ",
"                                                    ;>>,,,,,,,>>>>>>,,,,,,,>>;                                                  ",
"                                                                &&                                                              ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                "};


/* XPM */
static char * System_Preferences_icon_xpm[] = {
"100 100 17 1",
" 	c None",
".	c #060905",
"+	c #1A1B1A",
"@	c #282A28",
"#	c #373939",
"$	c #434543",
"%	c #545653",
"&	c #646563",
"*	c #737572",
"=	c #838582",
"-	c #939592",
";	c #A2A4A1",
">	c #B5B7B4",
",	c #C6C8C5",
"'	c #D7D9D5",
")	c #E6E8E5",
"!	c #F7F9F6",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"       -=---=-=-==--=-----=------------------=--==-===--=====================================       ",
"     -)))))))))))))))))))))))))))))))))))))))))))))))))))))))))'))''''''''''''''''''''''''''',-     ",
"    =))))))))))))))))))))))))))))))))))))))))))))))))))))))'))))'''''''''''''''''''''''''''''',=    ",
"    >)')))))))))))))))))))))))))))))))))))))))))))))))))))))))''')'''''''''''''''''''''''''''''>    ",
"    ,))))))))))))))))))))))))))))))))))))))))))))))))))))))))'''''''''''''''''''''''''''''''','>    ",
"    ,'))))))))))))))))))))))))))))))))))))))))))))))))))))))''))'''''''''''''''''''''''''''''''>    ",
"    ,')))))!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!))))))))))))))))))))))))))))''''''>    ",
"    ,'')))).++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.''',',>    ",
"    ,''))))+##@$$$$$@#$$$$#@$$$$$@#$$$$#@$$$$$@#$$$$#@$$$$$@#$$$$#@$$$$$@#$$$$$@$$$$$@##+''''''>    ",
"    ,'''))'@%@#&&&&%#%&&&&$#%&&&%#$&&&&##%&&&&#%&&&&%#%&&&%##&&&&%#%&&&%#$&&&&&#%&&&&#@%@''',,,>    ",
"    ,''')))#*->*****>******>*****>=****=>****&-******-&****>-*****>*****>=*****>*****>;&#''',,,>    ",
"    >)'')')#=====*=====*======*=====*======*'''*=*==*'''*=====*======*=====**=====*====*#,,,,',>    ",
"    ,''''')+----=%=----%%----*%=----%%-----$)))!-%%-!)))%=----$%-----%-----%%-----%=---=@,,,'',>    ",
"    ,''''''*-;;;>,;;;;;,';;;;,,;;;->!!!-;;;>!!!!-,'-!!!!--;;-!)!>;;;;,;;;;;'';;;;;,-;;;-&,,,,,,>    ",
"    ,''''''$-;;;;;;;;;;;;;;;;;;;;--)!!!=-;--!!!!---=!!!!*-;--)))!--;;;;;;;;;;;;;;;;;;;;-$',,,,,>    ",
"    >''''''$-%%-----%=----=%-----%*!!!!!%--*!!!!*---!!!!*--%!))))=%-----%*----=%-----%%=$,,,,,,>    ",
"    >''''')$-;=-----=>----;*-----*-,!!!!&==*!!!!!,,!!!!!*===))))=;*-----*;---->*------;=$,,,,,,>    ",
"    >''''''$=--------------->!!=--=*!!!!!&)!!!!!!!!!!!!!!)&!)))'*=--=!';---------------=$,,,,',>    ",
"    >''''''#=---*$=----$*-=)!!!!===*)!!!!!!!!!!!!!!!!!!!)))))''!*===!''',=-%&----*$=---=+,,,,,,>    ",
"    >''''''$====-#-====$-==&!!!!!***!!!!!!!!!!!!!!!!!!!)))))''')***!''''*==*=====;#;===*@,,,,,,>    ",
"    >''''''$===============*)!!!!!&!!!!!!!!!)')'',,,')'))))'''''!&!'''')*==============*$,,,,,,>    ",
"    >''''''#*&%=====%*====&$%!!!!!!!!!!!!'';=&%%%%%%%%*))))'''''''',',,%$&====*$=====%&*#,,,,,,>    ",
"    ,''''''#*$#*===*#******$&'!!!!!!!!)'-*%%&&$&&&&&&$%))'''')'',',',,)&$&*****#*====##*#,,,,,,>    ",
"    >''''''#**;*****;&)!!&&-&$!!!!!!!'=%%%&&&&-&****&=*)))'''-'',,,,,,%&-&&!')&;*****-**#,,,,,,>    ",
"    >''''''@*****%***)!!!!%&%!!!!!!'-$%%&&&%*****%&**&))''''=%&>',,,,,!%&=''''!***%****&@,,,,,,>    ",
"    >''''''.&***%@%*&'!!!!!!!!!!!!,*$#%&&&&@%****@@**&))''',$%#$*,,,,,'!!,'''''&*&@%***&.,,,,,,>    ",
"    >''''''&&***;-&*&$!!!!!!!!!!';$%*-&&**=-&****;,*&$)'''')%%**$%>),,,,,,'','%&*=-&***&%,,,,,,>    ",
"    >''''''+%&&&&&&&%%@)!!!!!!!'*#$%&&&&%&&&&&%&&&&&%!)'',,%%&&&%$#=',,'',,,)#%%&&&&&&&$+,,,,,,>    ",
"    >''''''+#..$*&&%@$$@'!!!!!'&#@#&&&&@@%&&&&@$&&&&$'''',,@@&&&&#@#=',,,,,'#$$@%&&*$..#+,,,,,,;    ",
"    >''''''+#=&####$*=$#+))))))@#&;&&&&>=&&&&&=>&&&%%)'',,'%=&&&&;&$@=,,,,,@#$**####$&*#+,,,,,,>    ",
"    >''''''+#$$##)!,.@+.))))))))@%%&&&&&&&&&&&&%%%%%))'',,%$%&&&&&%%$@=',,,!.+@.,!>##$$#+,,,,,,>    ",
"    >''''''.#$$#.'''''&$'''''')))>%%+#&&&&#+$%%$#++@))',,>#$%&+#&&&%#+.=-;;>.,',,,>.#$$#.,,,,,,;    ",
"    >',''''+####,''''''''''''''''')+.$$$%%&.$!)))))))'',,'#$$$.%####%.+#;;>>>>,>>>>*####.,,,,,>>    ",
"    >'','''+####.;''''''''''''''''''.@###@%'''''''''',>;;,+@#########@+.%>>>,>>>>>>+####+,,,,,,>    ",
"    >',,','+#..#+.;'''''''-@,''''''''$@..'''''''''''',>;--)..####+.$##@.+;>>>>>>>>.+#..#+>,,>>>;    ",
"    >',,,,'+#..@+...-'''',#..;''''''''!.''''''''''''',>;--=-.####@.@###..%>>>>;>...+#..#+>,,,>,>    ",
"    >,',,,'+##@#@+...>,,,=....&''''''''''''''''''''',,;;--=---####@####@.+=;;;,...+@#@##+>>>>>>;    ",
"    >,,,,,'.####@.+..>>,>#..+...;''''''''''''''''''',>;;-=-===.+####$.#@+.%>;;-..+.#####.>>,>>>;    ",
"    >,,,,,,.##++$@...>>>;+.+@....>'''''''''''''''''',>;---=-==>.####@.@#+.@;;--...@#++##.,>>,>>;    ",
"    >,,,,',$##>-;;;;;;;;%.+@##*+..@,,,,,,,,,,,,,,,,,>>;---==--;-#####,##@+.&--====--->##&>,,>>>;    ",
"    >,,,,,,+#@;---;--;;;#.+@##@@+...,,,,,,,,,,,,,,,,>>--==----;;@#@#####@+.%-=--------@#+>>>>>>;    ",
"    >,,,,,,+#.-=-------;@...@###+..=,,,,,,,,,,,>=$#-;>--==--;;;;%..@###@...#;--=---=--.#+>>>>>>>    ",
"    >,,,,,,+#$+;;====--;+.&%####@##;>,,,,,,,,,*%&*&$@=------;;-=;*%#####%%.@;===--=;=+$#+>>>>>>;    ",
"    >,,,,,,+#@....*>=-==.+@#######+;>>,,,,,,,-&=;;-&%@;--;----===+@@@@@@@+.+====;%....@#+>>>>>>>    ",
"    >,,,,,,.#@+....%===%.+@##+.@###-;;>>>,>>-&->>;-=&%#-;--======;,,,,,,,,,,-=-=.....+@#.>>>>>>;    ",
"    >,,,,,,@##@+@..-==*$++###*@###;--;;;;;>>&*;>'>>'*&$%-=======================$+.@+@##+>>>>>>;    ",
"    >,,,,,,$-,+++..>***#++#######@>------;;;+&-%>>;-$&%+---===============*====*>..++@>-$>>>>>>;    ",
"    >,,,,,,%;>>;&*=****#++..#####.>====-=--;+%*@=;>;@*%@;;----=====***===***=*******;;>;%>>>>>>;    ",
"    >,,,,,,%;>;-****-**#++#.#####.>*======--@%&$*;>>&-&#;;-----===========**=******&-->-%>>>>>>;    ",
"    >,,,,,,%;;;-&&**,,'$++#######@%**=**===->%&&+-;$>;*>>;;----=-========****;>,-&&&-=;-%>>>>>>;    ",
"    >,,,,,,%-;;=$%$,,,>,++###@.##@.*=**=*===;+%&=-;;;-%,;;;;;;;--...........-,,,,-%%**;-%>>>>>>;    ",
"    >>,,,,,$-;*-++=,,';>+.###+.+#@+=***==*===,#%*-;;-*,;;;;;;;;;-..........+*,',,,++.*;-$;>>>>>;    ",
"    >,>>,>,$-;-*.@,,,',%@+@##@-##@+-**=*****=-'!#*=&)';;;;;;;;;;*..++#++..$@&;',,,=..&;-$>>>>>>;    ",
"    >>>,,>,$-;;>->,,''-$@$+*,-###.+.==*=****==--))))-;;;;;;;;;;;.+.@@@.>,.@#%;;',,,-;;;-$>>>>>;;    ",
"    ;>>>>>>$-;;>>,,,';=#@@>)))'#@..-*******&*==-;;;;;;;;;;;;;;;=...+#+,))>+#%@;'',,>>;;-$;>>>>>;    ",
"    >>,>,>>$-;>>>,,'''.#%>)))!'#@*****&&*&*&*==-;;;;;;;;;;;;;;-.+&*##+'))),%$#-'',,>>>;-$;>>>>;;    ",
"    ;>>>>,>$-;>>,,'''),>>)))!;@+;***&&%&&****==---------------..+#####)!)));$))''',,>>;-$;>>>;>;    ",
"    >>>>>>>$-;>>,,'')))))))!!>.****&&&&&*&&*&==--------------*..@###+..!!!))!)))''',,>>-$;>>>>;;    ",
"    ;>>>>>>%;>>,,''))))))!!!;%%&&&&&&&*=%&&**==-------------*..@####*.$)!!!))))))'',,>>-%>;;;>>;    ",
"    ;>>>>>>@!>,,''))))))!!!!@#%%%%!*%*..*&&**==------------*..+@@!=##@@.;!!!!)))))'',,>'&;>;;;;;    ",
"    ;>>>>>>...+!')))))!!!!!)'#$@'))'&....+*&&===---------=...+@#!))>%@+@)!!!!!)))))'';...;;;;;;;    ",
"    ;>>>>>>.+++..))))!!!!!!!)>'!))''!.......**============..+@#$'''))>*'!!!!!!!!))!..+++.;;>;;;;    ",
"    ;>>>>>>.@@@+++.!!!!!!!!!!!))''''.++++......&****======.+@###>'''))!!!!!!!!!!!..+++@@.;;;;;;;    ",
"    ;>>>>>>.@@@@@+++*!!!!!!!)))''''...@@@+..........*=====.@##..@,''''))!!!!!!!!.++@@@@@.;;;;;;;    ",
"    ;>>>>>;+#####@@++$!!!!!)))''''...+###@+..........======@#$..@+>''''))!!!!!!++@@####@+;;;;;;-    ",
"    ;>>>>>>+#######@@+.!!!))'''',..+%@####@=++++.@+..======@##-#@+.,,''')))!!!+@@#######+;;;;;;;    ",
"    ;>>;>;;+##$$$$$##@+.!))''',,)+.+@&'$+####@.@++++.*=====.@)*++.@','''')))!+@###$$$$##+;-;;;--    ",
"    ;;;;;;;+#$$$$$$$$#@+=)'',,,,>'%;>),'.@####.+###@.+======!,),;;&'>,,''''!+@#$$$$$$$$#+;;;-;;;    ",
"    ;;;;;;;+$$$$$$$$$$#@+!',,,>>>''>;;;;&####$&;$###$+=====*;;;;>,!>>,,,,''+@#$$$$$$$$$#+--;-;;-    ",
"    ;;;;;;;+#$$$$$$$$$$#@+>>>;;;;;----=='##@########@.%*****-=-----;;;;;>>.@#$$$$$$$$$$#+-------    ",
"    -;;;;;;+#$$$$$$$$$$#@+.----=====*=*=%....@###..#@+&&&&&&=*=*=====----;+@#$$$$$$$$$$#+-------    ",
"    ;;;;;;;+############@@+=**&&&&&&&*%+@#$%@.+++@@+...%%%%%$@*&&&&&&&&**++@###########@.-------    ",
"    -;;;;-;.++++++++++++++..#########..+@++++@@@@@@@@@+@@@@@@+++$########.++++++++++++++.=------    ",
"    ;-;;-;-;---;;;-;;;;--;;;----;;--;;;--;;--;-----;----------------------=----------=-----=----    ",
"    -;-;-;;---;-;;;--;;;;;;;;;;;;;-;;;-;;-;-;;;;;------;-;---;-----------------=----=----=----=-    ",
"    -----------;-------;;;-;;;;-;---;;--;----;----;-;-----------------------------=--=---=======    ",
"    ------------;-----;--------------;;;----------;---------------------------=----==--==-======    ",
"    $=---------------------;------------------------------------=----------=---=======-=======*$    ",
"     &=---------------------------------------------------------=-=----======================*%     ",
"      .%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$%%%%%%%$%%$%%$%$%$%%%%%$%$$$$$$$%$$$$%.      ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    ",
"                                                                                                    "};


/* variables temporaires */
static gint TmpPageWidth;
static gint TmpPageHeight;
static gint TmpPageMargins;
static GdkColor TmpPgeColor;
static gint TmpMovieFreq;
static gint TmpMovieFootage;
static gboolean TmpBiblioAutosave;
static gint TmpZoom=0;
static gchar *TmpLayerName;
static gint TmpAlignZone=1;/* selection */
static gint TmpAlignHoriz=0;/* no change */
static gint TmpAlignVerti=0;/* no change */
/**** fonctions ****/

GtkWidget*
create_dialogAskBeforeNew (void)
{
  GtkWidget *dialogAskBeforeNew;
  GtkWidget *dialog_vbox4;
  GtkWidget *vbox8;
  GtkWidget *hbox12;
  GtkWidget *image6;
  GtkWidget *label18;
  GtkWidget *label20;
  GtkWidget *label19;
  GtkWidget *dialog_action_area4;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;

  dialogAskBeforeNew = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogAskBeforeNew), "Attention !");
  gtk_window_set_position (GTK_WINDOW (dialogAskBeforeNew), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogAskBeforeNew), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogAskBeforeNew), "gtk-dialog-warning");
  gtk_window_set_type_hint (GTK_WINDOW (dialogAskBeforeNew), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox4 = GTK_DIALOG (dialogAskBeforeNew)->vbox;
  gtk_widget_show (dialog_vbox4);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), vbox8, TRUE, TRUE, 0);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox12, FALSE, FALSE, 0);

  image6 = gtk_image_new_from_icon_name ("gtk-dialog-warning", GTK_ICON_SIZE_DIALOG);
  gtk_widget_show (image6);
  gtk_box_pack_start (GTK_BOX (hbox12), image6, TRUE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (image6), 0, 0.5);

  label18 = gtk_label_new ( gettext("Attention !"));
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox12), label18, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label18), 0.9, 0.9);

  label20 = gtk_label_new ("                                                     ");
  gtk_widget_show (label20);
  gtk_box_pack_start (GTK_BOX (hbox12), label20, FALSE, FALSE, 0);

  label19 = gtk_label_new ( gettext("Your work isn't saved !\nWhat do you want ?"));
  gtk_widget_show (label19);
  gtk_box_pack_start (GTK_BOX (vbox8), label19, FALSE, FALSE, 0);

  dialog_action_area4 = GTK_DIALOG (dialogAskBeforeNew)->action_area;
  gtk_widget_show (dialog_action_area4);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area4), GTK_BUTTONBOX_END);

  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAskBeforeNew), button1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  button2 = gtk_button_new_from_stock ("gtk-clear");
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAskBeforeNew), button2, GTK_RESPONSE_REJECT);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);

  button3 = gtk_button_new_from_stock ("gtk-save");
  gtk_widget_show (button3);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAskBeforeNew), button3, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);

  return dialogAskBeforeNew;
}
/*******************************
 * fonctions pour choisir
 * la taille du canevas
 * ****************************/

void
on_entryPageWidth_activate             (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text = (gchar *)gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=550;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"550");
	}
  TmpPageWidth=valeur;	
}


void
on_entryPageHeight_activate            (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text = (gchar *) gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=440;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"440");
	}
  TmpPageHeight=valeur;	
}


void
on_entryPageMargins_activate           (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text =(gchar *)gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=80;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"80");
	}
  TmpPageMargins=valeur;	
}
/**** fonctions pour lire les choix temporaires ****/
gint dlg_get_page_width(void)
{
  return TmpPageWidth;
}
gint dlg_get_page_height(void)
{
  return TmpPageHeight;
}
gint dlg_get_page_margins(void)
{
  return TmpPageMargins;
}



GtkWidget*
create_dialogPageSize (gint w,gint h,gint m)
{
  GtkWidget *dialogPageSize;
  GtkWidget *dialog_vbox6;
  GtkWidget *vbox10;
  GtkWidget *hbox17;
  GtkWidget *label35;
  GtkWidget *label29;
  GtkWidget *entryPageWidth;
  GtkWidget *label31;
  GtkWidget *hbox18;
  GtkWidget *image7;
  GtkWidget *label36;
  GtkWidget *label30;
  GtkWidget *entryPageHeight;
  GtkWidget *label32;
  GtkWidget *hbox19;
  GtkWidget *label37;
  GtkWidget *label33;
  GtkWidget *entryPageMargins;
  GtkWidget *label34;
  GtkWidget *dialog_action_area6;
  GtkWidget *cancelbutton5;
  GtkWidget *okbutton5;
  GtkTooltips *tooltips;
  GdkPixbuf *pb;
  gchar *str;
  
  /* passage vars tempos */
  TmpPageWidth=w;
  TmpPageHeight=h;
  TmpPageMargins=m;
  /* création image */
  pb = gdk_pixbuf_new_from_xpm_data((const char **)ecran_xpm); /* transtypage obligatoire */
  tooltips = gtk_tooltips_new ();

  dialogPageSize = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogPageSize),  gettext("Siez of animation's scene"));
  gtk_window_set_position (GTK_WINDOW (dialogPageSize), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogPageSize), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogPageSize), "gtk-fullscreen");
  gtk_window_set_type_hint (GTK_WINDOW (dialogPageSize), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox6 = GTK_DIALOG (dialogPageSize)->vbox;
  gtk_widget_show (dialog_vbox6);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (dialog_vbox6), vbox10, TRUE, TRUE, 0);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox17, TRUE, TRUE, 0);

  label35 = gtk_label_new ("          ");
  gtk_widget_show (label35);
  gtk_box_pack_start (GTK_BOX (hbox17), label35, FALSE, FALSE, 0);

  label29 = gtk_label_new ("Largeur :");
  gtk_widget_show (label29);
  gtk_box_pack_start (GTK_BOX (hbox17), label29, FALSE, FALSE, 0);

  entryPageWidth = gtk_entry_new ();
  gtk_widget_show (entryPageWidth);
  gtk_box_pack_start (GTK_BOX (hbox17), entryPageWidth, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryPageWidth,
      gettext( "Type here the max width of the drawing area for your project"), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryPageWidth), -1);
  str=g_strdup_printf("%d",w);
  gtk_entry_set_text (GTK_ENTRY (entryPageWidth), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryPageWidth), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryPageWidth), 5);

  label31 = gtk_label_new ( gettext("pixels"));
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (hbox17), label31, FALSE, FALSE, 0);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox18, TRUE, TRUE, 0);

  image7 = gtk_image_new_from_pixbuf (pb);
  g_object_unref(pb);
  gtk_widget_show (image7);
  gtk_box_pack_start (GTK_BOX (hbox18), image7, TRUE, TRUE, 0);

  label36 = gtk_label_new ("          ");
  gtk_widget_show (label36);
  gtk_box_pack_start (GTK_BOX (hbox18), label36, FALSE, FALSE, 0);

  label30 = gtk_label_new ( gettext("Height :"));
  gtk_widget_show (label30);
  gtk_box_pack_start (GTK_BOX (hbox18), label30, FALSE, FALSE, 0);

  entryPageHeight = gtk_entry_new ();
  gtk_widget_show (entryPageHeight);
  gtk_box_pack_start (GTK_BOX (hbox18), entryPageHeight, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryPageHeight,
     gettext( "Type here the max height of the drawing area for your project"), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryPageHeight), -1);
  str=g_strdup_printf("%d",h);
  gtk_entry_set_text (GTK_ENTRY (entryPageHeight), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryPageHeight), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryPageHeight), 5);

  label32 = gtk_label_new ( gettext("pixels"));
  gtk_widget_show (label32);
  gtk_box_pack_start (GTK_BOX (hbox18), label32, FALSE, FALSE, 0);

  hbox19 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox19);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox19, TRUE, TRUE, 0);

  label37 = gtk_label_new ("          ");
  gtk_widget_show (label37);
  gtk_box_pack_start (GTK_BOX (hbox19), label37, FALSE, FALSE, 0);

  label33 = gtk_label_new ( gettext("Margins :"));
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (hbox19), label33, FALSE, FALSE, 0);

  entryPageMargins = gtk_entry_new ();
  gtk_widget_show (entryPageMargins);
  gtk_box_pack_start (GTK_BOX (hbox19), entryPageMargins, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryPageMargins, 
   gettext("Type here the 'margins' of the drawing area. This margins acts as 'backstages' in order to hide some objects before their appearing")
   , NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryPageMargins), -1);
  str=g_strdup_printf("%d",m);
  gtk_entry_set_text (GTK_ENTRY (entryPageMargins), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryPageMargins), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryPageMargins), 4);

  label34 = gtk_label_new ( gettext("pixels"));
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (hbox19), label34, FALSE, FALSE, 0);

  dialog_action_area6 = GTK_DIALOG (dialogPageSize)->action_area;
  gtk_widget_show (dialog_action_area6);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area6), GTK_BUTTONBOX_END);

  cancelbutton5 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton5);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogPageSize), cancelbutton5, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton5, GTK_CAN_DEFAULT);

  okbutton5 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton5);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogPageSize), okbutton5, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton5, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) entryPageWidth, "changed",
                    G_CALLBACK (on_entryPageWidth_activate),
                    NULL);
  g_signal_connect ((gpointer) entryPageHeight, "changed",
                    G_CALLBACK (on_entryPageHeight_activate),
                    NULL);
  g_signal_connect ((gpointer) entryPageMargins, "changed",
                    G_CALLBACK (on_entryPageMargins_activate),
                    NULL); 
  return dialogPageSize;
}
/************************************
 * préférences
 * *********************************/
void
on_buttonDefautPageColor_clicked       (GtkButton       *button,
                                        GtkWidget *win)
{
	gdouble couleur[4]; /* tableau temporaire pour les composantes */
	GtkColorSelectionDialog *dialog_couleur;
    gint reponse;
    cairo_t *cr; 
	
    cr = gdk_cairo_create(win->window);
    dialog_couleur = (GtkColorSelectionDialog*)gtk_color_selection_dialog_new( gettext("Choice of the page's default color ..."));
    gtk_widget_hide(dialog_couleur->help_button);
    reponse = gtk_dialog_run(GTK_DIALOG(dialog_couleur));
    if (reponse==GTK_RESPONSE_OK)
          {
              /* récupérer la couleur choisie  */
              gtk_color_selection_get_color(GTK_COLOR_SELECTION (dialog_couleur->colorsel),couleur);   
              TmpPgeColor.red=(guint16)(couleur[0]*65535);
              TmpPgeColor.green=(guint16)(couleur[1]*65535);          
              TmpPgeColor.blue=(guint16)(couleur[2]*65535);    
			  /* réafficher la preview */
			  cairo_set_source_rgb(cr,(gdouble)(TmpPgeColor.red/65535.0),
                         (gdouble)(TmpPgeColor.green/65535.0),
						 (gdouble)(TmpPgeColor.blue/65535.0));
			  cairo_rectangle(cr,0,0,32,32);
			  cairo_fill(cr);
			  cairo_set_source_rgb(cr,0,0,0);
              cairo_rectangle(cr,0,0,32,32);
              cairo_stroke(cr);
			  cairo_destroy(cr);        	             
          }
    gtk_widget_destroy(GTK_WIDGET(dialog_couleur));
}


void
on_spinbuttonDefaultFPS_changed        (GtkWidget *spb,
                                        gpointer         user_data)
{
  gint valeur;
  
  TmpMovieFreq= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spb));
}


void
on_entryWidth_changed                  (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text =(gchar *)gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
 // printf("width chan gée \n");
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=550;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"550");
	}
  TmpPageWidth=valeur;	
}


void
on_entryHeight_changed                 (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text =(gchar *) gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=440;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"440");
	}
  TmpPageHeight=valeur;	
}


void
on_entryMargins_changed                (GtkEntry        *entry,
                                        gpointer         user_data)
{
  gchar *entry_text;
  gint valeur;
  
  entry_text = (gchar *)gtk_entry_get_text(GTK_ENTRY(entry));
  
  /* tester validité */
  valeur=atoi(entry_text);
  if ((valeur==0)||(valeur<0))
    {
		/* problème */
		printf("valeur erronée ! \n");
		valeur=80;/* par défaut*/
		/* modifier affichage */
		gtk_entry_set_text(entry,"80");
	}
  TmpPageMargins=valeur;
}


gboolean
on_drawingareaPageDefaultColor_expose_event
                                        (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                       GtkWidget *win)
{
 cairo_t *cr; 
 cr = gdk_cairo_create(win->window);
 
 cairo_set_source_rgb(cr,(gdouble)(TmpPgeColor.red/65535.0),
                         (gdouble)(TmpPgeColor.green/65535.0),
						 (gdouble)(TmpPgeColor.blue/65535.0));
 cairo_rectangle(cr,0,0,32,32);
 cairo_fill(cr);
 cairo_set_source_rgb(cr,0,0,0);
 cairo_rectangle(cr,0,0,32,32);
 cairo_stroke(cr);
 cairo_destroy(cr); 	
 return FALSE;
}

void
on_spinbuttonFootage_changed (GtkWidget *spb,
                                        gpointer         user_data)
{
  gint valeur;
  
  TmpMovieFootage= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spb));	  
}

void
on_checkbuttonArchiveBiblioAuto_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean etat;
	
	etat=gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton));
	TmpBiblioAutosave=etat;
	if (etat)	  
	   printf("biblio actif !\n");
	else
	   printf("biblio inactif !\n");
	
}
void
on_combobox1PrefsZoom_changed          (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  //printf("changement valeur zoom \n");
  TmpZoom=gtk_combo_box_get_active(GTK_COMBO_BOX(combobox)); 
}

										
GtkWidget*
create_dialogPrefs (gint w,gint h,gint marges,gint fps,gint footage,GdkColor pcolor,gboolean f_archive,gint zoom)
{
 GtkWidget *dialogPrefs;
  GtkWidget *dialog_vbox5;
  GtkWidget *notebookPrefs;
  GtkWidget *hbox20;
  GtkWidget *vseparator4;
  GtkWidget *vbox9;
  GtkWidget *hbox13;
  GtkWidget *label21;
  GtkWidget *entryWidth;
  GtkWidget *label22;
  GtkWidget *entryHeight;
  GtkWidget *label23;
  GtkWidget *hbox14;
  GtkWidget *label24;
  GtkWidget *entryMargins;
  GtkWidget *label25;
  GtkWidget *hbox15;
  GtkWidget *label26;
  GtkWidget *drawingareaPageDefaultColor;
  GtkWidget *vseparator3;
  GtkWidget *buttonDefautPageColor;
  GtkWidget *label46;
  GtkWidget *vbox14;
  GtkWidget *hbox16;
  GtkWidget *label27;
  GtkObject *spinbuttonDefaultFPS_adj;
  GtkWidget *spinbuttonDefaultFPS;
  GtkObject *spinbuttonFootage_adj;
  GtkWidget *spinbuttonFootage;
  GtkWidget *label28;
  GtkWidget *hbox24;
  GtkWidget *label44;
  GtkObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GtkWidget *label45;
  /* zoom */
  GtkWidget *hseparator2PrefsFilm;
  GtkWidget *hbox27Prefs;
  GtkWidget *label49PrefsZoom;
  GtkWidget *combobox1PrefsZoom;
   
  GtkWidget *label47;
  GtkWidget *vbox13;
  GtkWidget *hbox26;
  GtkWidget *vbox13user;
  
  GtkWidget *checkbuttonArchiveBiblioAuto;
  GtkWidget *label48;
  GtkWidget *dialog_action_area5;
  GtkWidget *cancelbutton4;
  GtkWidget *okbutton4;
  GtkTooltips *tooltips;
  GtkWidget *image11;
  GdkPixbuf *pb;
  gchar *str;
  
  /* passage vars tempos */
  TmpPgeColor=pcolor;
  TmpPageWidth=w;
  TmpPageHeight=h;
  TmpPageMargins=marges;
  TmpMovieFreq=fps;
  TmpMovieFootage=footage;
  TmpZoom=zoom;
   /* création image */
  pb = gdk_pixbuf_new_from_xpm_data((const char **)System_Preferences_icon_xpm); /* transtypage obligatoire */
  
  tooltips = gtk_tooltips_new ();

  dialogPrefs = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogPrefs), gettext( "Preferences : default values"));
  gtk_window_set_position (GTK_WINDOW (dialogPrefs), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogPrefs), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogPrefs), "gtk-preferences");
  gtk_window_set_type_hint (GTK_WINDOW (dialogPrefs), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox5 = GTK_DIALOG (dialogPrefs)->vbox;
  gtk_widget_show (dialog_vbox5);

  notebookPrefs = gtk_notebook_new ();
  gtk_widget_show (notebookPrefs);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), notebookPrefs, TRUE, TRUE, 0);

  hbox20 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox20);
  gtk_container_add (GTK_CONTAINER (notebookPrefs), hbox20);

//  hbox20 = gtk_hbox_new (FALSE, 0);
//  gtk_widget_show (hbox20);
//  gtk_box_pack_start (GTK_BOX (dialog_vbox5), hbox20, TRUE, TRUE, 0);

  image11 = gtk_image_new_from_pixbuf (pb);
  g_object_unref(pb);
  gtk_widget_show (image11);
  gtk_box_pack_start (GTK_BOX (hbox20), image11, TRUE, TRUE, 0);

  vseparator4 = gtk_vseparator_new ();
  gtk_widget_show (vseparator4);
  gtk_box_pack_start (GTK_BOX (hbox20), vseparator4, FALSE, FALSE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox20), vbox9, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox9), 1);

  hbox13 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox13, FALSE, FALSE, 0);

  label21 = gtk_label_new ( gettext("Scene's size : "));
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox13), label21, FALSE, FALSE, 0);

  entryWidth = gtk_entry_new ();
  gtk_widget_show (entryWidth);
  gtk_box_pack_start (GTK_BOX (hbox13), entryWidth, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryWidth, gettext( "Type here the width(in pixels) of your project"), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryWidth), 12);
  str=g_strdup_printf("%d",TmpPageWidth);
  gtk_entry_set_text (GTK_ENTRY (entryWidth), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryWidth), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryWidth), 5);

  label22 = gtk_label_new ("x");
  gtk_widget_show (label22);
  gtk_box_pack_start (GTK_BOX (hbox13), label22, FALSE, FALSE, 0);

  entryHeight = gtk_entry_new ();
  gtk_widget_show (entryHeight);
  gtk_box_pack_start (GTK_BOX (hbox13), entryHeight, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryHeight, gettext( "Type here the height(in pixels) of your project"), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryHeight), 12);
  str=g_strdup_printf("%d",TmpPageHeight);
  gtk_entry_set_text (GTK_ENTRY (entryHeight), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryHeight), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryHeight), 5);

  label23 = gtk_label_new (gettext( "pixels"));
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox13), label23, FALSE, FALSE, 0);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox14, FALSE, TRUE, 0);

  label24 = gtk_label_new (gettext( "Size of margins  :"));
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox14), label24, FALSE, FALSE, 0);

  entryMargins = gtk_entry_new ();
  gtk_widget_show (entryMargins);
  gtk_box_pack_start (GTK_BOX (hbox14), entryMargins, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entryMargins,gettext( 
       "Type here the size(in pixels) of the margins of your project"), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (entryMargins), 12);
  
  str=g_strdup_printf("%d",TmpPageMargins);
  gtk_entry_set_text (GTK_ENTRY (entryMargins), str);
  g_free(str);
  gtk_entry_set_invisible_char (GTK_ENTRY (entryMargins), 9679);
  gtk_entry_set_width_chars (GTK_ENTRY (entryMargins), 3);

  label25 = gtk_label_new (gettext( "pixels"));
  gtk_widget_show (label25);
  gtk_box_pack_start (GTK_BOX (hbox14), label25, FALSE, FALSE, 0);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox15, TRUE, TRUE, 0);

  label26 = gtk_label_new (gettext( "Scene's background color "));
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox15), label26, FALSE, FALSE, 0);

  drawingareaPageDefaultColor = gtk_drawing_area_new ();
  gtk_widget_show (drawingareaPageDefaultColor);
  gtk_box_pack_start (GTK_BOX (hbox15), drawingareaPageDefaultColor, FALSE, FALSE, 0);
  gtk_widget_set_size_request (drawingareaPageDefaultColor, 32, 32);
  gtk_tooltips_set_tip (tooltips, drawingareaPageDefaultColor,
    gettext(  "Preview of your project's background color"), NULL);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_show (vseparator3);
  gtk_box_pack_start (GTK_BOX (hbox15), vseparator3, FALSE, FALSE, 0);

  buttonDefautPageColor = gtk_button_new_from_stock ("gtk-select-color");
  gtk_widget_show (buttonDefautPageColor);
  gtk_box_pack_start (GTK_BOX (hbox15), buttonDefautPageColor, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, buttonDefautPageColor,
     gettext(  "Click this button to change the background color"), NULL);

  label46 = gtk_label_new (gettext("Editor"));
  gtk_widget_show (label46);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebookPrefs), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebookPrefs), 0), label46);
  
  
  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox14);
  gtk_container_add (GTK_CONTAINER (notebookPrefs), vbox14);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (notebookPrefs), vbox14,

  /* fréquence */                                      FALSE, FALSE, GTK_PACK_START);
  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox16, FALSE, FALSE, 0);
  label27 = gtk_label_new (gettext("Default animation frequency :"));
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (hbox16), label27, FALSE, FALSE, 0);
  spinbuttonDefaultFPS_adj = gtk_adjustment_new (TmpMovieFreq, 1, 30, 1, 1, 1);
  spinbuttonDefaultFPS = gtk_spin_button_new (GTK_ADJUSTMENT (spinbuttonDefaultFPS_adj), 1, 0);
  gtk_widget_show (spinbuttonDefaultFPS);
  gtk_box_pack_start (GTK_BOX (hbox16), spinbuttonDefaultFPS, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, spinbuttonDefaultFPS, gettext("Default animation frequency (1 to 29)"), NULL);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbuttonDefaultFPS), TRUE);
  label28 = gtk_label_new (gettext("frames per seconde"));
  gtk_widget_show (label28);
  gtk_box_pack_start (GTK_BOX (hbox16), label28, FALSE, FALSE, 0);
  /* métrage */
  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox24, TRUE, TRUE, 0);
  label44 = gtk_label_new (gettext("Default footage :"));
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (hbox24), label44, FALSE, FALSE, 0);
  spinbuttonFootage_adj = gtk_adjustment_new (TmpMovieFootage, 512, 16384, 1, 10, 10);
  spinbuttonFootage = gtk_spin_button_new (GTK_ADJUSTMENT (spinbuttonFootage_adj), 1, 0);
  gtk_widget_show (spinbuttonFootage);
  gtk_box_pack_start (GTK_BOX (hbox24), spinbuttonFootage, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, spinbuttonFootage,
    gettext(  "Type here the total frames length of your project"), NULL);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbuttonFootage), TRUE);
  label45 = gtk_label_new (gettext("Frames"));
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox24), label45, FALSE, FALSE, 0);
/* zoom */
  hseparator2PrefsFilm = gtk_hseparator_new ();
  gtk_widget_show (hseparator2PrefsFilm);
  gtk_box_pack_start (GTK_BOX (vbox14), hseparator2PrefsFilm, TRUE, TRUE, 0);

  hbox27Prefs = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox27Prefs);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox27Prefs, TRUE, TRUE, 0);

  label49PrefsZoom = gtk_label_new (gettext("Default pasteboard zoom :"));
  gtk_widget_show (label49PrefsZoom);
  gtk_box_pack_start (GTK_BOX (hbox27Prefs), label49PrefsZoom, FALSE, FALSE, 0);

  combobox1PrefsZoom = gtk_combo_box_new_text ();
  gtk_widget_show (combobox1PrefsZoom);
  gtk_box_pack_start (GTK_BOX (hbox27Prefs), combobox1PrefsZoom, FALSE, FALSE, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1PrefsZoom), "100 %");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1PrefsZoom), "75 %");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1PrefsZoom), "50 %");
  gtk_combo_box_set_active(GTK_COMBO_BOX(combobox1PrefsZoom),zoom);

  label47 = gtk_label_new (gettext("Film"));
  gtk_widget_show (label47);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebookPrefs), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebookPrefs), 1), label47);

  vbox13user = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox13user);
  gtk_container_add (GTK_CONTAINER (notebookPrefs), vbox13user);
  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox13user), hbox26, FALSE, FALSE, 0);
  /* options biblio */
  label46 = gtk_label_new (gettext( "Automatic creation of library archive :"));
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox26), label46, FALSE, FALSE, 0);
  checkbuttonArchiveBiblioAuto = gtk_check_button_new_with_mnemonic ("");
  gtk_widget_show (checkbuttonArchiveBiblioAuto);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonArchiveBiblioAuto),f_archive);
  gtk_box_pack_start (GTK_BOX (hbox26), checkbuttonArchiveBiblioAuto, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, checkbuttonArchiveBiblioAuto,
    gettext(  "Click here if you want that, by default, Ella saves the library in a file with the same name as the current project"), NULL);

  label48 = gtk_label_new (gettext( "User"));
  gtk_widget_show (label48);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebookPrefs),
        gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebookPrefs), 2), label48);

  dialog_action_area5 = GTK_DIALOG (dialogPrefs)->action_area;
  gtk_widget_show (dialog_action_area5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area5), GTK_BUTTONBOX_END);

  cancelbutton4 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton4);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogPrefs), cancelbutton4, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton4, GTK_CAN_DEFAULT);

  okbutton4 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton4);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogPrefs), okbutton4, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton4, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) entryWidth, "changed",
                    G_CALLBACK (on_entryWidth_changed),
                    NULL);
  g_signal_connect ((gpointer) entryHeight, "changed",
                    G_CALLBACK (on_entryHeight_changed),
                    NULL);
  g_signal_connect ((gpointer) entryMargins, "changed",
                    G_CALLBACK (on_entryMargins_changed),
                    NULL);
  g_signal_connect ((gpointer) drawingareaPageDefaultColor, "expose_event",
                            G_CALLBACK (on_drawingareaPageDefaultColor_expose_event),
                            GTK_OBJECT (drawingareaPageDefaultColor));
  g_signal_connect ((gpointer) buttonDefautPageColor, "clicked",
                            G_CALLBACK (on_buttonDefautPageColor_clicked),
                            GTK_OBJECT (drawingareaPageDefaultColor));
  g_signal_connect ((gpointer) spinbuttonDefaultFPS, "changed",
                    G_CALLBACK (on_spinbuttonDefaultFPS_changed),
                    NULL);
  /* footage */
  g_signal_connect ((gpointer) spinbuttonFootage, "changed",
                    G_CALLBACK (on_spinbuttonFootage_changed),
                    NULL);
  /* archivage */
  g_signal_connect ((gpointer) checkbuttonArchiveBiblioAuto, "toggled",
                    G_CALLBACK (on_checkbuttonArchiveBiblioAuto_toggled),
                    NULL);		
  /* zoom */
  g_signal_connect ((gpointer) combobox1PrefsZoom, "changed",
                    G_CALLBACK (on_combobox1PrefsZoom_changed),
                    NULL);			
  return dialogPrefs;
}
/*** transmettre les valeurs choisies ***/
gdouble dlg_get_default_width(void)
{
	return (gdouble)TmpPageWidth;
}
gdouble dlg_get_default_height(void)
{
	return (gdouble)TmpPageHeight;
}
gdouble dlg_get_default_margins(void)
{
	return (gdouble)TmpPageMargins;
}
gint dlg_get_default_fps(void)
{
	return (gint)TmpMovieFreq;
}
gboolean dlg_get_biblio_autosave(void)
{
    return TmpBiblioAutosave;
}
gint dlg_get_default_footage(void)
{
	return (gint)TmpMovieFootage;
}
GdkColor dlg_get_default_page_color(void)
{
	return TmpPgeColor;
}
gint dlg_get_timeline_default_zoom(void)
{
	return TmpZoom;
}
/************************************
 * importation d'éléments
 * dans la bibliothèque
 * en entrée, un message spécifique,
 * plus un code de format pour les
 * filtres de recherche
 * ********************************/
GtkWidget*
dlg_create_dialogImporter (gchar *titre,gint format)
{
  GtkWidget *dialogImporter;
  GtkWidget *dialog_vbox9;
  GtkWidget *dialog_action_area9;
  GtkWidget *button6;
  GtkWidget *button7;
  GtkFileFilter *filter;
  
  filter = gtk_file_filter_new ();

  dialogImporter = gtk_file_chooser_dialog_new (titre, NULL,
                     GTK_FILE_CHOOSER_ACTION_OPEN,NULL,NULL, NULL);
  if (format==1)/* bitmap */
     {
       gtk_file_filter_add_pattern (filter, "*.jpg");
	   gtk_file_filter_add_pattern (filter, "*.jpeg");
	   gtk_file_filter_add_pattern (filter, "*.png");
	   gtk_file_filter_add_pattern (filter, "*.xpm");
	   gtk_file_filter_set_name (filter,"images");	 
     }
  if (format==2)/* vecteurs */
     {
       gtk_file_filter_add_pattern (filter, "*.svg");	 
	   gtk_file_filter_set_name (filter,gettext( "drawings"));	   
     }
  if (format==3)/* sons */
     {
       gtk_file_filter_add_pattern (filter, "*.wav");	
	   gtk_file_filter_add_pattern (filter, "*.WAV");
	   gtk_file_filter_add_pattern (filter, "*.mp3");
	   gtk_file_filter_add_pattern (filter, "*.MP3");
	   gtk_file_filter_set_name (filter,gettext( "sounds"));	    
     }
  if (format==4)/* symbols */
     {
       gtk_file_filter_add_pattern (filter, "*.svg");	 
	   gtk_file_filter_set_name (filter,gettext( "symbols"));	   
     }	 
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(dialogImporter),filter);
  gtk_container_set_border_width (GTK_CONTAINER (dialogImporter), 5);
  gtk_window_set_position (GTK_WINDOW (dialogImporter), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogImporter), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (dialogImporter), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox9 = GTK_DIALOG (dialogImporter)->vbox;
  gtk_widget_show (dialog_vbox9);

  dialog_action_area9 = GTK_DIALOG (dialogImporter)->action_area;
  gtk_widget_show (dialog_action_area9);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area9), GTK_BUTTONBOX_END);

  button6 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button6);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogImporter), button6, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);

  button7 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button7);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogImporter), button7, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button7, GTK_CAN_DEFAULT);

  gtk_widget_grab_default (button7);
  return dialogImporter;
}
/*************************************
 * renommer un calque
 * **********************************/
/*** callback ***/

void
on_entry1RenameLayer_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
 //  printf("le nom a changé !\n");
   
}

GtkWidget*
create_dialogRenameLayer (gchar *nom_calque,GtkWidget *entry1RenameLayer)
{
  GtkWidget *dialogRenameLayer;
  GtkWidget *dialog_vbox12;
  GtkWidget *table1;
  GtkWidget *label47RenameLayer;
  GtkWidget *label48RenameLayer;
 // GtkWidget *entry1RenameLayer;
  GtkWidget *label49CurrentLayerName;
  GtkWidget *dialog_action_area12;
  GtkWidget *cancelbutton7;
  GtkWidget *okbutton7;

  dialogRenameLayer = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogRenameLayer), gettext("Rename the layer"));
  gtk_window_set_position (GTK_WINDOW (dialogRenameLayer), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogRenameLayer), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogRenameLayer), "gtk-edit");
  gtk_window_set_type_hint (GTK_WINDOW (dialogRenameLayer), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox12 = GTK_DIALOG (dialogRenameLayer)->vbox;
  gtk_widget_show (dialog_vbox12);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox12), table1, TRUE, TRUE, 0);

  label47RenameLayer = gtk_label_new (gettext("Layer actual name:"));
  gtk_widget_show (label47RenameLayer);
  gtk_table_attach (GTK_TABLE (table1), label47RenameLayer, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label47RenameLayer), 0, 0.5);

  label48RenameLayer = gtk_label_new (gettext("New layer name:"));
  gtk_widget_show (label48RenameLayer);
  gtk_table_attach (GTK_TABLE (table1), label48RenameLayer, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label48RenameLayer), 0, 0.5);

  //entry1RenameLayer = gtk_entry_new ();
  gtk_widget_show (entry1RenameLayer);
  gtk_table_attach (GTK_TABLE (table1), entry1RenameLayer, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (entry1RenameLayer), 128);
  gtk_entry_set_invisible_char (GTK_ENTRY (entry1RenameLayer), 9679);

  label49CurrentLayerName = gtk_label_new (nom_calque);
  gtk_widget_show (label49CurrentLayerName);
  gtk_table_attach (GTK_TABLE (table1), label49CurrentLayerName, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label49CurrentLayerName), 0, 0.5);

  dialog_action_area12 = GTK_DIALOG (dialogRenameLayer)->action_area;
  gtk_widget_show (dialog_action_area12);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area12), GTK_BUTTONBOX_END);

  cancelbutton7 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton7);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogRenameLayer), cancelbutton7, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton7, GTK_CAN_DEFAULT);

  okbutton7 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton7);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogRenameLayer), okbutton7, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton7, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) entry1RenameLayer, "changed",
                            G_CALLBACK (on_entry1RenameLayer_changed),
                            GTK_OBJECT (entry1RenameLayer));							
  return dialogRenameLayer;
}
/************************************
 * callback du changement nombre 
 * d'images
 * *********************************/
void
on_spinbuttonAddFramesAfterCursor_value_changed(GtkSpinButton   *spinbutton,
                                        gint *val_int)
{
   gint valeur;
   
   /* lire la nouvelle valeur */
   valeur=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));
   /* poke de la valeur */
   *val_int=valeur;
}
/*************************************
ajouter des images APRES la
position du curseur
*************************************/
GtkWidget*
create_dialogAddFramesAfterCursor (gint position_actuelle, gint max_possible, gint *val_int)
{
  GtkWidget *dialogAddFramesAfterCursor;
  GtkWidget *dialog_vbox13;
  GtkWidget *vbox12;
  GtkWidget *label47AddFramesAfterCursor;
  GtkObject *spinbuttonAddFramesAfterCursor_adj;
  GtkWidget *spinbuttonAddFramesAfterCursor;
  GtkWidget *dialog_action_area13;
  GtkWidget *cancelbutton8;
  GtkWidget *okbutton8;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialogAddFramesAfterCursor = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogAddFramesAfterCursor),  gettext("Add frames after cursor position ..."));
  gtk_window_set_position (GTK_WINDOW (dialogAddFramesAfterCursor), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogAddFramesAfterCursor), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogAddFramesAfterCursor), "gtk-dialog-question");
  gtk_window_set_type_hint (GTK_WINDOW (dialogAddFramesAfterCursor), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox13 = GTK_DIALOG (dialogAddFramesAfterCursor)->vbox;
  gtk_widget_show (dialog_vbox13);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (dialog_vbox13), vbox12, TRUE, TRUE, 0);

  label47AddFramesAfterCursor = 
    gtk_label_new ( gettext("Type here the number of frames you want to append after cursor position"));
  gtk_widget_show (label47AddFramesAfterCursor);
  gtk_box_pack_start (GTK_BOX (vbox12), label47AddFramesAfterCursor, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label47AddFramesAfterCursor), TRUE);
  gtk_label_set_justify (GTK_LABEL (label47AddFramesAfterCursor), GTK_JUSTIFY_FILL);

  spinbuttonAddFramesAfterCursor_adj = gtk_adjustment_new (0, 0, max_possible-position_actuelle, 1, 1, 1);
  spinbuttonAddFramesAfterCursor = gtk_spin_button_new (GTK_ADJUSTMENT (spinbuttonAddFramesAfterCursor_adj), 1, 0);
  gtk_widget_show (spinbuttonAddFramesAfterCursor);
  gtk_box_pack_start (GTK_BOX (vbox12), spinbuttonAddFramesAfterCursor, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, spinbuttonAddFramesAfterCursor,
      gettext( "TYpe here the number a frames ; a check will be made in order to avoir errors"), NULL);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbuttonAddFramesAfterCursor), TRUE);

  dialog_action_area13 = GTK_DIALOG (dialogAddFramesAfterCursor)->action_area;
  gtk_widget_show (dialog_action_area13);

  cancelbutton8 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton8);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAddFramesAfterCursor), cancelbutton8, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton8, GTK_CAN_DEFAULT);
  g_signal_connect((gpointer) spinbuttonAddFramesAfterCursor, "value_changed",
                            G_CALLBACK (on_spinbuttonAddFramesAfterCursor_value_changed),
                            val_int);
  okbutton8 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton8);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAddFramesAfterCursor), okbutton8, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton8, GTK_CAN_DEFAULT);
  return dialogAddFramesAfterCursor;
}
/*************************************
 * dialogue 'à propos'               *
 * **********************************/
GtkWidget*
create_aboutElla (void)
{
  GtkWidget *aboutElla;
  const gchar *authors[] = {
    "Kevlar <kevlar@legtux.net>\n",
    NULL
  };
  const gchar *artists[] = {
  "Ella's Logo and main icons  : Kevlar",
    "Prefs icon : found on GPL stuff.",
    "Screen icon : Sergio Sanchez Lopez (GPL)",
    "Some icons : Tcharless, lovaloa from ubuntu.fr forum",
    NULL
  };
  /* TRANSLATORS: Replace this string with your names, one name per line. */
  gchar *translators = gettext("translator-credits");
  GdkPixbuf *aboutElla_logo_pixbuf;
  
  aboutElla = gtk_about_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (aboutElla), 5);
  gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (aboutElla), NUM_REVISION);
  gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (aboutElla), "Contrib");
  gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG (aboutElla), "(c) Kevlar & others - 2009, 2010\n");
  gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (aboutElla), "E         L       L        A\n*Elegant Light Linux Animator*\nis a *free* Flash(tm),\n SVG & HTML5\n Editor/generator under Gtk, free & light");
  gtk_about_dialog_set_license (GTK_ABOUT_DIALOG (aboutElla), "This software is under GPL V3 licence.\n*******************");
  gtk_about_dialog_set_wrap_license (GTK_ABOUT_DIALOG (aboutElla), TRUE);
  gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (aboutElla), "http://ella.tuxfamily.org/");
  gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG (aboutElla), "Ella Home Page");
  gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (aboutElla), authors);
  gtk_about_dialog_set_artists (GTK_ABOUT_DIALOG (aboutElla), artists);
  gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (aboutElla), translators);
  aboutElla_logo_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **)logo_xpm); 
  gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG (aboutElla), aboutElla_logo_pixbuf);
  return aboutElla;
}
/**********************************
 * dialogue quitter
 * *******************************/
gint dialog_ask_before_quit(void)
{
  GtkWidget *dialog;
  gint reponse;
  
  dialog = gtk_message_dialog_new(NULL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_QUESTION,
            GTK_BUTTONS_OK_CANCEL,
            gettext("Are you sure you want to quit Ella ?"));
  gtk_window_set_title(GTK_WINDOW(dialog), gettext("Quit"));
  reponse=gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);	
  return reponse;
}
/*************************************
 * general error dialog
 * **********************************/
void dlg_file_error(void)
{
  GtkWidget *dialog;
  
  dialog = gtk_message_dialog_new(NULL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_ERROR,
            GTK_BUTTONS_OK,
            gettext("Error loading file"));
  gtk_window_set_title(GTK_WINDOW(dialog), gettext("Error"));
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}
/**************************************************
 * callback for movie footage
 * ************************************************/
void
on_spinbuttonTrames_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
  printf("valeur footage changée \n");
}
/**********************************************
 * dialog to change the total length of
 * the movie
 * ******************************************/
GtkWidget*
create_dialogFootage (void)
{
  GtkWidget *dialogFootage;
  GtkWidget *dialog_vbox8;
  GtkWidget *hbox21;
  GtkWidget *image9;
  GtkWidget *vseparator5;
  GtkWidget *vbox11;
  GtkWidget *label38;
  GtkWidget *hbox22;
  GtkWidget *label39;
  GtkObject *spinbuttonTrames_adj;
  GtkWidget *spinbuttonTrames;
  GtkWidget *label40;
  GtkWidget *hbox23;
  GtkWidget *label41;
  GtkWidget *labelDuration;
  GtkWidget *dialog_action_area8;
  GtkWidget *cancelbutton6;
  GtkWidget *okbutton6;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialogFootage = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogFootage), gettext("Animation footage"));
  gtk_window_set_position (GTK_WINDOW (dialogFootage), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogFootage), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogFootage), "gtk-properties");
  gtk_window_set_type_hint (GTK_WINDOW (dialogFootage), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox8 = GTK_DIALOG (dialogFootage)->vbox;
  gtk_widget_show (dialog_vbox8);

  hbox21 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (dialog_vbox8), hbox21, FALSE, FALSE, 0);

  image9 = gtk_image_new_from_icon_name ("gtk-cdrom", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox21), image9, FALSE, FALSE, 0);

  vseparator5 = gtk_vseparator_new ();
  gtk_widget_show (vseparator5);
  gtk_box_pack_start (GTK_BOX (hbox21), vseparator5, TRUE, TRUE, 0);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (hbox21), vbox11, FALSE, FALSE, 0);

  label38 = gtk_label_new (gettext("<big>Animation footage :</big>"));
  gtk_widget_show (label38);
  gtk_box_pack_start (GTK_BOX (vbox11), label38, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label38), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label38), 0, 0.5);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox22, FALSE, FALSE, 0);

  label39 = gtk_label_new (gettext("Total frames : "));
  gtk_widget_show (label39);
  gtk_box_pack_start (GTK_BOX (hbox22), label39, FALSE, FALSE, 0);

  spinbuttonTrames_adj = gtk_adjustment_new (512, 512, 1024, 1, 10, 10);
  spinbuttonTrames = gtk_spin_button_new (GTK_ADJUSTMENT (spinbuttonTrames_adj), 1, 0);
  gtk_widget_show (spinbuttonTrames);
  gtk_box_pack_start (GTK_BOX (hbox22), spinbuttonTrames, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, spinbuttonTrames,
      gettext( "Type here the total amount of frames which recquires your movie"), NULL);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbuttonTrames), TRUE);

  label40 = gtk_label_new (gettext("frames"));
  gtk_widget_show (label40);
  gtk_box_pack_start (GTK_BOX (hbox22), label40, FALSE, FALSE, 0);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox23, FALSE, FALSE, 0);

  label41 = gtk_label_new (gettext("Resulting playing time : "));
  gtk_widget_show (label41);
  gtk_box_pack_start (GTK_BOX (hbox23), label41, FALSE, FALSE, 0);

  labelDuration = gtk_label_new (gettext("0'00\" at 12 frames/sec"));
  gtk_widget_show (labelDuration);
  gtk_box_pack_start (GTK_BOX (hbox23), labelDuration, FALSE, FALSE, 0);

  dialog_action_area8 = GTK_DIALOG (dialogFootage)->action_area;
  gtk_widget_show (dialog_action_area8);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area8), GTK_BUTTONBOX_END);

  cancelbutton6 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton6);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogFootage), cancelbutton6, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton6, GTK_CAN_DEFAULT);

  okbutton6 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton6);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogFootage), okbutton6, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton6, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) spinbuttonTrames, "value_changed",
                            G_CALLBACK (on_spinbuttonTrames_changed),
                            GTK_OBJECT (labelDuration));


  return dialogFootage;
}
/**************************************
 * callbacks for alignment dialog
 * ***********************************/
void
on_radiobuttonHorizAlign_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GSList *pList;	
	gint i=0;
	gboolean trouve=FALSE;
	
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					TmpAlignHoriz=i;
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										

void
on_radiobuttonVertiAlign_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GSList *pList;
	gint i=0;
	gboolean trouve=FALSE;
		
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					trouve=TRUE;
					TmpAlignVerti=i;
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										

void
on_radiobuttonZoneAlign_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GSList *pList;
	gint i=0;
	gboolean trouve=FALSE;
		
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					trouve=TRUE;
					TmpAlignZone=i;
					//printf("le choix actuel est :%d\n",i);
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										
								
/* ad-hoc functions to get the choice of user */
gint dlg_get_horizontal_align(void)
{
	return TmpAlignHoriz;
}
gint dlg_get_vertical_align(void)
{
	return TmpAlignVerti;
}
gint dlg_get_zone_align(void)
{
	return TmpAlignZone;
}
										
/*************************************
 * dialog to set alignment of items
 * **********************************/
GtkWidget*
create_dialogAlignement (void)
{
  GtkWidget *dialogAlignement;
  GtkWidget *dialog_vbox14;
  GtkWidget *hbox30;
  GtkWidget *vbox16;
  GtkWidget *frame7;
  GtkWidget *alignment12;
  GtkWidget *hbox31;
  GtkWidget *vbox17;
  GtkWidget *radiobuttonLeftAligne;
  GSList *radiobuttonLeftAligne_group = NULL;
  GtkWidget *alignment15;
  GtkWidget *hbox32;
  GtkWidget *image12;
  GtkWidget *label61;
  GtkWidget *radiobuttonCenterAlign;
  GtkWidget *alignment16;
  GtkWidget *hbox33;
  GtkWidget *image13;
  GtkWidget *label62;
  GtkWidget *radiobuttonRightAlign;
  GtkWidget *radiobuttonNoChangeHoriz;
  GtkWidget *alignment17;
  GtkWidget *hbox34;
  GtkWidget *image14;
  GtkWidget *label63;
  GtkWidget *label56;
  GtkWidget *frame8;
  GtkWidget *alignment13;
  GtkWidget *vbox19;
  GtkWidget *radiobuttonHighAlign;
  GSList *radiobuttonHighAlign_group = NULL;
  GtkWidget *alignment18;
  GtkWidget *hbox35;
  GtkWidget *image15;
  GtkWidget *label64;
  GtkWidget *radiobuttonMiddleAlign;
  GtkWidget *alignment19;
  GtkWidget *hbox36;
  GtkWidget *image16;
  GtkWidget *label65;
  GtkWidget *radiobuttonLowAlign;
  GtkWidget *radiobuttonNoChangeVerti;
  GtkWidget *alignment20;
  GtkWidget *hbox37;
  GtkWidget *image17;
  GtkWidget *label66;
  GtkWidget *label57;
  GtkWidget *frame9;
  GtkWidget *alignment14;
  GtkWidget *hbox38;
  GtkWidget *vbox20;
  GtkWidget *radiobuttonSelectionAlign;
  GSList *radiobuttonSelectionAlign_group = NULL;
  GtkWidget *alignment21;
  GtkWidget *hbox39;
  GtkWidget *image18;
  GtkWidget *label67;
  GtkWidget *radiobuttonSceneryAlign;
  GtkWidget *alignment22;
  GtkWidget *hbox40;
  GtkWidget *image19;
  GtkWidget *label68;
  GtkWidget *label58;
  GtkWidget *dialog_action_area14;
  GtkWidget *cancelbutton9;
  GtkWidget *okbutton9;
  GdkPixbuf *ico;
  
  dialogAlignement = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogAlignement),gettext("Align items ..."));
  gtk_window_set_position (GTK_WINDOW (dialogAlignement), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogAlignement), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogAlignement), "gtk-preferences");
  gtk_window_set_type_hint (GTK_WINDOW (dialogAlignement), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox14 = GTK_DIALOG (dialogAlignement)->vbox;
  gtk_widget_show (dialog_vbox14);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (dialog_vbox14), hbox30, TRUE, TRUE, 0);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox16);
  gtk_box_pack_start (GTK_BOX (hbox30), vbox16, TRUE, TRUE, 0);

  frame7 = gtk_frame_new (NULL);
  gtk_widget_show (frame7);
  gtk_box_pack_start (GTK_BOX (vbox16), frame7, TRUE, TRUE, 0);

  alignment12 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment12);
  gtk_container_add (GTK_CONTAINER (frame7), alignment12);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment12), 0, 0, 12, 0);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox31);
  gtk_container_add (GTK_CONTAINER (alignment12), hbox31);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox31), vbox17, TRUE, TRUE, 0);

  radiobuttonLeftAligne = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonLeftAligne);
  gtk_box_pack_start (GTK_BOX (vbox17), radiobuttonLeftAligne, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonLeftAligne), radiobuttonLeftAligne_group);
  radiobuttonLeftAligne_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonLeftAligne));

  alignment15 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment15);
  gtk_container_add (GTK_CONTAINER (radiobuttonLeftAligne), alignment15);

  hbox32 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox32);
  gtk_container_add (GTK_CONTAINER (alignment15), hbox32);

  ico = gdk_pixbuf_new_from_xpm_data((const char **)left_align_xpm);  
  image12 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image12);
  gtk_box_pack_start (GTK_BOX (hbox32), image12, FALSE, FALSE, 0);

  label61 = gtk_label_new_with_mnemonic (gettext("left"));
  gtk_widget_show (label61);
  gtk_box_pack_start (GTK_BOX (hbox32), label61, FALSE, FALSE, 0);

  radiobuttonCenterAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonCenterAlign);
  gtk_box_pack_start (GTK_BOX (vbox17), radiobuttonCenterAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonCenterAlign), radiobuttonLeftAligne_group);
  radiobuttonLeftAligne_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonCenterAlign));

  alignment16 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment16);
  gtk_container_add (GTK_CONTAINER (radiobuttonCenterAlign), alignment16);

  hbox33 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox33);
  gtk_container_add (GTK_CONTAINER (alignment16), hbox33);

  ico = gdk_pixbuf_new_from_xpm_data((const char **)center_align_xpm);  
  image13 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image13);
  gtk_box_pack_start (GTK_BOX (hbox33), image13, FALSE, FALSE, 0);

  label62 = gtk_label_new_with_mnemonic (gettext("center"));
  gtk_widget_show (label62);
  gtk_box_pack_start (GTK_BOX (hbox33), label62, FALSE, FALSE, 0);

  radiobuttonRightAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonRightAlign);
  gtk_box_pack_start (GTK_BOX (vbox17), radiobuttonRightAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonRightAlign), radiobuttonLeftAligne_group);
  radiobuttonLeftAligne_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonRightAlign));

  alignment17 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment17);
  gtk_container_add (GTK_CONTAINER (radiobuttonRightAlign), alignment17);

  hbox34 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox34);
  gtk_container_add (GTK_CONTAINER (alignment17), hbox34);

  ico = gdk_pixbuf_new_from_xpm_data((const char **)right_align_xpm);  
  image14 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image14);
  gtk_box_pack_start (GTK_BOX (hbox34), image14, FALSE, FALSE, 0);

  label63 = gtk_label_new_with_mnemonic (gettext("right"));
  gtk_widget_show (label63);
  gtk_box_pack_start (GTK_BOX (hbox34), label63, FALSE, FALSE, 0);
  
  radiobuttonNoChangeHoriz = gtk_radio_button_new_with_mnemonic (NULL, gettext("no change "));
  gtk_widget_show (radiobuttonNoChangeHoriz);
  gtk_box_pack_start (GTK_BOX (vbox17), radiobuttonNoChangeHoriz, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonNoChangeHoriz), radiobuttonLeftAligne_group); 
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobuttonNoChangeHoriz),TRUE);
  radiobuttonLeftAligne_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonNoChangeHoriz));
  
  label56 = gtk_label_new (gettext("<b>Horizontally</b>"));
  gtk_widget_show (label56);
  gtk_frame_set_label_widget (GTK_FRAME (frame7), label56);
  gtk_label_set_use_markup (GTK_LABEL (label56), TRUE);

  frame8 = gtk_frame_new (NULL);
  gtk_widget_show (frame8);
  gtk_box_pack_start (GTK_BOX (vbox16), frame8, TRUE, TRUE, 0);

  alignment13 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment13);
  gtk_container_add (GTK_CONTAINER (frame8), alignment13);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment13), 0, 0, 12, 0);

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox19);
  gtk_container_add (GTK_CONTAINER (alignment13), vbox19);

  radiobuttonHighAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonHighAlign);
  gtk_box_pack_start (GTK_BOX (vbox19), radiobuttonHighAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonHighAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonHighAlign));

  alignment18 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment18);
  gtk_container_add (GTK_CONTAINER (radiobuttonHighAlign), alignment18);

  hbox35 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox35);
  gtk_container_add (GTK_CONTAINER (alignment18), hbox35);

    ico = gdk_pixbuf_new_from_xpm_data((const char **)high_align_xpm);  
  image15 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image15);
  gtk_box_pack_start (GTK_BOX (hbox35), image15, FALSE, FALSE, 0);

  label64 = gtk_label_new_with_mnemonic (gettext("high"));
  gtk_widget_show (label64);
  gtk_box_pack_start (GTK_BOX (hbox35), label64, FALSE, FALSE, 0);

  radiobuttonMiddleAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonMiddleAlign);
  gtk_box_pack_start (GTK_BOX (vbox19), radiobuttonMiddleAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonMiddleAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonMiddleAlign));

  alignment19 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment19);
  gtk_container_add (GTK_CONTAINER (radiobuttonMiddleAlign), alignment19);

  hbox36 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox36);
  gtk_container_add (GTK_CONTAINER (alignment19), hbox36);

   ico = gdk_pixbuf_new_from_xpm_data((const char **)mid_align_xpm);  
  image16 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image16);
  gtk_box_pack_start (GTK_BOX (hbox36), image16, FALSE, FALSE, 0);

  label65 = gtk_label_new_with_mnemonic (gettext("middle"));
  gtk_widget_show (label65);
  gtk_box_pack_start (GTK_BOX (hbox36), label65, FALSE, FALSE, 0);

  radiobuttonLowAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonLowAlign);
  gtk_box_pack_start (GTK_BOX (vbox19), radiobuttonLowAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonLowAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonLowAlign));

  alignment20 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment20);
  gtk_container_add (GTK_CONTAINER (radiobuttonLowAlign), alignment20);

  hbox37 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox37);
  gtk_container_add (GTK_CONTAINER (alignment20), hbox37);

    ico = gdk_pixbuf_new_from_xpm_data((const char **)low_align_xpm);  
  image17 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image17);
  gtk_box_pack_start (GTK_BOX (hbox37), image17, FALSE, FALSE, 0);

  label66 = gtk_label_new_with_mnemonic (gettext("low"));
  gtk_widget_show (label66);
  gtk_box_pack_start (GTK_BOX (hbox37), label66, FALSE, FALSE, 0);

  radiobuttonNoChangeVerti = gtk_radio_button_new_with_mnemonic (NULL, gettext("no change")); 
  gtk_widget_show (radiobuttonNoChangeVerti);
  gtk_box_pack_start (GTK_BOX (vbox19), radiobuttonNoChangeVerti, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonNoChangeVerti), radiobuttonHighAlign_group);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobuttonNoChangeVerti),TRUE);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonNoChangeVerti));

  label57 = gtk_label_new (gettext("<b>Vertically</b>"));
  gtk_widget_show (label57);
  gtk_frame_set_label_widget (GTK_FRAME (frame8), label57);
  gtk_label_set_use_markup (GTK_LABEL (label57), TRUE);

  frame9 = gtk_frame_new (NULL);
  gtk_widget_show (frame9);
  gtk_box_pack_start (GTK_BOX (hbox30), frame9, TRUE, TRUE, 0);

  alignment14 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment14);
  gtk_container_add (GTK_CONTAINER (frame9), alignment14);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment14), 0, 0, 12, 0);

  hbox38 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox38);
  gtk_container_add (GTK_CONTAINER (alignment14), hbox38);

  vbox20 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox20);
  gtk_box_pack_start (GTK_BOX (hbox38), vbox20, TRUE, TRUE, 0);

  radiobuttonSelectionAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonSelectionAlign);
  gtk_box_pack_start (GTK_BOX (vbox20), radiobuttonSelectionAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonSelectionAlign), radiobuttonSelectionAlign_group);
  radiobuttonSelectionAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonSelectionAlign));

  alignment21 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment21);
  gtk_container_add (GTK_CONTAINER (radiobuttonSelectionAlign), alignment21);

  hbox39 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox39);
  gtk_container_add (GTK_CONTAINER (alignment21), hbox39);

    ico = gdk_pixbuf_new_from_xpm_data((const char **)select_align_xpm);  
  image18 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image18);
  gtk_box_pack_start (GTK_BOX (hbox39), image18, FALSE, FALSE, 0);

  label67 = gtk_label_new_with_mnemonic (gettext("selection"));
  gtk_widget_show (label67);
  gtk_box_pack_start (GTK_BOX (hbox39), label67, FALSE, FALSE, 0);

  radiobuttonSceneryAlign = gtk_radio_button_new (NULL);
  gtk_widget_show (radiobuttonSceneryAlign);
  gtk_box_pack_start (GTK_BOX (vbox20), radiobuttonSceneryAlign, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonSceneryAlign), radiobuttonSelectionAlign_group);
  radiobuttonSelectionAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonSceneryAlign));

  alignment22 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment22);
  gtk_container_add (GTK_CONTAINER (radiobuttonSceneryAlign), alignment22);

  hbox40 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox40);
  gtk_container_add (GTK_CONTAINER (alignment22), hbox40);

   ico = gdk_pixbuf_new_from_xpm_data((const char **)scenery_align_xpm);  
  image19 =  gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);
  gtk_widget_show (image19);
  gtk_box_pack_start (GTK_BOX (hbox40), image19, FALSE, FALSE, 0);

  label68 = gtk_label_new_with_mnemonic (gettext("scenery"));
  gtk_widget_show (label68);
  gtk_box_pack_start (GTK_BOX (hbox40), label68, FALSE, FALSE, 0);

  label58 = gtk_label_new (gettext("<b>Relatively to : </b>"));
  gtk_widget_show (label58);
  gtk_frame_set_label_widget (GTK_FRAME (frame9), label58);
  gtk_label_set_use_markup (GTK_LABEL (label58), TRUE);

  dialog_action_area14 = GTK_DIALOG (dialogAlignement)->action_area;
  gtk_widget_show (dialog_action_area14);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area14), GTK_BUTTONBOX_END);

  cancelbutton9 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton9);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAlignement), cancelbutton9, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton9, GTK_CAN_DEFAULT);

  okbutton9 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton9);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogAlignement), okbutton9, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton9, GTK_CAN_DEFAULT);

  g_signal_connect((gpointer) radiobuttonLeftAligne, "toggled",
                            G_CALLBACK (on_radiobuttonHorizAlign_toggled),
                            GTK_OBJECT (radiobuttonLeftAligne));
  g_signal_connect ((gpointer) radiobuttonCenterAlign, "toggled",
                            G_CALLBACK (on_radiobuttonHorizAlign_toggled),
                            GTK_OBJECT (radiobuttonLeftAligne));
  g_signal_connect ((gpointer) radiobuttonRightAlign, "toggled",
                            G_CALLBACK (on_radiobuttonHorizAlign_toggled),
                            GTK_OBJECT (radiobuttonLeftAligne));
  g_signal_connect ((gpointer) radiobuttonHighAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                            GTK_OBJECT (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonMiddleAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                            GTK_OBJECT (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonLowAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                            GTK_OBJECT (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonSelectionAlign, "toggled",
                            G_CALLBACK (on_radiobuttonZoneAlign_toggled),
                            GTK_OBJECT (radiobuttonSelectionAlign));
  g_signal_connect ((gpointer) radiobuttonSceneryAlign, "toggled",
                            G_CALLBACK (on_radiobuttonZoneAlign_toggled),
                            GTK_OBJECT (radiobuttonSelectionAlign));
  return dialogAlignement;
}
