/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/

//translations
#include <locale.h>
#include <libintl.h>

/************************
 * dialogues pour l'
 * éditeur
 * *********************/
#include <gtk/gtk.h>
/* les deux includes ci-dessous sont indispensables pour accéder aux patterns des fontes */
#include "pango/pangofc-font.h"
#include "pango/pangofc-fontmap.h"


/* XPM */
static char * peinture_xpm[] = {
"64 100 1419 2",
"  	c None",
". 	c #E7EAC0",
"+ 	c #DEE097",
"@ 	c #EDF0E1",
"# 	c #DFE280",
"$ 	c #E5E795",
"% 	c #DBDD51",
"& 	c #C6C8A5",
"* 	c #D0D2B9",
"= 	c #E8ECE7",
"- 	c #EAEEEC",
"; 	c #EFF2EF",
"> 	c #EEF1F1",
", 	c #ECF0F1",
"' 	c #ECEFEF",
") 	c #E7EBE1",
"! 	c #D1D487",
"~ 	c #CBCD7E",
"{ 	c #AFB163",
"] 	c #93954C",
"^ 	c #92944C",
"/ 	c #969851",
"( 	c #C9CB91",
"_ 	c #C6C883",
": 	c #CFD295",
"< 	c #C6C8A2",
"[ 	c #E2E4BB",
"} 	c #C6C8B2",
"| 	c #B3B58E",
"1 	c #F0F3F3",
"2 	c #D6D85A",
"3 	c #E5E89B",
"4 	c #BEC0C1",
"5 	c #AAAC6E",
"6 	c #B9BB64",
"7 	c #CED078",
"8 	c #D7D999",
"9 	c #F1F4EE",
"0 	c #F2F5F3",
"a 	c #F0F3EB",
"b 	c #E4E6C0",
"c 	c #E2E4B9",
"d 	c #E3E5BA",
"e 	c #D9DB95",
"f 	c #B0B259",
"g 	c #ACAE55",
"h 	c #93953C",
"i 	c #8C8E35",
"j 	c #8F9136",
"k 	c #AAAC40",
"l 	c #AEB054",
"m 	c #D0D279",
"n 	c #CED079",
"o 	c #CACC7B",
"p 	c #D2D5A3",
"q 	c #CFD2D9",
"r 	c #A3A5A8",
"s 	c #6F7178",
"t 	c #B2B38E",
"u 	c #E1E441",
"v 	c #C5C765",
"w 	c #AAAC55",
"x 	c #C3C538",
"y 	c #A9AB36",
"z 	c #A6A84C",
"A 	c #C0C269",
"B 	c #BFC166",
"C 	c #ADAF50",
"D 	c #A8AA4B",
"E 	c #A6A84A",
"F 	c #98993F",
"G 	c #949637",
"H 	c #A8AA4A",
"I 	c #B7B954",
"J 	c #B9BB50",
"K 	c #B1B337",
"L 	c #A2A433",
"M 	c #9FA234",
"N 	c #999B35",
"O 	c #909233",
"P 	c #A0A246",
"Q 	c #A0A24B",
"R 	c #BFC169",
"S 	c #C2C46B",
"T 	c #CFD16B",
"U 	c #D0D270",
"V 	c #C9CC8C",
"W 	c #DCE0CC",
"X 	c #9FA1AC",
"Y 	c #B1B389",
"Z 	c #D4D646",
"` 	c #DADC54",
" .	c #C8CA4B",
"..	c #AFB13B",
"+.	c #929437",
"@.	c #909236",
"#.	c #989A3C",
"$.	c #9D9F3E",
"%.	c #B0B256",
"&.	c #BABC69",
"*.	c #BEC06E",
"=.	c #C6C869",
"-.	c #DBDD64",
";.	c #E1E357",
">.	c #E4E64F",
",.	c #E4E64A",
"'.	c #E7E93E",
").	c #EFF234",
"!.	c #F7F92D",
"~.	c #FBFE29",
"{.	c #FAFD2B",
"].	c #E9EC34",
"^.	c #D5D73C",
"/.	c #C5C742",
"(.	c #BBBD3F",
"_.	c #9C9E37",
":.	c #8D8F3C",
"<.	c #9D9F51",
"[.	c #B4B654",
"}.	c #CED06D",
"|.	c #D2D483",
"1.	c #D7DAB3",
"2.	c #DBDFEC",
"3.	c #5F606B",
"4.	c #AAAB90",
"5.	c #CFD160",
"6.	c #D6D86A",
"7.	c #BCBE63",
"8.	c #96983D",
"9.	c #8B8D36",
"0.	c #8C8E36",
"a.	c #C4C641",
"b.	c #D9DB45",
"c.	c #D6D854",
"d.	c #DDE156",
"e.	c #E7E940",
"f.	c #EDF037",
"g.	c #F3F62E",
"h.	c #F4F72C",
"i.	c #F5F82A",
"j.	c #F5F82B",
"k.	c #F6F929",
"l.	c #F3F62D",
"m.	c #F4F72B",
"n.	c #F2F52E",
"o.	c #EFF133",
"p.	c #EBEE32",
"q.	c #E8EB34",
"r.	c #C2C43B",
"s.	c #858748",
"t.	c #85873F",
"u.	c #B7B95C",
"v.	c #D0D27A",
"w.	c #CDD08B",
"x.	c #D1D4D3",
"y.	c #929379",
"z.	c #CCCE6D",
"A.	c #B9BB62",
"B.	c #979944",
"C.	c #7E8035",
"D.	c #848540",
"E.	c #D0D33A",
"F.	c #F1F338",
"G.	c #E7E93D",
"H.	c #F0F330",
"I.	c #F7FA27",
"J.	c #F6F928",
"K.	c #F6F92A",
"L.	c #ECEE38",
"M.	c #E8EA41",
"N.	c #A7A948",
"O.	c #7A7B47",
"P.	c #919342",
"Q.	c #BABC64",
"R.	c #BCBE86",
"S.	c #DDDFDB",
"T.	c #5D5E5A",
"U.	c #9B9D45",
"V.	c #9C9E42",
"W.	c #787A39",
"X.	c #7B7D3B",
"Y.	c #ADAF43",
"Z.	c #F0F235",
"`.	c #F5F82D",
" +	c #F3F62C",
".+	c #F7FA28",
"++	c #EFF239",
"@+	c #CFD256",
"#+	c #7F805E",
"$+	c #858746",
"%+	c #8F9049",
"&+	c #A0A298",
"*+	c #7A7C48",
"=+	c #8D8F35",
"-+	c #88894A",
";+	c #D0D245",
">+	c #E1E345",
",+	c #ECEE36",
"'+	c #F6F92B",
")+	c #DADB4F",
"!+	c #808246",
"~+	c #7E7F49",
"{+	c #707147",
"]+	c #8D8E9C",
"^+	c #818349",
"/+	c #77783B",
"(+	c #5E5E4C",
"_+	c #D8DA4A",
":+	c #E0E244",
"<+	c #EBED36",
"[+	c #EAED37",
"}+	c #EBED39",
"|+	c #7A7B77",
"1+	c #65663B",
"2+	c #6A6B3F",
"3+	c #A6A8B4",
"4+	c #797B5A",
"5+	c #454548",
"6+	c #C1C23F",
"7+	c #EEF137",
"8+	c #ECEF34",
"9+	c #F7FA29",
"0+	c #F8FB30",
"a+	c #959782",
"b+	c #90914B",
"c+	c #4D4E48",
"d+	c #555647",
"e+	c #696A71",
"f+	c #70713D",
"g+	c #F1F42F",
"h+	c #E7E93C",
"i+	c #EFF132",
"j+	c #F8FB28",
"k+	c #F0F322",
"l+	c #BABC6C",
"m+	c #888970",
"n+	c #BFC158",
"o+	c #5D5E3F",
"p+	c #838483",
"q+	c #8C8E39",
"r+	c #E9EC40",
"s+	c #F0F42F",
"t+	c #CED047",
"u+	c #848587",
"v+	c #676871",
"w+	c #8F909A",
"x+	c #585862",
"y+	c #696A74",
"z+	c #E4EAEF",
"A+	c #BABDB8",
"B+	c #C7CA58",
"C+	c #EDF029",
"D+	c #D7DA44",
"E+	c #A3A57E",
"F+	c #8F9181",
"G+	c #C6C763",
"H+	c #ACAD75",
"I+	c #71727E",
"J+	c #8A8B95",
"K+	c #7A7B86",
"L+	c #D7DCE2",
"M+	c #D7DDE5",
"N+	c #C6CAD1",
"O+	c #C8CA8F",
"P+	c #E5E742",
"Q+	c #FBFE22",
"R+	c #F8FB26",
"S+	c #FCFF27",
"T+	c #D3D53E",
"U+	c #ABAC80",
"V+	c #8B8C91",
"W+	c #AFB15E",
"X+	c #E8EB35",
"Y+	c #FAFD25",
"Z+	c #B1B276",
"`+	c #7A7B85",
" @	c #71727D",
".@	c #DBE0E5",
"+@	c #D3D9E1",
"@@	c #CED3DB",
"#@	c #BDC1C8",
"$@	c #BFC3CB",
"%@	c #C1C275",
"&@	c #EDF038",
"*@	c #DADC53",
"=@	c #9D9E83",
"-@	c #9192A2",
";@	c #94965E",
">@	c #E3E62F",
",@	c #F2F52F",
"'@	c #B7B873",
")@	c #9B9CA9",
"!@	c #757681",
"~@	c #73747F",
"{@	c #898A94",
"]@	c #CAD0D7",
"^@	c #BCBFC6",
"/@	c #B5B8C6",
"(@	c #A9ABB9",
"_@	c #C0C394",
":@	c #CDD05F",
"<@	c #E2E44A",
"[@	c #E7EA3F",
"}@	c #EEF138",
"|@	c #F1F431",
"1@	c #F9FC27",
"2@	c #F8FC26",
"3@	c #F8FB25",
"4@	c #F7FA26",
"5@	c #F3F62B",
"6@	c #E7EA34",
"7@	c #E5E844",
"8@	c #DCDF58",
"9@	c #C2C589",
"0@	c #9FA192",
"a@	c #B3B5A7",
"b@	c #A8AA6C",
"c@	c #D2D52C",
"d@	c #F5F838",
"e@	c #D9DC45",
"f@	c #B5B76A",
"g@	c #929497",
"h@	c #C2C6D4",
"i@	c #9B9CA4",
"j@	c #82838C",
"k@	c #D2D8E0",
"l@	c #D4DAE3",
"m@	c #CBD0D8",
"n@	c #C9CED6",
"o@	c #BEC2CD",
"p@	c #B5B8C7",
"q@	c #B2B5C3",
"r@	c #BBBEB8",
"s@	c #B9BA9C",
"t@	c #C1C394",
"u@	c #B9BA7E",
"v@	c #A9AB5F",
"w@	c #A9AA5E",
"x@	c #AEB066",
"y@	c #B7B871",
"z@	c #CECF88",
"A@	c #C9CC88",
"B@	c #CDD19C",
"C@	c #CACEA6",
"D@	c #CCCFBA",
"E@	c #C2C4C1",
"F@	c #BDC098",
"G@	c #CFD171",
"H@	c #D3D64E",
"I@	c #CACC41",
"J@	c #D6D85E",
"K@	c #BABB71",
"L@	c #929380",
"M@	c #7E7F8E",
"N@	c #9495A3",
"O@	c #CFD5DE",
"P@	c #C7CBD3",
"Q@	c #8E8F98",
"R@	c #747580",
"S@	c #777883",
"T@	c #94959D",
"U@	c #E1E6E8",
"V@	c #D1D8E0",
"W@	c #D1D7DF",
"X@	c #CED4DC",
"Y@	c #B5BAC2",
"Z@	c #9698A1",
"`@	c #83848D",
" #	c #717279",
".#	c #5D5D65",
"+#	c #656671",
"@#	c #6A6A61",
"##	c #898A7D",
"$#	c #81825C",
"%#	c #979969",
"&#	c #B3B57E",
"*#	c #C3C57F",
"=#	c #BFC062",
"-#	c #D0D26E",
";#	c #D1D59B",
">#	c #B3B69C",
",#	c #A6A8A6",
"'#	c #858688",
")#	c #76777F",
"!#	c #7B7C86",
"~#	c #A1A2A9",
"{#	c #C8CDD5",
"]#	c #BBBFC6",
"^#	c #878892",
"/#	c #D4DBE3",
"(#	c #D4DAE2",
"_#	c #AEAFB6",
":#	c #9A9BA4",
"<#	c #5A5A61",
"[#	c #4D4D53",
"}#	c #55555D",
"|#	c #858694",
"1#	c #8B8C99",
"2#	c #888997",
"3#	c #9EA0AD",
"4#	c #CBD0DE",
"5#	c #D3D9E8",
"6#	c #D0D6E2",
"7#	c #B8BAC2",
"8#	c #74757F",
"9#	c #737480",
"0#	c #7B7C87",
"a#	c #C5CAD2",
"b#	c #B0B1B9",
"c#	c #DBE1E5",
"d#	c #B6B9C0",
"e#	c #A3A4AC",
"f#	c #4E4E54",
"g#	c #48484D",
"h#	c #767782",
"i#	c #6B7283",
"j#	c #70727D",
"k#	c #94959E",
"l#	c #C1C5CC",
"m#	c #D0D6DE",
"n#	c #B7BAC0",
"o#	c #7D7D88",
"p#	c #6D7485",
"q#	c #A3A4AB",
"r#	c #AEAFB7",
"s#	c #A6A6AE",
"t#	c #7F808A",
"u#	c #6A6A74",
"v#	c #E7EBEC",
"w#	c #D5DBE3",
"x#	c #D6DCE4",
"y#	c #D6DDE5",
"z#	c #C3C7CF",
"A#	c #595960",
"B#	c #5A5A62",
"C#	c #767681",
"D#	c #727481",
"E#	c #72737F",
"F#	c #95969F",
"G#	c #C2C5CD",
"H#	c #AAABB2",
"I#	c #A6A7AE",
"J#	c #7D7E88",
"K#	c #E7E9E7",
"L#	c #DFE2E2",
"M#	c #C5C7CA",
"N#	c #BFC3C7",
"O#	c #A4ABB4",
"P#	c #A6AAB3",
"Q#	c #A4A8B2",
"R#	c #A2A8B3",
"S#	c #8A909D",
"T#	c #848A98",
"U#	c #838A98",
"V#	c #848A97",
"W#	c #848893",
"X#	c #999DA7",
"Y#	c #9EA2AC",
"Z#	c #7A7A84",
"`#	c #686871",
" $	c #6B6B74",
".$	c #67748A",
"+$	c #74747F",
"@$	c #72737E",
"#$	c #7E7F89",
"$$	c #ABACB3",
"%$	c #797A84",
"&$	c #D3D4D6",
"*$	c #A6B8C8",
"=$	c #9AABC1",
"-$	c #8EA6BE",
";$	c #A5B6CA",
">$	c #A1B8D1",
",$	c #97C1E3",
"'$	c #9CB9D5",
")$	c #89ADD3",
"!$	c #85AAD2",
"~$	c #6CA3D6",
"{$	c #489BDD",
"]$	c #377DBD",
"^$	c #316FB0",
"/$	c #3571B0",
"($	c #326194",
"_$	c #3A6A9E",
":$	c #5082B4",
"<$	c #7A9FC1",
"[$	c #7C99B9",
"}$	c #8C9DB4",
"|$	c #8997A9",
"1$	c #9C989C",
"2$	c #88868E",
"3$	c #797881",
"4$	c #93949D",
"5$	c #C3C7CE",
"6$	c #B4B6BD",
"7$	c #8A8B94",
"8$	c #80818B",
"9$	c #A9AAB1",
"0$	c #9A9BA3",
"a$	c #7C7D87",
"b$	c #BEBEC1",
"c$	c #B3B0B2",
"d$	c #94ACC6",
"e$	c #679AC8",
"f$	c #84A6C5",
"g$	c #99B1CA",
"h$	c #ABC2DA",
"i$	c #94B5D7",
"j$	c #8EB1D6",
"k$	c #92B2D4",
"l$	c #96B6D8",
"m$	c #9BB8D9",
"n$	c #98B8DA",
"o$	c #89C0EA",
"p$	c #48ADF1",
"q$	c #3386CD",
"r$	c #3372B5",
"s$	c #3373B6",
"t$	c #3374B7",
"u$	c #316FB2",
"v$	c #3188CF",
"w$	c #3298E2",
"x$	c #5BAFEA",
"y$	c #5C9BD2",
"z$	c #5B98CC",
"A$	c #6B90B9",
"B$	c #8AA4BD",
"C$	c #AFAAAC",
"D$	c #AFB2B8",
"E$	c #CACFD7",
"F$	c #B1B2B9",
"G$	c #757680",
"H$	c #A0A1A8",
"I$	c #777882",
"J$	c #DDE0DE",
"K$	c #A8ABB2",
"L$	c #75849B",
"M$	c #577DA9",
"N$	c #467FBB",
"O$	c #85A1C1",
"P$	c #B5C9DE",
"Q$	c #93B5D9",
"R$	c #95B6D9",
"S$	c #92B4D8",
"T$	c #91B3D8",
"U$	c #8FB1D5",
"V$	c #8AB0D6",
"W$	c #72A0C9",
"X$	c #608FC1",
"Y$	c #528FC7",
"Z$	c #3A81C2",
"`$	c #25578D",
" %	c #245589",
".%	c #275A90",
"+%	c #306CAC",
"@%	c #3388CE",
"#%	c #3194DE",
"$%	c #41A3E7",
"%%	c #42A4E8",
"&%	c #38A0E9",
"*%	c #3188D0",
"=%	c #377FC1",
"-%	c #96B2CD",
";%	c #A3A8B4",
">%	c #9B9DA6",
",%	c #747581",
"'%	c #686972",
")%	c #81828C",
"!%	c #9E9FA7",
"~%	c #70717D",
"{%	c #AFB4BB",
"]%	c #7488A3",
"^%	c #4877AB",
"/%	c #376FAA",
"(%	c #5099D3",
"_%	c #67BBF3",
":%	c #8CBEE7",
"<%	c #8DB5DC",
"[%	c #87ADD4",
"}%	c #779AC1",
"|%	c #5B90C1",
"1%	c #4475A5",
"2%	c #28649A",
"3%	c #164375",
"4%	c #143F6E",
"5%	c #123965",
"6%	c #1B3B61",
"7%	c #1E4973",
"8%	c #234A73",
"9%	c #1C4A76",
"0%	c #1C4874",
"a%	c #1C426D",
"b%	c #1B416B",
"c%	c #183960",
"d%	c #15355A",
"e%	c #1A3657",
"f%	c #1C426E",
"g%	c #1E4674",
"h%	c #28629C",
"i%	c #2A6DAA",
"j%	c #2F79BA",
"k%	c #3490D8",
"l%	c #2974BB",
"m%	c #4375AA",
"n%	c #97B5D1",
"o%	c #777782",
"p%	c #888992",
"q%	c #ADAEB5",
"r%	c #ACADB4",
"s%	c #6F707C",
"t%	c #9FA0A5",
"u%	c #99AEC2",
"v%	c #4471A1",
"w%	c #2E67A3",
"x%	c #3172B5",
"y%	c #3270B2",
"z%	c #3390DA",
"A%	c #3A96DE",
"B%	c #5085B5",
"C%	c #3B6EA2",
"D%	c #294F79",
"E%	c #1B3F68",
"F%	c #143863",
"G%	c #25476D",
"H%	c #34648E",
"I%	c #4B7CA7",
"J%	c #579DCF",
"K%	c #58A1D6",
"L%	c #59A3D7",
"M%	c #4DABE6",
"N%	c #39A6E6",
"O%	c #3192D8",
"P%	c #3191D7",
"Q%	c #308FD5",
"R%	c #308BD0",
"S%	c #308ACF",
"T%	c #2E85C7",
"U%	c #2C7DBD",
"V%	c #2F72AC",
"W%	c #205B8E",
"X%	c #28537F",
"Y%	c #163459",
"Z%	c #1E395A",
"`%	c #1A416C",
" &	c #1E4877",
".&	c #27588F",
"+&	c #3371B3",
"@&	c #3272B5",
"#&	c #317DC2",
"$&	c #79A3CB",
"%&	c #B6BAC3",
"&&	c #6D6E79",
"*&	c #70717C",
"=&	c #C4C5C5",
"-&	c #8C8E97",
";&	c #86ABCC",
">&	c #346DA8",
",&	c #3271B2",
"'&	c #3372B4",
")&	c #3271B3",
"!&	c #2B629C",
"~&	c #1F4A79",
"{&	c #183C64",
"]&	c #193D64",
"^&	c #294E74",
"/&	c #4D83B0",
"(&	c #62B2EB",
"_&	c #63BCF6",
":&	c #59BAF6",
"<&	c #4AB1F2",
"[&	c #47ABEE",
"}&	c #37A5EC",
"|&	c #339CE6",
"1&	c #339BE6",
"2&	c #349CE6",
"3&	c #2D73AE",
"4&	c #294C70",
"5&	c #243F5D",
"6&	c #183C65",
"7&	c #1B426C",
"8&	c #2B619A",
"9&	c #2E81C9",
"0&	c #728FAE",
"a&	c #ADADB3",
"b&	c #AFB0B6",
"c&	c #AFAFB1",
"d&	c #8D98A8",
"e&	c #619AD0",
"f&	c #296AB0",
"g&	c #3474B7",
"h&	c #2F6AA8",
"i&	c #25588E",
"j&	c #1F436C",
"k&	c #1C3C61",
"l&	c #28547D",
"m&	c #497EA8",
"n&	c #61B1E7",
"o&	c #60C0FD",
"p&	c #50B5F6",
"q&	c #41A6EB",
"r&	c #30A3EC",
"s&	c #329FE8",
"t&	c #35A1EA",
"u&	c #33AAF1",
"v&	c #3DABF0",
"w&	c #32B2F8",
"x&	c #31B4FA",
"y&	c #31B4F9",
"z&	c #32B0F7",
"A&	c #33A7EF",
"B&	c #33A9F1",
"C&	c #32ABF2",
"D&	c #32A8F0",
"E&	c #33A4ED",
"F&	c #33A2EB",
"G&	c #33A4EC",
"H&	c #33A0E9",
"I&	c #349DE7",
"J&	c #34A0EA",
"K&	c #35A3F0",
"L&	c #2F8AD0",
"M&	c #2D5986",
"N&	c #264365",
"O&	c #1E3959",
"P&	c #204671",
"Q&	c #2A629C",
"R&	c #2A7DC6",
"S&	c #759EC9",
"T&	c #86858D",
"U&	c #96979F",
"V&	c #6F707B",
"W&	c #567090",
"X&	c #9A9EA6",
"Y&	c #C1C6CA",
"Z&	c #A4A3A7",
"`&	c #7897B4",
" *	c #4282C1",
".*	c #306FB2",
"+*	c #2F6BAA",
"@*	c #215083",
"#*	c #1B416A",
"$*	c #203858",
"%*	c #286090",
"&*	c #3291CE",
"**	c #46AAED",
"=*	c #49ACF0",
"-*	c #39A2EA",
";*	c #339DE7",
">*	c #37A4EC",
",*	c #3AACF1",
"'*	c #35ADF4",
")*	c #35ADF3",
"!*	c #37B0F6",
"~*	c #31B0F7",
"{*	c #31B0F6",
"]*	c #32B1F7",
"^*	c #31B3F9",
"/*	c #32AFF6",
"(*	c #32B0F6",
"_*	c #33A1EA",
":*	c #3499E4",
"<*	c #3184C7",
"[*	c #2E5A89",
"}*	c #2A394D",
"|*	c #233D5C",
"1*	c #204A78",
"2*	c #316DAC",
"3*	c #7F8B9F",
"4*	c #70707B",
"5*	c #A8A9B0",
"6*	c #8FB2D1",
"7*	c #758FAC",
"8*	c #7F808B",
"9*	c #6D7F98",
"0*	c #8F8D95",
"a*	c #5DA0D5",
"b*	c #327FC4",
"c*	c #3378BC",
"d*	c #3373B5",
"e*	c #285C93",
"f*	c #173C65",
"g*	c #223D5C",
"h*	c #2A517A",
"i*	c #308FD3",
"j*	c #339BE5",
"k*	c #32ADF4",
"l*	c #33ACF3",
"m*	c #33ADF4",
"n*	c #32B3F9",
"o*	c #349BE5",
"p*	c #327CBC",
"q*	c #2C415C",
"r*	c #253E5C",
"s*	c #234062",
"t*	c #486385",
"u*	c #6D6C75",
"v*	c #868790",
"w*	c #6282A7",
"x*	c #9FA1A8",
"y*	c #A0B6CC",
"z*	c #3D83C3",
"A*	c #3191DB",
"B*	c #3484C9",
"C*	c #306BAA",
"D*	c #1D4572",
"E*	c #18395E",
"F*	c #21446B",
"G*	c #316EA0",
"H*	c #349CE8",
"I*	c #33ABF2",
"J*	c #32AAF1",
"K*	c #32AEF5",
"L*	c #32AEF4",
"M*	c #368ACB",
"N*	c #2F5071",
"O*	c #2E3F54",
"P*	c #354D69",
"Q*	c #686D7B",
"R*	c #8A8E9A",
"S*	c #A4A5AC",
"T*	c #9899A2",
"U*	c #3A6596",
"V*	c #9DAFC4",
"W*	c #2060A4",
"X*	c #3275B8",
"Y*	c #3482C7",
"Z*	c #255488",
"`*	c #183F69",
" =	c #1D3859",
".=	c #30608E",
"+=	c #3189D0",
"@=	c #349EEA",
"#=	c #349AE4",
"$=	c #33A3EC",
"%=	c #32AFF5",
"&=	c #33A3EB",
"*=	c #39A2EB",
"==	c #4CA2E2",
"-=	c #334E6F",
";=	c #374A62",
">=	c #575A66",
",=	c #6C7D97",
"'=	c #9A999F",
")=	c #648BB7",
"!=	c #3675B6",
"~=	c #3C77B6",
"{=	c #306EAE",
"]=	c #2E68A5",
"^=	c #214D7E",
"/=	c #173B64",
"(=	c #263850",
"_=	c #2B71AB",
":=	c #359BE5",
"<=	c #32B1F8",
"[=	c #66A8D9",
"}=	c #324562",
"|=	c #585F6D",
"1=	c #33455C",
"2=	c #7F8A9D",
"3=	c #AEAEB4",
"4=	c #91B9DB",
"5=	c #3777B8",
"6=	c #235386",
"7=	c #1A3C62",
"8=	c #284465",
"9=	c #3284C5",
"0=	c #349DE8",
"a=	c #32ACF3",
"b=	c #34A0E9",
"c=	c #41A4E8",
"d=	c #5790C3",
"e=	c #414854",
"f=	c #424A55",
"g=	c #7F7E88",
"h=	c #A1A2AA",
"i=	c #4376AD",
"j=	c #1A3F69",
"k=	c #163B64",
"l=	c #243C58",
"m=	c #2F79B6",
"n=	c #349EE9",
"o=	c #33A6EE",
"p=	c #449BDB",
"q=	c #7F8B99",
"r=	c #8D8E96",
"s=	c #7B7C82",
"t=	c #999BA3",
"u=	c #326398",
"v=	c #183B63",
"w=	c #1C3D62",
"x=	c #213956",
"y=	c #2B6FA9",
"z=	c #32AAF2",
"A=	c #328AD1",
"B=	c #689DCD",
"C=	c #8C8C91",
"D=	c #A4A6AC",
"E=	c #ABAEB4",
"F=	c #ACADB3",
"G=	c #3A699B",
"H=	c #225083",
"I=	c #1C3C5F",
"J=	c #25598B",
"K=	c #349EE8",
"L=	c #328CD3",
"M=	c #3E71AA",
"N=	c #4B5A70",
"O=	c #969799",
"P=	c #274F7B",
"Q=	c #193E67",
"R=	c #193C64",
"S=	c #1F426A",
"T=	c #3188CE",
"U=	c #33A8F0",
"V=	c #33A9F0",
"W=	c #349AE5",
"X=	c #318BD3",
"Y=	c #5279A5",
"Z=	c #565A67",
"`=	c #484D55",
" -	c #9E9FA6",
".-	c #83909D",
"+-	c #153F6D",
"@-	c #193D65",
"#-	c #275D92",
"$-	c #349DE6",
"%-	c #33A0EA",
"&-	c #32ABF3",
"*-	c #349EE7",
"=-	c #328BD3",
"--	c #4476AE",
";-	c #5D5C63",
">-	c #696970",
",-	c #6A819B",
"'-	c #123760",
")-	c #1A4069",
"!-	c #3184C9",
"~-	c #349CE7",
"{-	c #338CD3",
"]-	c #2A66A6",
"^-	c #5E5D64",
"/-	c #51657F",
"(-	c #143A63",
"_-	c #3597E2",
":-	c #347FC4",
"<-	c #1C4B80",
"[-	c #65646C",
"}-	c #455A75",
"|-	c #153A63",
"1-	c #173A61",
"2-	c #2B65A0",
"3-	c #34A2ED",
"4-	c #339EE7",
"5-	c #33AAF2",
"6-	c #32A9F1",
"7-	c #349BE4",
"8-	c #2F79BB",
"9-	c #214268",
"0-	c #788EA2",
"a-	c #113660",
"b-	c #17395F",
"c-	c #3376B9",
"d-	c #34A0EB",
"e-	c #33A5ED",
"f-	c #3399E3",
"g-	c #2C639E",
"h-	c #798392",
"i-	c #90919A",
"j-	c #153A64",
"k-	c #3479BD",
"l-	c #33A5EF",
"m-	c #32B3F8",
"n-	c #339EE8",
"o-	c #3394DB",
"p-	c #4B7BAF",
"q-	c #7B7E8A",
"r-	c #3C5C7F",
"s-	c #16375E",
"t-	c #347BC0",
"u-	c #339DE6",
"v-	c #349FE8",
"w-	c #31ABF3",
"x-	c #30ABF3",
"y-	c #40A7EA",
"z-	c #5B7C9A",
"A-	c #5F768F",
"B-	c #15385F",
"C-	c #2E6AA7",
"D-	c #31B2F8",
"E-	c #30AFF6",
"F-	c #41B4F6",
"G-	c #5EBAF4",
"H-	c #4DB9F8",
"I-	c #5CA7DC",
"J-	c #ABACB2",
"K-	c #2B496C",
"L-	c #24568A",
"M-	c #358FD8",
"N-	c #33A7F0",
"O-	c #38AEF4",
"P-	c #4DB8F7",
"Q-	c #52B7F5",
"R-	c #3AB4F8",
"S-	c #3AB5F9",
"T-	c #5AACE7",
"U-	c #ACACB2",
"V-	c #EAECEB",
"W-	c #748395",
"X-	c #0F3560",
"Y-	c #347CBF",
"Z-	c #33AFF5",
"`-	c #41B5F7",
" ;	c #52B9F6",
".;	c #43B3F5",
"+;	c #33AEF5",
"@;	c #50B8F6",
"#;	c #47B7F8",
"$;	c #5FA7D9",
"%;	c #D5DAE1",
"&;	c #7B8A9D",
"*;	c #1C518C",
"=;	c #3391D8",
"-;	c #30B3F9",
";;	c #52B8F6",
">;	c #5ABAF5",
",;	c #33B2F8",
"';	c #38AFF5",
");	c #57B9F5",
"!;	c #5FBAF5",
"~;	c #40B6F8",
"{;	c #6DB4E3",
"];	c #E5EAEA",
"^;	c #718AA7",
"/;	c #3172B3",
"(;	c #3398E1",
"_;	c #4BB7F6",
":;	c #5BBAF5",
"<;	c #35AEF4",
"[;	c #57BAF6",
"};	c #60BBF4",
"|;	c #5EBAF5",
"1;	c #3DB2F6",
"2;	c #D9DFE4",
"3;	c #CCD2DB",
"4;	c #899FB8",
"5;	c #3F71A8",
"6;	c #2E92DC",
"7;	c #33A5EE",
"8;	c #32A5EE",
"9;	c #31AEF5",
"0;	c #30B2F9",
"a;	c #34B3F8",
"b;	c #44B6F7",
"c;	c #5FBBF5",
"d;	c #5DBBF5",
"e;	c #49B3F4",
"f;	c #37B0F5",
"g;	c #5DBAF5",
"h;	c #61BBF4",
"i;	c #61BBF5",
"j;	c #54B7F4",
"k;	c #36B2F6",
"l;	c #D5DBE2",
"m;	c #D3D8DE",
"n;	c #B3BDCB",
"o;	c #658AB3",
"p;	c #2D87CF",
"q;	c #319EE9",
"r;	c #2EB1F8",
"s;	c #3CB3F7",
"t;	c #3CB5F8",
"u;	c #31B2F9",
"v;	c #2EB2F9",
"w;	c #3BB4F8",
"x;	c #69BDF3",
"y;	c #45B6F7",
"z;	c #3CB4F8",
"A;	c #43B4F6",
"B;	c #57B8F5",
"C;	c #60BBF5",
"D;	c #5CB7F3",
"E;	c #36A4EC",
"F;	c #31ADF4",
"G;	c #DEE3E6",
"H;	c #D1D5DC",
"I;	c #A5ACB8",
"J;	c #5898CB",
"K;	c #359CE5",
"L;	c #3499E3",
"M;	c #32A6EE",
"N;	c #3EB5F8",
"O;	c #2FB2F9",
"P;	c #5AB9F5",
"Q;	c #33B3F8",
"R;	c #6FBEF2",
"S;	c #6ABCF3",
"T;	c #37B3F8",
"U;	c #62BCF5",
"V;	c #3AA5EC",
"W;	c #D6DCE3",
"X;	c #D7DDE4",
"Y;	c #D5D6DB",
"Z;	c #B4B7BE",
"`;	c #76A1C8",
" >	c #4F98D0",
".>	c #4096D7",
"+>	c #2F96DF",
"@>	c #2FA7F2",
"#>	c #30AEF6",
"$>	c #30B0F8",
"%>	c #3EA6EC",
"&>	c #4FB7F5",
"*>	c #39B3F8",
"=>	c #39B4F8",
"->	c #40B5F7",
";>	c #48B6F7",
">>	c #43B6F7",
",>	c #4EB8F6",
"'>	c #62BCF4",
")>	c #70BEF3",
"!>	c #72BDF1",
"~>	c #6DBCF2",
"{>	c #59B9F5",
"]>	c #55B9F5",
"^>	c #63BBF4",
"/>	c #5AB6F3",
"(>	c #389EE6",
"_>	c #E2E7E8",
":>	c #D5DAE2",
"<>	c #D5D8DE",
"[>	c #C2C8D2",
"}>	c #B4C3D3",
"|>	c #9AB2C9",
"1>	c #7794AD",
"2>	c #538DC0",
"3>	c #438DC2",
"4>	c #3B8ECB",
"5>	c #2B9EEA",
"6>	c #2EA9F6",
"7>	c #2FA8F5",
"8>	c #2DA5F1",
"9>	c #2CA3EF",
"0>	c #2B9EEC",
"a>	c #2A9CEB",
"b>	c #2892E1",
"c>	c #2E97E1",
"d>	c #45B8F9",
"e>	c #42B1F3",
"f>	c #5EBBF4",
"g>	c #62BBF4",
"h>	c #66BCF3",
"i>	c #6EBEF3",
"j>	c #70BEF2",
"k>	c #6EBEF2",
"l>	c #66BCF4",
"m>	c #62BBF5",
"n>	c #57B6F3",
"o>	c #379EE7",
"p>	c #31A8F1",
"q>	c #DADFE4",
"r>	c #B0B4BC",
"s>	c #A4A7B1",
"t>	c #6F7583",
"u>	c #8496AD",
"v>	c #8899B0",
"w>	c #9BADC4",
"x>	c #A3A6B1",
"y>	c #AFB2B7",
"z>	c #C7C9CC",
"A>	c #E1E6E7",
"B>	c #A6C8E4",
"C>	c #35AFF6",
"D>	c #39B3F7",
"E>	c #6DBDF3",
"F>	c #6BBCF4",
"G>	c #65BCF4",
"H>	c #5FBAF4",
"I>	c #66BDF5",
"J>	c #3BA0E8",
"K>	c #D8DEE6",
"L>	c #DCE2E9",
"M>	c #DCE1E8",
"N>	c #D8DDE4",
"O>	c #D7DCE3",
"P>	c #D5DBE4",
"Q>	c #D3DAE2",
"R>	c #D4D8E0",
"S>	c #8CC5EC",
"T>	c #6FBEF4",
"U>	c #3DA1E8",
"V>	c #DFE4E7",
"W>	c #D3D9E0",
"X>	c #B6D0E4",
"Y>	c #D8DDE3",
"Z>	c #D2D8E1",
"`>	c #D2D9E1",
" ,	c #9BC7E8",
".,	c #64BBF4",
"+,	c #63BBF5",
"@,	c #6BBDF3",
"#,	c #DDE2E6",
"$,	c #D0D8E1",
"%,	c #78C0F0",
"&,	c #67BDF3",
"*,	c #6CBDF3",
"=,	c #D6DCE2",
"-,	c #D8DAE0",
";,	c #9AC5E6",
">,	c #68BCF4",
",,	c #EDF1EE",
"',	c #D1D7E0",
"),	c #D5D9E0",
"!,	c #65BBF4",
"~,	c #E0E5E7",
"{,	c #D4DAE1",
"],	c #D7DBE1",
"^,	c #A0CCEA",
"/,	c #67BCF3",
"(,	c #63BCF4",
"_,	c #6EBDF2",
":,	c #71BDF0",
"<,	c #E3E8E9",
"[,	c #E4E8EA",
"},	c #D6E0E7",
"|,	c #82BEEA",
"1,	c #67BCF4",
"2,	c #95B5D8",
"3,	c #D8DEE3",
"4,	c #C9D3DF",
"5,	c #7CBDEC",
"6,	c #68BDF4",
"7,	c #6CBEF3",
"8,	c #83BAE6",
"9,	c #A4BCD8",
"0,	c #D2D1D6",
"a,	c #88C5EF",
"b,	c #66BBF4",
"c,	c #6ABDF3",
"d,	c #92B9DE",
"e,	c #C3D0DE",
"f,	c #E0E4E7",
"g,	c #D6D9E0",
"h,	c #98C5E7",
"i,	c #6BBDF4",
"j,	c #7BBAE9",
"k,	c #A8BFD9",
"l,	c #D8DCE1",
"m,	c #9DC3E3",
"n,	c #6ABDF4",
"o,	c #6BBEF4",
"p,	c #89B4DC",
"q,	c #D0D7E0",
"r,	c #E3E7E9",
"s,	c #CDD3DE",
"t,	c #76BBED",
"u,	c #6FBCF0",
"v,	c #ACC6DE",
"w,	c #D4D9E1",
"x,	c #D9DBE1",
"y,	c #81B8E2",
"z,	c #69BCF3",
"A,	c #79BAEA",
"B,	c #CDD6E1",
"C,	c #D7DAE0",
"D,	c #96C4E5",
"E,	c #57B2F0",
"F,	c #6ABCF4",
"G,	c #91BFE4",
"H,	c #CFD6E0",
"I,	c #9ECBEA",
"J,	c #54B0EE",
"K,	c #ADCAE2",
"L,	c #ECEFED",
"M,	c #AFC9E0",
"N,	c #54B1F0",
"O,	c #7BBDEC",
"P,	c #C3CEDC",
"Q,	c #BFC4CD",
"R,	c #CFD4DB",
"S,	c #70BBEF",
"T,	c #6CBEF4",
"U,	c #93BCE1",
"V,	c #D1D6DE",
"W,	c #A5ADBB",
"X,	c #457BB4",
"Y,	c #367BBD",
"Z,	c #A4C8E5",
"`,	c #64BCF4",
" '	c #75BCEF",
".'	c #A5B9D1",
"+'	c #D6DBE2",
"@'	c #C6CCD5",
"#'	c #7B9CC0",
"$'	c #3670B0",
"%'	c #359BE4",
"&'	c #C8D3E0",
"*'	c #7DBDEB",
"='	c #6FBEF3",
"-'	c #6DBEF3",
";'	c #73B2E2",
">'	c #AABFD3",
",'	c #CACFD8",
"''	c #CFD5DD",
")'	c #A2A8B4",
"!'	c #5A88BA",
"~'	c #328ED6",
"{'	c #E0E5E8",
"]'	c #D6DAE0",
"^'	c #AFC4D8",
"/'	c #4FAAE9",
"('	c #4CACED",
"_'	c #4EAAEA",
":'	c #49A6E7",
"<'	c #79ABD4",
"['	c #7BA3CA",
"}'	c #6C98C7",
"|'	c #3379BC",
"1'	c #B9BFC8",
"2'	c #9EB6D2",
"3'	c #8DB2D8",
"4'	c #6BB2E7",
"5'	c #35A0E9",
"6'	c #378DD3",
"7'	c #3576B9",
"8'	c #3776B7",
"9'	c #3976B6",
"0'	c #3473B4",
"a'	c #337ABE",
"b'	c #3499E2",
"c'	c #B0B4BE",
"d'	c #95B4D5",
"e'	c #8BB6DE",
"f'	c #68BBF3",
"g'	c #44A5EA",
"h'	c #328CD4",
"i'	c #337CBF",
"j'	c #3498E1",
"k'	c #C4CBD6",
"l'	c #98B4D4",
"m'	c #76B6E7",
"n'	c #4AABEE",
"o'	c #3091DB",
"p'	c #327EC3",
"q'	c #3272B3",
"r'	c #3274B7",
"s'	c #3383C8",
"t'	c #3490D7",
"u'	c #3390D8",
"v'	c #CACED5",
"w'	c #CDD2DA",
"x'	c #AEBDD2",
"y'	c #73B5E6",
"z'	c #35A0EA",
"A'	c #3393DB",
"B'	c #337FC4",
"C'	c #3270B1",
"D'	c #326FB1",
"E'	c #3381C6",
"F'	c #348FD7",
"G'	c #3395DD",
"H'	c #339AE4",
"I'	c #DBDFE3",
"J'	c #BFC3CA",
"K'	c #CBD1DB",
"L'	c #98BBDC",
"M'	c #40A2E7",
"N'	c #3289D0",
"O'	c #3273B6",
"P'	c #3272B4",
"Q'	c #D7DCE1",
"R'	c #C7CCD4",
"S'	c #CAD1DC",
"T'	c #59A1D9",
"U'	c #3175B9",
"V'	c #3378BB",
"W'	c #3374B6",
"X'	c #3386CC",
"Y'	c #339CE7",
"Z'	c #D7DCE0",
"`'	c #CACED4",
" )	c #B4C9DC",
".)	c #407FBC",
"+)	c #326EB0",
"@)	c #3385CA",
"#)	c #3BA6EC",
"$)	c #DCE1E6",
"%)	c #AAC0D8",
"&)	c #3B78B7",
"*)	c #3274B6",
"=)	c #338AD1",
"-)	c #30A3ED",
";)	c #78ADDC",
">)	c #9FB5CD",
",)	c #367ABB",
"')	c #348ED5",
"))	c #32ACF4",
"!)	c #67BDF0",
"~)	c #DCE1E5",
"{)	c #D8DEE4",
"])	c #E2E6E8",
"^)	c #A9C7DF",
"/)	c #389CE4",
"()	c #2FA6EF",
"_)	c #4AB6F6",
":)	c #4FA9E8",
"<)	c #51B8F6",
"[)	c #41ADEF",
"})	c #3AA9EE",
"|)	c #37A0E8",
"1)	c #3EB3F6",
"2)	c #61BCF5",
"3)	c #68BFF2",
"4)	c #59B4ED",
"5)	c #2E9DE8",
"6)	c #46AEF0",
"7)	c #56B7F3",
"8)	c #5BBBF6",
"9)	c #C0D9E9",
"0)	c #76BAEC",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                      . +                                                                       ",
"                                                    @ # $ %           & * = - ; > , ' ) ! ~ { ] ^ / ( _ : < [                   ",
"                                                    } | 1 2 3   4 5 6 7 8 9 0 a b c d e f g h i j k l m 7 7 n o p q             ",
"                                                    r s t u v w x y z A B C D E F h G H I J K L L M N O P Q R S T U V W         ",
"                                                    X Y Z `  ...+.@.#.$.%.&.*.=.-.;.>.,.'.).!.~.~.{.].^./.(._.:.<.[.}.|.1.2.    ",
"                                                  3.4.5.6.7.8.9.0.a.b.c.d.e.f.g.h.i.i.i.j.k.k.i.k.l.m.i.n.o.p.q.r.s.t.u.v.w.x.  ",
"                                                  y.z.A.B.C.D.E.F.G.H.I.I.J.k.i.K.K.K.K.K.K.K.K.i.k.k.H.h.i.H.i.L.M.N.O.P.Q.R.S.",
"                                                T.U.V.W.X.Y.Z.`. +.+k.i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.k.k.k.k.k.J..+++@+#+$+%+&+",
"                                                *+=+W.-+;+>+,+i.k.i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.k.'+)+!+~+{+",
"                                              ]+^+/+(+_+:+<+[+i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i..+}+|+1+2+",
"                                              3+4+5+6+7+.+i.8+i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.9+0+a+b+c+d+",
"                                                e+f+M.m.g+h+i+i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.j+k+l+m+n+o+p+",
"                                                3+q+r+.+k.s+k.i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.k.K.9+t+u+v+w+x+y+  ",
"                                                z+A+B+C+.+k.i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.k.j+.+D+E+F+G+H+I+J+K+  ",
"                                                L+M+N+O+P+Q+J.i.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.K.i.R+S+T+U+V+W+X+Y+Z+J+`+ @  ",
"                                                .@+@@@#@$@%@&@J.k.k.i.K.K.K.K.K.K.K.K.K.K.K.K.i.k.k.R+*@=@-@;@>@.+,@'@)@!@~@{@  ",
"                                                  +@+@]@^@/@(@_@:@<@[@}@|@j.1@1@1@2@3@4@5@H.6@7@8@9@0@a@b@c@d@e@f@g@h@i@!@ @j@  ",
"                                                  k@+@+@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@A@B@C@D@E@F@G@H@I@J@K@L@M@N@O@P@Q@R@S@T@  ",
"                                                  U@V@+@k@+@k@W@W@X@Y@Z@`@ #.#+#@###$#%#&#*#=#-#;#>#,#'#)#!@~@!#~#{#]#^#~@R@    ",
"                                                    +@k@+@+@+@+@k@+@/#(#_#:#R@<#[#}#|#1#2#3#4#5#6#7#`+~@8#9#~@0#~#a#b#^#~@R@    ",
"                                                    c#k@+@+@+@+@+@+@+@W@d#e#~@~@f#g#h#i#j#k#l#+@m#n#o#9#p#8#~@0#q#r#s#t#R@u#    ",
"                                                    v#l@w#w#w#x#y#y#y#y#z#_#~@!@A#B#C#D#E#F#G#+@m#n#o#9#D#8#~@0#e#H#I#J#~@      ",
"                                            K#L#M#N#O#P#Q#Q#R#S#T#U#V#W#X#Y#Z#`+`# $.$+$@$F#G#+@m#n##$~@R@R@~@!#e#$$F#%$~@      ",
"                                        &$*$=$-$;$>$,$'$)$!$~${$]$^$/$($_$:$<$[$}$|$1$2$3$4$5$(#m#6$7$~@R@R@~@8$9$$$0$a$~@      ",
"                                b$c$d$e$f$g$h$i$j$k$l$m$n$n$o$p$q$r$s$t$s$u$v$w$x$y$z$A$B$C$D$E$+@F$J+~@R@~@R@G$T@H$I$~@R@      ",
"                          J$K$L$M$N$O$P$Q$R$Q$S$T$U$V$W$X$Y$Z$`$ % % % %.%+%^$@%#%$%%%&%*%=%-%;%>%I#`+R@R@,%'%)%H#!%~%R@~@      ",
"                        {%]%^%/%(%_%:%<%[%}%|%1%2%3%4%5%6%7%8%9%9%0%a%b%c%d%e%f%g%h%i%j%k%q$l%m%n%q#o%R@R@~@,%p%q%r%s%R@        ",
"                    t%u%v%w%x%y%z%A%B%C%D%E%F%G%H%I%J%K%L%M%N%O%P%Q%R%S%T%U%V%W%X%Y%Z%`% &.&+&@&#&$&%&&&R@R@R@!%$$$$*&@$        ",
"                =&-&;&>&,&'&)&'&!&~&{&]&^&/&(&_&:&<&[&}&|&1&|&|&|&|&|&|&|&2&2&2&2&2&3&4&5&6&7&8&s$9&0&a&s%~@G$b&H#$$*&R@        ",
"              c&d&e&f&r$g&h&i&j&k&l&m&n&o&p&q&r&s&t&u&v&w&x&y&z&A&B&C&A&D&E&F&G&H&I&J&K&L&M&N&O&P&Q&R&S&T&*&U&r%$$$$V&R@        ",
"      W&X&Y&Z&`& *.*g&+*@*#*$*%*&***=*-*;*>*,*'*)*!*~*{*z&w&]*^*^*^*^*^*^*w&/*(*z&B&E&_*I&:*<*[*}*|*1*2*3*4*5*$$$$$$t# @        ",
"  6*7*8*9*0*a*b*c*d*e*f*g*h*i*j*2&2&j*F&k*l*m*C&^*l*^*w&^*^*^*w&n*n*n*n*w&^*w&w&^*l*]*B&F&o*2&j*p*q*r*s*t*u*!%$$$$$$v*#$        ",
"  w*  x*y*z*A*B*C*D*E*F*G*H*I&j*o*H&I*k*J*K*L*/*^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*^*(*L*F&2&|&I&M*N*O*P*Q*R*$$$$H#S*T*        ",
"  U*  V*W*X*Y*Z*`* =.=+=@=|&j*#=$=I*u&z&]*^*^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*(*%=&=2&1&*===-=;=>=,='=r%$$$$r%        ",
"  )=!=~={=]=^=/=(=_=:=2&|&o*I&B&k*^*w&^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*<=l*F&j*j*I&[=}=|=1=2=3=H#$$$$        ",
"  4=5=+*6=~&7=8=9=0=j*j*2&H&a=^*k*/*^*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*(*K*b=j*j*c=d=e=f=g=h=9$$$          ",
"    i=j=j=k=l=m=n=|&j*2&o=K*w&^*^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*L*H&o*2&j*p=q=r=*&s=t=r%          ",
"    u=v=w=x=y=;*2&2&2&z=l*w&^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*n*o=o*2&j*A=B=C=D=E=i@F=          ",
"  G=H={&I=J=K=j*j*2&A&y&^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*L*o=o*2&2&L=M=N=O=d#$$H#          ",
"  P=Q=R=S=T=|&o*o*U=x&w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*V=W=2&2&X=Y=Z=`= -$$H#          ",
".-+-{&@-#-$-o*%-&-^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&y&o=*-o*2&=---;->-5*$$H#          ",
",-'-{&)-!-~-D&y&^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*k*I*W=2&2&{-]-^-^#q%H#$$          ",
"/-(-v=6=_-B&(*^*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*a=U=o*2&#=:-<-[-e#$$$$            ",
"}-|-1-2-3-4-5-^*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*x&6-2&j*2&7-8-9-T@q%H#$$            ",
"0-a-b-c-d-e-n*^*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&u&D&o*2&o*f-g-h-i-r%H#H#            ",
"  j-b-k-l-m-w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*^*z&U=|&j*2&n-o-p-q-h=$$H#H#            ",
"  r-s-t-$-z&w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*]*k*e-u-W=v-B&w-x-y-z-r%H#H#              ",
"  A-B-C-$-a=^*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*w&A&u-o*I&e-D-E-F-G-H-I-J-H#                ",
"    K-L-M-N-^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*w&w&I*$=2&;*A&]*^*O-P-Q-R-S-T-U-                  ",
"  V-W-X-Y-$-z&^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*^*x&z=_*I&*-e-k*^*Z-`- ;.;+;@;#;$;                    ",
"    %;&;*;=;G&]*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*^*w&A&n-o*_*u&]*w&-;m*;;>;,;';);!;~;{;                    ",
"    ];k@^;/;(;%-z&^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*^*w&a=I*K=|&G&k*y&^*]*(*_;:;:;<;O-[;};|;1;                      ",
"      2;3;4;5;6;$=K*<=^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*n*^*^*]*z=U=7;8;9;z&y&n*0;a;b;c;d;e;f;_;g;h;i;j;k;                      ",
"        l;m;n;o;p;q;E&%=^*^*w&n*n*n*n*n*n*n*n*n*n*n*n*n*w&^*6-l*6-L*r;s;t;a;u;v;w;h;x;y;z;A;B;};};C;D;E;F;                      ",
"        G;k@+@H;I;J;K;L;M;k*w&w&^*^*^*^*^*^*^*^*^*^*w&w&^*:=U=D-N;O;P;w;u;Q;a;>;R;S;T;T;!;};};!;C;U;V;D&                        ",
"          W;+@+@X;Y;Z;`; >.>+>@>#>$>u;<=w&w&]*]*(*/*k*%-%>&>*>=>->;>R->>,>'>)>!>~>{>]>^>};C;C;C;C;/>(>$=                        ",
"          _>k@+@k@+@:><>[>}>|>1>2>3>4>5>6>7>8>8>9>0>a>b>c>d>,;e>f>g>h>i>j>R;k>l>m>h;};!;C;C;C;C;C;n>o>p>                        ",
"            q>k@+@+@k@+@+@k@k@k@m#r>s>Q@!#t>u>v>w>x>y>z>A>B>C>D>j>k>k>E>F>G>H>C;C;H>C;C;C;C;C;C;!;I>J>                          ",
"              +@k@+@+@+@+@+@+@+@+@w#x#K>L>M>N>N>O>x#P>Q>R>S>!;g>m>G>c;|;!;!;C;C;C;C;C;C;C;C;C;!;h;T>U>                          ",
"              V>k@+@+@+@+@+@+@+@+@+@+@+@k@k@+@+@+@+@+@+@W>X>l>!;!;!;!;C;C;C;C;C;C;C;C;C;C;C;!;g>g>                              ",
"                Y>k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@Z>`> ,.,!;};C;C;C;C;C;C;C;C;C;C;C;C;!;+,@,                              ",
"                #,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@W>$,%,&,!;};C;C;C;C;C;C;C;C;C;C;C;!;^>*,k>                            ",
"                  =,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@Z>-,;,@,h;!;C;C;C;C;C;C;C;C;C;C;!;C;>,*,k>                            ",
"                  ,,',+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@W>),!,!,!;C;C;C;C;C;C;C;C;C;C;H>i;*,E>k>                            ",
"                    ~,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@k@k@k@{,],^,/,h;};C;C;C;C;C;C;C;C;C;!;(,E>_,:,                            ",
"                      l;k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@G;_><,];[,},|,!,!;};C;C;C;C;C;C;C;C;};1,@,:,2,                            ",
"                      O>k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@O>3,3,=,l;l;4,5,l>|;};C;C;C;C;C;C;};};6,7,8,9,                            ",
"                        {,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@+@0,a,b,c;H>C;C;C;C;C;!;&,c,7,d,e,                            ",
"                        f,V@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@+@g,h,S;C;!;};C;C;!;i;&,i,j,k,l,                            ",
"                          O>k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@W>k@m,n,g>!;};C;H>C;@,o,p,q,+@                            ",
"                          r,k@k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@s,t,@,h;!;C;!;l>@,u,v,w,+@                            ",
"                            Y>k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@x,y,z,^>!;H>C;G>i>A,B,k@k@                            ",
"                            U@{,+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@C,D,E,l>C;!;(,F,_,G,H,k@+@                            ",
"                              +@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@g,I,J,G>!;!;(,E>u,K,W>k@+@                            ",
"                              L,+@k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@%;M,N,G>C;h;l>E>O,P,+@k@Q,                            ",
"                                V>',+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@R,S,n,!;^>c,T,U,',W>V,W,X,Y,                        ",
"                                  =,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@Z>Z,c,l>`,*, '.'+'+@@'#'$'%'                        ",
"                                  #,k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@&'*'z,='-';'>',''')'!'~'|&                        ",
"                                  {'{,+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@]'^'/'('_':'<'['O$}'|'(;j*                        ",
"                                    l;+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@k@(#1'2'3'4'5'6'7'8'9'0'a'b'                          ",
"                                    G;k@+@k@+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@(#c'd'e'f'g'h''&'&'&+&@&i'j'                          ",
"                                      Y>''+@+@+@+@+@+@+@+@+@+@+@+@+@+@+@w,k'l'm'n'o'p'q')&'&+&r's't'u'                          ",
"                                        v'w'k@+@+@+@+@+@+@+@+@+@+@+@+@k@+'x'y'z'A'B'C'+&'&+&D'E'F'G'H'                          ",
"                                        I'J'k@+@k@+@+@+@+@+@+@+@+@+@+@+@K'L'M'N'O')&'&)&P't$s'k%2&2&j*2&                        ",
"                                          Q'R'W@+@k@+@+@+@+@+@+@+@+@+@+@S'T'U'V'W''&)&V'X'L;K=Y'o*2&o*j*                        ",
"                                            Z'`'w'Z>+@+@+@+@+@+@+@+@+@+@ ).)+&+&C'+)@)(;~-|&o*2&|&o*n-#)                        ",
"                                                $)+@k@+@+@+@+@+@+@+@+@+@%)&))&*)=)j*o*2&|&2&2&2&o*G&-);)                        ",
"                                                    q>l;l;k@k@k@k@+@k@k@>),)')L;I&|&2&2&2&2&j*2&F&))!)                          ",
"                                                            ~)+@+@k@{)])^)/)Y'2&o*2&2&2&2&o*|&()_)                              ",
"                                                                          :)o*o*|&2&2&2&|&u-<;<)                                ",
"                                                                            [)})Y'j*1&n-|)1)2)                                  ",
"                                                                              3)4)5)6)7)8)                                      ",
"                                                                                  9)g>0)                                        "};

/***************************
 * variables locales
 * ************************/
GdkColor TmpSColor;
GdkColor TmpFColor;
GdkColor TmpPageColor;
gint TmpAlpha;

/******************************************
 * dialogue commun à toutes les fonctions
 * de couleurs ; on passe en entrée la
 * couleur courante sous forme
 * GdkColor
 * en sortie, chaine correspondant au choix,
 * chaine nulle si pas de clic sur OK
 * attention : alpha est une valeur de 
 * 0 à 1 !
 * ****************************************/
void redraw_preview(GtkWidget *widget)
{
 cairo_t *cr; 
 cr = gdk_cairo_create(widget->window);
 
 cairo_set_source_rgb(cr,(gdouble)(TmpPageColor.red/65535.0),
                         (gdouble)(TmpPageColor.green/65535.0),
						 (gdouble)(TmpPageColor.blue/65535.0));
 cairo_rectangle(cr,0,0,128,48);
 cairo_fill(cr);
 cairo_set_source_rgba(cr, (gdouble)(TmpFColor.red/65535.0),
                          (gdouble)(TmpFColor.green/65535.0),
                          (gdouble)(TmpFColor.blue/65535.0),
						  (gdouble)(TmpAlpha/100.0));
 cairo_rectangle(cr,32,5,64,32);
 cairo_fill(cr);
 cairo_set_source_rgba(cr, (gdouble)(TmpSColor.red/65535.0),
                          (gdouble)(TmpSColor.green/65535.0),
                          (gdouble)(TmpSColor.blue/65535.0),
						  (gdouble)(TmpAlpha/100.0));
 cairo_rectangle(cr,32,5,64,32);
 cairo_stroke(cr);
 cairo_destroy(cr); 	
}
void
on_buttonDlgColorFColor_clicked        (GtkButton       *button,
                                        GtkWidget *widget)
{
	gdouble couleur[4]; /* tableau temporaire pour les composantes */
	GtkColorSelectionDialog *dialog_couleur;
    gint reponse;
    	
    dialog_couleur = (GtkColorSelectionDialog*)gtk_color_selection_dialog_new(gettext("Choosing fill color "));
    gtk_widget_hide(dialog_couleur->help_button);
    reponse = gtk_dialog_run(GTK_DIALOG(dialog_couleur));
    if (reponse==GTK_RESPONSE_OK)
          {
              /* récupérer la couleur choisie  */
              gtk_color_selection_get_color(GTK_COLOR_SELECTION (dialog_couleur->colorsel),couleur);   
              TmpFColor.red=(guint16)(couleur[0]*65535);
              TmpFColor.green=(guint16)(couleur[1]*65535);          
              TmpFColor.blue=(guint16)(couleur[2]*65535);    
			  /* redessiner l'aperçu */  
			  redraw_preview(widget);     	             
          }
    gtk_widget_destroy(GTK_WIDGET(dialog_couleur));
}



void on_buttonDlgColorSColor_clicked(GtkButton       *button,
                                        GtkWidget *widget)
{
	gdouble couleur[4]; /* tableau temporaire pour les composantes */
	GtkColorSelectionDialog *dialog_couleur;
    gint reponse;
    
    dialog_couleur = (GtkColorSelectionDialog*)gtk_color_selection_dialog_new(gettext("Choosing stroke color "));
    gtk_widget_hide(dialog_couleur->help_button);
    reponse = gtk_dialog_run(GTK_DIALOG(dialog_couleur));
    if (reponse==GTK_RESPONSE_OK)
          {
              /* récupérer la couleur choisie  */
              gtk_color_selection_get_color(GTK_COLOR_SELECTION (dialog_couleur->colorsel),couleur);   
              TmpSColor.red=(guint16)(couleur[0]*65535);
              TmpSColor.green=(guint16)(couleur[1]*65535);          
              TmpSColor.blue=(guint16)(couleur[2]*65535);    
			  redraw_preview(widget);         	             
          }
    gtk_widget_destroy(GTK_WIDGET(dialog_couleur));
}
void
on_spinbuttonDlgColorAlpha_value_changed(GtkSpinButton   *spinbutton,
                                        GtkWidget *widget)
{
	TmpAlpha  = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));	
	/* changer la preview */
    redraw_preview(widget); 
}
/************ expose events pour les aperçus de couleurs */
gboolean
on_drawingareaDlgColors_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
 redraw_preview(widget); 
 return FALSE;
}
/************** dialogue couleur pour le fond de page ************/
const gchar *dlg_couleur(gchar *message)
{
	gchar *str=NULL;
	gdouble couleur[4]; /* tableau temporaire pour les composantes */
	GdkColor coul;
	GtkColorSelectionDialog *dialog_couleur;
    gint reponse;
    
    dialog_couleur = (GtkColorSelectionDialog*)gtk_color_selection_dialog_new(message);
    gtk_widget_hide(dialog_couleur->help_button);
    reponse = gtk_dialog_run(GTK_DIALOG(dialog_couleur));
    if (reponse==GTK_RESPONSE_OK)
          {
              /* récupérer la couleur choisie  */
              gtk_color_selection_get_color(GTK_COLOR_SELECTION (dialog_couleur->colorsel),couleur);   
              coul.red=(guint16)(couleur[0]*65535);
              coul.green=(guint16)(couleur[1]*65535);          
              coul.blue=(guint16)(couleur[2]*65535);
              str=gdk_color_to_string(&coul);              	             
          }
    gtk_widget_destroy(GTK_WIDGET(dialog_couleur));
	return str;
}
/*****************************
 * choix de la fonte ;
 * en sortie, donne un pointeur
 * sur une structure de type
 * PangoFontDescription
 * ****************************/
PangoFontDescription *dlg_fontes(gchar *message)
{
	GtkResponseType result;
	gchar *fontname;
    PangoFontDescription *font_desc=NULL;		
	 
    GtkWidget *dialog = gtk_font_selection_dialog_new(message);
    result = gtk_dialog_run(GTK_DIALOG(dialog));

    if (result == GTK_RESPONSE_OK || result == GTK_RESPONSE_APPLY)
     {      
        fontname = gtk_font_selection_dialog_get_font_name(
                            GTK_FONT_SELECTION_DIALOG(dialog));
        font_desc = pango_font_description_from_string(fontname);	  
        g_free(fontname);	 
     }
    gtk_widget_destroy(dialog);	
	return font_desc;
}
/**********************************
 * saisie d'un texte à travers une
 * boîte de dialogue
 * *******************************/

gchar *dlg_saisie_text(gchar *message,gchar *txt_actuel)
{
  GtkWidget *DlgAddText;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *scrolledwindow1;
  GtkWidget *TextViewEditor;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;
  GtkTooltips *tooltips;
  GtkResponseType result;
  GtkTextBuffer *textbuffer;
  GtkTextIter iStart;
  GtkTextIter iEnd;
  gchar* sBuffer=NULL;

  tooltips = gtk_tooltips_new ();

  DlgAddText = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (DlgAddText), message);
  gtk_window_set_type_hint (GTK_WINDOW (DlgAddText), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (DlgAddText)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  label1 = gtk_label_new (gettext("Text :"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_SHADOW_IN);

  TextViewEditor = gtk_text_view_new ();
  gtk_widget_show (TextViewEditor);
  textbuffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (TextViewEditor));
  /* passer le texte */
  gtk_text_buffer_set_text(textbuffer,txt_actuel,-1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), TextViewEditor);
  gtk_tooltips_set_tip (tooltips, TextViewEditor,
    gettext( "Type here the text you want to\nadd on your drawing."), NULL);

  dialog_action_area1 = GTK_DIALOG (DlgAddText)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (DlgAddText), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (DlgAddText), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

  result = gtk_dialog_run(GTK_DIALOG(DlgAddText));
  if (result == GTK_RESPONSE_OK || result == GTK_RESPONSE_APPLY)
  {
    /* récupérer le texte tapé */
    /* On recupere l'origine du buffer */
    gtk_text_buffer_get_start_iter(textbuffer, &iStart);
    /* On recupere la fin du buffer */
    gtk_text_buffer_get_end_iter(textbuffer, &iEnd);
    /* On copie le contenu du buffer dans une variable */
    sBuffer = gtk_text_buffer_get_text(textbuffer, &iStart, &iEnd, TRUE);
    printf("texte tapé:%s\n",sBuffer);
  }/* endif Ok */
  gtk_widget_destroy(DlgAddText); 
  return sBuffer;
}

/*******************************
 * gestion simultanée des deux 
 * couleurs et du canal
 * alpha ;
 * on passe en entrée les choix
 * actuels de couleurs
 * ****************************/
GtkWidget*
create_dialogColorsAlpha (GdkColor scolor,GdkColor fcolor,GdkColor pcolor,gint alpha)
{ 
  GtkWidget *dialogColors2;
  GtkWidget *dialog_vbox3;
  GtkWidget *hbox25;
  GtkWidget *image10;
  GtkWidget *frame4;
  GtkWidget *alignment6;
  GtkWidget *vbox6;
  GtkWidget *buttonDlgColorFColor;
  GtkWidget *alignment9;
  GtkWidget *hbox10;
  GtkWidget *image4;
  GtkWidget *label15;
  GtkWidget *buttonDlgColorSColor;
  GtkWidget *alignment10;
  GtkWidget *hbox11;
  GtkWidget *image5;
  GtkWidget *label16;
  GtkWidget *labelcolors;
  GtkWidget *frame5;
  GtkWidget *alignment7;
  GtkWidget *vbox7;
  GtkWidget *label17;
  GtkObject *spinbuttonDlgColorAlpha_adj;
  GtkWidget *spinbuttonDlgColorAlpha;
  GtkWidget *label13;
  GtkWidget *vbox5;
  GtkWidget *frame6;
  GtkWidget *alignment8;
  GtkWidget *drawingareaDlgColors;
  GtkWidget *label14;
  GtkWidget *dialog_action_area3;
  GtkWidget *cancelbutton3;
  GtkWidget *okbutton3;
  GtkTooltips *tooltips;
  GdkPixbuf *pb;
  
  tooltips = gtk_tooltips_new ();
 
  /* création image */
  pb = gdk_pixbuf_new_from_xpm_data((const char **)peinture_xpm); /* transtypage obligatoire */
  /* passage des paramètres actuels */
  TmpSColor=scolor;
  TmpFColor=fcolor;
  TmpPageColor=pcolor;
  TmpAlpha=alpha;
  
  dialogColors2 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialogColors2), gettext("Colors choosing "));
  gtk_window_set_position (GTK_WINDOW (dialogColors2), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogColors2), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (dialogColors2), "gtk-color-picker");
  gtk_window_set_type_hint (GTK_WINDOW (dialogColors2), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox3 = GTK_DIALOG (dialogColors2)->vbox;
  gtk_widget_show (dialog_vbox3);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), hbox25, TRUE, TRUE, 0);

  image10 = gtk_image_new_from_pixbuf (pb);
   g_object_unref(pb);
  gtk_widget_show (image10);
  gtk_box_pack_start (GTK_BOX (hbox25), image10, TRUE, TRUE, 0);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (hbox25), frame4, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame4), GTK_SHADOW_IN);

  alignment6 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment6);
  gtk_container_add (GTK_CONTAINER (frame4), alignment6);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment6), 0, 0, 12, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (alignment6), vbox6);

  buttonDlgColorFColor = gtk_button_new ();
  gtk_widget_show (buttonDlgColorFColor);
  gtk_box_pack_start (GTK_BOX (vbox6), buttonDlgColorFColor, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, buttonDlgColorFColor,
   gettext( "This button allow to change fill color (main color) of drawings and to choose text color")
   , NULL);

  alignment9 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment9);
  gtk_container_add (GTK_CONTAINER (buttonDlgColorFColor), alignment9);

  hbox10 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (alignment9), hbox10);

  image4 = gtk_image_new_from_stock ("gtk-select-color", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image4);
  gtk_box_pack_start (GTK_BOX (hbox10), image4, FALSE, FALSE, 0);

  label15 = gtk_label_new_with_mnemonic (gettext("_foreground"));
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (hbox10), label15, FALSE, FALSE, 0);

  buttonDlgColorSColor = gtk_button_new ();
  gtk_widget_show (buttonDlgColorSColor);
  gtk_box_pack_start (GTK_BOX (vbox6), buttonDlgColorSColor, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, buttonDlgColorSColor,
   gettext( "This button allow to choose the outline color")
   , NULL);

  alignment10 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment10);
  gtk_container_add (GTK_CONTAINER (buttonDlgColorSColor), alignment10);

  hbox11 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (alignment10), hbox11);

  image5 = gtk_image_new_from_stock ("gtk-select-color", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image5);
  gtk_box_pack_start (GTK_BOX (hbox11), image5, FALSE, FALSE, 0);

  label16 = gtk_label_new_with_mnemonic (gettext("_Outline"));
  gtk_widget_show (label16);
  gtk_box_pack_start (GTK_BOX (hbox11), label16, FALSE, FALSE, 0);

  labelcolors = gtk_label_new (gettext("<b>Colors </b>"));
  gtk_widget_show (labelcolors);
  gtk_frame_set_label_widget (GTK_FRAME (frame4), labelcolors);
  gtk_label_set_use_markup (GTK_LABEL (labelcolors), TRUE);

  frame5 = gtk_frame_new (NULL);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox25), frame5, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame5), GTK_SHADOW_IN);

  alignment7 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment7);
  gtk_container_add (GTK_CONTAINER (frame5), alignment7);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment7), 0, 0, 12, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (alignment7), vbox7);

  label17 = gtk_label_new (gettext("Alpha channel value :"));
  gtk_widget_show (label17);
  gtk_box_pack_start (GTK_BOX (vbox7), label17, FALSE, FALSE, 0);

  spinbuttonDlgColorAlpha_adj = gtk_adjustment_new (TmpAlpha, 0, 101, 1, 1, 1);
  spinbuttonDlgColorAlpha = gtk_spin_button_new (GTK_ADJUSTMENT (spinbuttonDlgColorAlpha_adj), 1, 0);
  gtk_widget_show (spinbuttonDlgColorAlpha);
  gtk_box_pack_start (GTK_BOX (vbox7), spinbuttonDlgColorAlpha, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, spinbuttonDlgColorAlpha,
   gettext( "Type here a value between 0 and 100. Near of 0 = transparent, near of 100 = opaque"), NULL);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbuttonDlgColorAlpha), TRUE);

  label13 = gtk_label_new (gettext("<b>Transparencies </b>"));
  gtk_widget_show (label13);
  gtk_frame_set_label_widget (GTK_FRAME (frame5), label13);
  gtk_label_set_use_markup (GTK_LABEL (label13), TRUE);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), vbox5, TRUE, TRUE, 0);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox5), frame6, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame6), GTK_SHADOW_IN);

  alignment8 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment8);
  gtk_container_add (GTK_CONTAINER (frame6), alignment8);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment8), 0, 0, 12, 0);

  drawingareaDlgColors = gtk_drawing_area_new ();
  gtk_widget_show (drawingareaDlgColors);
  gtk_container_add (GTK_CONTAINER (alignment8), drawingareaDlgColors);
  gtk_widget_set_size_request (drawingareaDlgColors, 128, 48);
  gtk_tooltips_set_tip (tooltips, drawingareaDlgColors,
  gettext( "Color and opacity preview"), NULL);

  label14 = gtk_label_new (gettext("<b>Preview </b>"));
  gtk_widget_show (label14);
  gtk_frame_set_label_widget (GTK_FRAME (frame6), label14);
  gtk_label_set_use_markup (GTK_LABEL (label14), TRUE);

  dialog_action_area3 = GTK_DIALOG (dialogColors2)->action_area;
  gtk_widget_show (dialog_action_area3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area3), GTK_BUTTONBOX_END);

  cancelbutton3 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton3);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogColors2), cancelbutton3, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton3, GTK_CAN_DEFAULT);

  okbutton3 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton3);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogColors2), okbutton3, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton3, GTK_CAN_DEFAULT);


  g_signal_connect ((gpointer) buttonDlgColorFColor, "clicked",
                            G_CALLBACK (on_buttonDlgColorFColor_clicked),
                            GTK_OBJECT (drawingareaDlgColors));
  g_signal_connect ((gpointer) buttonDlgColorSColor, "clicked",
                            G_CALLBACK (on_buttonDlgColorSColor_clicked),
                            GTK_OBJECT (drawingareaDlgColors));
  g_signal_connect ((gpointer) spinbuttonDlgColorAlpha, "value_changed",
                            G_CALLBACK (on_spinbuttonDlgColorAlpha_value_changed),
                            GTK_OBJECT (drawingareaDlgColors));
  g_signal_connect ((gpointer) drawingareaDlgColors, "expose_event",
                            G_CALLBACK (on_drawingareaDlgColors_expose_event),
                            GTK_OBJECT (drawingareaDlgColors));
  return dialogColors2;
}
/*** fonctions permettant de lire depuis un autre module les valeurs choisies ***/
gint dlg_editeur_get_alpha(void)
{
	return TmpAlpha;
}
GdkColor dlg_editeur_get_scolor(void)
{
	return TmpSColor;
}
GdkColor dlg_editeur_get_fcolor(void)
{
	return TmpFColor;
}
/*****************************
 * fonctions pour charger des
 * images
 * ***************************/
/********************************
 File Dialog item
 ********************************/
 GtkWidget *create_DialogImportImageFile (gchar *titre,
            gchar *filtre1,gchar *filtre2,gchar *filtre3)
{
  GtkWidget *DialogOpenFile;
  GtkWidget *dialog_vbox2;
  GtkWidget *dialog_action_area2;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkFileFilter *filter;
  
  filter = gtk_file_filter_new ();

  DialogOpenFile = gtk_file_chooser_dialog_new (gettext("Import an image ..."), NULL,
             GTK_FILE_CHOOSER_ACTION_OPEN,NULL,NULL, NULL);
 
  gtk_file_filter_add_pattern (filter, filtre1);
  gtk_file_filter_add_pattern (filter, filtre2);
  gtk_file_filter_add_pattern (filter, filtre3);
  gtk_file_filter_set_name (filter,gettext("images"));
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(DialogOpenFile),filter);

  gtk_container_set_border_width (GTK_CONTAINER (DialogOpenFile), 5);
  gtk_window_set_position (GTK_WINDOW (DialogOpenFile), GTK_WIN_POS_CENTER);
  gtk_window_set_type_hint (GTK_WINDOW (DialogOpenFile), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_window_set_icon_name (GTK_WINDOW (DialogOpenFile), "gtk-open");

  dialog_vbox2 = GTK_DIALOG (DialogOpenFile)->vbox;
  gtk_widget_show (dialog_vbox2);

  dialog_action_area2 = GTK_DIALOG (DialogOpenFile)->action_area;
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);

  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogOpenFile), button1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  button2 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogOpenFile), button2, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) DialogOpenFile, "destroy",
                    G_CALLBACK (gtk_widget_destroy),
                    NULL);
  g_signal_connect ((gpointer) button1, "clicked",
                    G_CALLBACK (gtk_true),
                    NULL);

  gtk_widget_grab_default (button2);
  return DialogOpenFile;
}
/****************************************************** 
 * fonction globale gérant les dialogues et erreurs,
 * retournant NULL si problème, sinon un pointeur sur
 * un pixbuf
 * *******************************************************/
GdkPixbuf *dlg_import_image(gint e_w,gint e_h)
{
	GdkPixbuf *pb=NULL;
	GtkWidget *dlg;
	gint reponse;
	gchar *path_to_file;
	gint width, height;
	GdkPixbufFormat *fmt;
	GError *error=NULL;
	
	dlg=create_DialogImportImageFile (gettext("Import an image"),
            "*.jpg","*.png","*.jpeg");
	reponse=gtk_dialog_run(GTK_DIALOG(dlg));
	if (reponse!=GTK_RESPONSE_OK)
      {
           gtk_widget_destroy(dlg);
           return NULL;
      }
	/* quel fichier ? */
	path_to_file= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dlg));
	gtk_widget_destroy(dlg);
	/* vérifier contenu et validité du fichier */
	fmt=gdk_pixbuf_get_file_info(path_to_file,&width,&height);
	if (fmt==NULL)
	  {
	   printf("erreur lecture ! \n");
	   return NULL;
      }
	else
	  {
		  printf("width %d height %d \n",width, height);
	  }
	/* contraindre les dimensions !!! */
	if ((width>e_w)||(height>e_h))
	      {
			  width=e_w;
			  height=e_h;
		  }
	pb=gdk_pixbuf_new_from_file_at_scale(path_to_file,width,height,TRUE,
                                                         &error);
	/* si erreur, sortir NULL */
	
	g_free(path_to_file);
	return pb;
}
