/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/

//translations
#include <locale.h>
#include <libintl.h>

#include <gtk/gtk.h>
#include <swfdec-gtk/swfdec-gtk.h>
#include <goocanvas.h>
#include "ellasyms.h"
/**************************
 variables SWF
 plus simple en global
qu'en bricolant les fonctions
**********************************/
 GtkWidget *fix;
 GtkWidget *widget_swf;
 extern  SwfdecPlayer *player_preview;/* vient des callbacks */
 static gdouble total_played=0;
 static gulong total_duration;
 static GtkWidget *labelTimePosition;
 static gboolean fPaused=FALSE;
 static pPLayerTimeLineCursorItem;
 static GooCanvasItem *rootTlCursor;
 static gint zoom_tl;
 static gint player_freq;
 static GtkWidget *touche_play;
/**********************************************
 * displaying the reading head on the timeline
 *  window 
 * 
* human coordoninates      
**********************************/
void player_affiche_curseur(GooCanvasItem *root, gint position, gint zooming)
{	  
  gint largeur;/* largeur des cases en prenant en compte le zooming */
 
  largeur=(gint)((zooming*RULER_WIDTH)/100);	 	  
  position=position-1;     
  /* afficher la position sur la timeline */
  pPLayerTimeLineCursorItem= goo_canvas_rect_new (root,
                    position*largeur+(largeur/2)-1, 
                    0,2, 
                    MAX_LAYERS*RULER_HEIGHT,
				   "line-width", 1.0,"radius-x", 1.0,"radius-y", 1.0,
				   "stroke-color", "green", "fill-color", "green",
				   NULL);  	  
}
/**********************************
 * remove reading head from
 * timeline
 * *******************************/
void player_efface_curseur_timeline(void)
{
	if (pPLayerTimeLineCursorItem!=NULL)
	    goo_canvas_item_remove(pPLayerTimeLineCursorItem);
}
/*********************************************
 * intercept key-events
 * ******************************************/
gboolean            swf_keys                     (SwfdecPlayer *player,
                                                        guint         key,
                                                        guint         pressed,
                                                        gboolean      Returns,
                                                        gpointer      user_data)   
{
	printf("tu as pressé la touche:%d\n",key);
	return TRUE;
}														
/************************************************
 * callback called by swfplayer ;
 * print infos 
 * *********************************************/
static void
swf_infos (SwfdecPlayer *player, gulong        msecs,
                                                        guint         audio_samples,
                                                        gpointer      user_data)
{
 gdouble position;
 
 if (swfdec_gtk_player_get_playing (SWFDEC_GTK_PLAYER (player_preview)))
   fPaused=FALSE;
 else
   fPaused=TRUE;
 player_efface_curseur_timeline();
 if (!fPaused)
     total_played=total_played+msecs;
 /* set the time label */	
 gtk_label_set_markup(GTK_LABEL(labelTimePosition),
    g_strdup_printf("<span font_desc=\"Digit 12\" foreground=\"#00FF00\" background=\"#000000\"><big><b>%.2fsecs</b></big></span>",
   total_played/1000));
 if (total_played>total_duration)
   {	   
     total_played=0;
	 swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (player_preview), FALSE);
	 gtk_widget_set_sensitive(touche_play,TRUE);
   }
 /* compute position in human coordinates */
 position=(total_played/1000)*player_freq;  
 //printf("position=%f\n",position);
 if (position>MAX_FRAMES)
    position=MAX_FRAMES-1;
 player_affiche_curseur(rootTlCursor, (gint)position, zoom_tl);
}
/**************************************************
 démarrer proprement l'initialisation du
 player swf
**************************************************/
gint init_swf_player(SwfdecPlayer* player)
{
  while (!swfdec_player_is_initialized (player))
  {
      long next = swfdec_player_get_next_event (player);
      if (next < 0)
      {
          /* not a flash file */
          return 0;
      }
      swfdec_player_advance (player, next);
  }
 return -1;
}

/************************************************
 libérer la mémoire ?
************************************************/
void free_swf_player(GtkWidget *widget_swf,SwfdecPlayer* player)
{
 if (widget_swf!=NULL)
   gtk_object_destroy(GTK_OBJECT(widget_swf));
 if (fix!=NULL)
   gtk_object_destroy(GTK_OBJECT(fix));
 // g_free((SwfdecPlayer*)player);
}
/**************************************************
 * pause/un-pause the movie
 * **********************************************/
void swf_player_pause(void)
{
	fPaused=! fPaused;
	if (fPaused)
	    swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (player_preview), FALSE);
	else
	    swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (player_preview), TRUE);
}
/**************************************************
 charger et initialiser un player SWF
 on passe juste l'emplacement du chemin d'accès
 LOCAL au fichier
**************************************************/
SwfdecPlayer *new_swf_player(char *fich)
{
 gchar *uri_path;
 SwfdecPlayer* player;

 /* Create a new player */
 player = swfdec_gtk_player_new (NULL);
 uri_path = g_filename_to_uri(fich, NULL,NULL);
 SwfdecURL* url = swfdec_url_new(uri_path); 
 swfdec_player_set_url(player,url);
 /* adapter taille player à la fenêtre */
 swfdec_player_set_scale_mode(player, SWFDEC_SCALE_SHOW_ALL); /* bon choix = SWFDEC_SCALE_SHOW_ALL */
 return player;
}
/**************************************************
 placer le player swf  automatiquement, dans la
 fenêtre placée en  paramètre ; 
 attention ! La fenêtre doit déjà être
 visible pour calculer le placement !
le paramètre "recadre" détermine l'écart par
rapport au coin supérieur gauche de la 
"fenêtre" (qui peut être tout conteneur GTK)
***************************************************/
void put_swf_player(GtkWidget *w, GtkWidget *widget_swf,SwfdecPlayer* player,int x, int y, int larg,int haut)
{
  /* créer une zone fixe */
  fix = gtk_fixed_new();
  gtk_container_add(GTK_CONTAINER(w),fix);
 // gtk_widget_set_usize(widget_swf,larg,haut);/* ne marche que dans les limites où ça rentre dans la fenêtre */
  /* y placer le player swf */
  gtk_fixed_put(GTK_FIXED(fix),widget_swf,x,y);  
  gtk_widget_show(fix);
  //gtk_container_add(GTK_CONTAINER(w),widget_swf);
  gtk_widget_show(widget_swf);
}
/***********************************
 * arrêter brutalement la lecture
 * ********************************/
void kill_swf_player(void)
{
	if  (player_preview!=NULL)
     {
		swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (player_preview), FALSE); 
       /* arrêter le player */
       free_swf_player(widget_swf,player_preview);       
      //g_free(player_preview);
      player_preview=NULL;
	  fPaused=FALSE;
	  player_efface_curseur_timeline();
	  gtk_widget_set_sensitive(touche_play,TRUE);
     }
 }
/**********************************
 callbacks du dialogue des
 animations ;
 attention : elles ne sont PAS
 asynchrones ! (dans le sens où
 elles fonctionnent comme des 
widgets ;
attend un paramètre 'w' qui doit
être une scrolled window
**********************************/
void preview_animation(GtkWidget *w, gulong duration, GtkWidget *label,GtkWidget *play_touche, GooCanvasItem *rootTl, gint zooming, gint freq)
{
 char buf[512];
 gint width,height; /* taille de la fenêtre de preview utilisable */
 if  (player_preview!=NULL)
     {
       /* arrêter le player */
       free_swf_player(widget_swf,player_preview);       
      //g_free(player_preview);
      player_preview=NULL;
	   total_played=0;
	  if (fPaused)
	     player_efface_curseur_timeline();
     }
 sprintf(buf,"%s/.ella/%s",(gchar *)getenv("HOME"),"player.swf");
 /* créer le player swf */
 player_preview = new_swf_player(buf);
 /* widget SWF */
 widget_swf = swfdec_gtk_widget_new (player_preview);
 /* We wait till the initialization is completed */
 init_swf_player(player_preview);    
 /* attacher le player à la fenêtre et l'afficher */
 put_swf_player(w,widget_swf,player_preview,0,0,640,480);
 //Get notifications
  g_signal_connect(player_preview, "handle-key",G_CALLBACK (swf_keys), NULL);
  g_signal_connect (player_preview, "advance", G_CALLBACK (swf_infos), NULL);
 /* Play ! */
 total_played=0;
 total_duration=duration;
 labelTimePosition=label;
 touche_play=play_touche;
 fPaused=FALSE;
 rootTlCursor=rootTl;
 zoom_tl=zooming;
 player_freq=freq;
 player_affiche_curseur(rootTlCursor, 1, zoom_tl);
 swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (player_preview), TRUE);/* le système gère tout seul la souris */    
 /* inhibit [PLAY] key */
 gtk_widget_set_sensitive(touche_play,FALSE);        
}
