/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
//translations
#include <locale.h>
#include <libintl.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <goocanvas.h>
#include "timeline.h"
#include "ellasyms.h"

/* icons */
#include "./icones_rcs/ico_layer_sound.xpm"
#include "./icones_rcs/ico_layer_draw.xpm"

/* XPM */
static char * pointeur_regle_xpm[] = {
"12 12 4 1",
" 	c None",
".	c #F68585",
"+	c #EA0808",
"@	c #242424",
"            ",
"            ",
" .......... ",
" .++++++++@ ",
"  .++++++@  ",
"  .++++++@  ",
"   .++++@   ",
"   .++++@   ",
"    .++@    ",
"    .++@    ",
"     .@     ",
"            "};


/* variables EXTERN venant de l'interface */
  extern GooCanvasItem *rootEditorItems;
  extern GooCanvasItem *rootGroup;/* source du groupe de chaque calque */ 
  extern GooCanvasItem *rootKF; /* source des dessins de chaque image-clé */
  extern GSList *keyframes_list;/* source de la liste des images-clés de chaque calque */
  extern GooCanvasItem *pDrawings;/* pointeur générique utilisé pour simuler le mode xor */
  extern fModified; /* flag indiquant une modif */
  extern gboolean SelectedArea; /* indique si une sélection est en cours */
  extern GList *pSelectedItemsList; /* liste des items, mais VALIDE, sans le fond et l'origine */


    GtkWidget *ScrolledWindowLayersList;
    GtkWidget *ScrolledWindowTimeLine;
    GtkWidget *scrolledWindowRuler;

    gint xcell,ycell; /* positions sur timeline ; coordonnées humaines */
    gint xruler=1;/* position sur la règle en coordonnées humaines, en partant de 1*/
    gint x1sel,y1sel,x2sel,y2sel; /* coordonnées humaines des 4 coins de la zone de sélection */
    gboolean fTimeLineSelection=FALSE; /* flag indiquant une sélection en cours */
    /* local pointer on Editor's window */
	static GtkWidget *pWinTimelineEditor;
    GdkPixbuf *pIcoRulerCursor;
    /* icones des layers */
    GdkPixbuf *pIco_layer_dessin;
    GdkPixbuf *pIco_layer_son;  
    /* éléments de la treeview des layers */
    extern GtkWidget *pListViewLayers;
    GtkListStore *pListStore;
    extern gint LayerCount; /* nombre total de calques en cours, comptage humain */
    extern gint LayerSelected; /* calque actuellement sélectionné, coordonnées ordinateur 0-max */ 
    
    /* canvas */
	static GooCanvasItem *pRulerItem;/* pointer in order to quickly erase ruler */
    GtkWidget canvasEditorLink;/* permet l'interconnexion entre editeur et timeline */
    GtkWidget *canvasRuler;
    GooCanvasItem *rootRuler;
    GooCanvasItem *pRulerCursorItem;/* pointeur sur l'item représentant le curseur */
    GtkWidget *canvasTimeLine;
    GooCanvasItem *rootTimeLine;
    GooCanvasItem *pTimeLineCursorItem;/* pointeur sur le curseur vertical sur la time line */
    GooCanvasItem *pTimeLineSelectionCursor;
  
    /* pointeur sur label indiquant le calque en cours */
    GtkWidget *labelNumeroCalque; 
    /* boutons de réglage */
    GtkWidget *spinbuttonMoviePosition;
    GtkWidget *spinbuttonMovieFrequency;
    /* réglages divers */
    gint MovieFreq=12;
    gint MoviePos=1;
    static gint TimelineZoom=100;/* valeur actuelle du zooming sur la timeline */
    /* pour les callbacks */
    GtkWidget *buttonLayerNew;
    GtkWidget *buttonLayerRemove;
    GtkWidget *buttonLayerDuplicate;
    GtkWidget *buttonLayerDown;
    GtkWidget *buttonLayerUp;

    /* liste contenant les effets */
    /* listes */
    GSList *effects_list=NULL;
/* valeurs par défaut */
 gint timeline_defaut_MovieFreq;
 gint timeline_default_footage;
    
/* forwards */
void draw_ruler(GooCanvasItem *root, GtkWidget *win,gint freq );
void remove_ruler_bg(GooCanvas  *root, GtkWidget *win);
void draw_timeline_bg(GooCanvasItem *root,GtkTreeView *treeview, gint ligne, GtkWidget *win); 
void remove_timeline_bg(GooCanvas  *root, gint ligne); 
void add_tree_list_layer(GtkListStore *pListStore, GooCanvasItem *ancetre,gint maxi, gint type_layer);
void efface_curseur_regle(void);
void affiche_curseur_regle(GooCanvasItem *root, gint position);
void efface_curseur_timeline(void);
void affiche_curseur_timeline(gint x,gint y, gint x2, gint y2);
gboolean on_timeline_button_press(GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win);
void raz_liste_keyframes(GSList *list);		      
GSList  *add_liste_keyframes(GSList *list, guint kf, gboolean vide, gboolean efm,
         gboolean efr, gboolean efz,
		 gboolean efalpha, gboolean eflumi, gboolean efmorph,
		  gint xm, gint ym, gint z, gdouble r,
		  gint alpha, gint lumi,
		   GooCanvasItem *rKF);
GooCanvasItem *get_keyframe_group(GSList *list, guint kf);
void set_transition_page(GSList *list, gint kf);
void mouchard(void);

GooCanvasItem *timeline_get_root_ruler(void)
{
	return rootTimeLine;
}
/* renvoyer la valeur actuelle du zooming */
gint timeline_get_zooming(void)
{
	return TimelineZoom;
}
/* donner la position du curseur, en coordonnées humaines */
gint timeline_get_cursor_xpos(void)
{
	return xcell;
}
/* donner la position du curseur, en coordonnées humaines */
gint timeline_get_cursor_ypos(void)
{
	return ycell;
}
/*************************************
 * effacer le contenu de la sélection
 * **********************************/
void timeline_selection_raz(void)
{
  gint count;
  GSList *node;
  
  if (pSelectedItemsList!=NULL)
	{
	  
	  for (count = 0; node = (GSList *)g_list_nth (pSelectedItemsList, count); count++) 
        {          	
			pSelectedItemsList=g_list_remove(pSelectedItemsList,node->data);                          
        } /* for */         
	  g_list_free(pSelectedItemsList);
	  pSelectedItemsList=NULL;
	}/* endif list!=NULL*/	
}
/*************************************
 * sortir vers un fichier tous les
 * items d'une image-clé, fournie en
 * paramètre coordonnées PC ; autre
 * paramètre : une keyframes_list
 * et le pointeur, sur un fichier
 * **********************************/
void put2_items_to_file(guint kf)
{
	GSList  *temp,*list;
	effects_data_type *temp_data;
	gint    nIndex;
	gboolean sortir=FALSE;
	GooCanvasItem *source, *dest, *item;
	gchararray title;
		
		printf("kf =%d",kf);
	/* récupérer un pointeur sur le groupe d'items de l'image-clé précédente */
	nIndex=0;
	while (!sortir)
	  {
	  	temp = g_slist_nth (list, nIndex);
	  	source=((effects_data_type *)(temp->data))->rootKF;  
	    nIndex++;        		    
	  	if (((effects_data_type *)(temp->data))->keyframe==kf)
          {          	
          	sortir=TRUE;
          }
      }/* wend */
	
	printf("nombre total d'enfants %d \n",goo_canvas_item_get_n_children (source));
	/* boucle pour transférer les items */
	nIndex=0;
	while (nIndex<goo_canvas_item_get_n_children (source))		
	   {
	   	 item=goo_canvas_item_get_child(source,nIndex);
	   	 printf("rang %d\n",nIndex);
	   	 if (item!=NULL)
	   	   {
	   	   	printf("trouvé un item à copier ! \n");
	   	   	g_object_get(item,"title",&title,NULL);
	   	   	printf("titre %s\n",title);
            
		   }	
		 nIndex++;	
	   }/* wend */	
}
/**********************************
 * déterminer le nombre de
 * calques utilisés
 * *******************************/
gint timeline_get_layers_count(void)
{
	return LayerCount;
}
/**********************************
 * afficher les deux curseurs
 * *******************************/
void timeline_put_cursors(void)
{
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);	
}
/**********************************
 * changer les paramètres du calque
 * coordonnées humaines
 * *******************************/
void timeline_layer_set_name(gint ligne,gchar *name)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 
  if (ligne<0)
       return;
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));     
  path1=g_strdup_printf ("%d:%d",ligne-1,0);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_list_store_set(GTK_LIST_STORE(model), &pIter,
            LAYER_NAME_COLUMN, name,-1);
  g_free(path1);
  gtk_tree_path_free(path);
}
/**********************************
 * changer les paramètres du calque
 * coordonnées humaines
 * *******************************/
gchar  *timeline_layer_get_name(gint ligne)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1,*name;
 GtkTreeIter pIter;
 guint cell;
 
  if (ligne<0)
       return NULL;
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));     
  path1=g_strdup_printf ("%d:%d",ligne-1,0);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,  LAYER_NAME_COLUMN, &name,-1);
  g_free(path1);
  gtk_tree_path_free(path);
  return name;
}
/**********************************
 * changer les paramètres du calque
 * coordonnées humaines ;
 * normalement, rootKF 
 * est initialisé
 * *******************************/
void timeline_layer_set_visibility(gint ligne,gboolean visible)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 gint count;
 GSList *node;
 
  if (ligne<0)
       return;

  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));     
  path1=g_strdup_printf ("%d:%d",ligne-1,0);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_list_store_set(GTK_LIST_STORE(model), &pIter,
            LAYER_VISIBLE_COLUMN, visible,-1);
  /* passer toute la liste des keyframes en revue, et la toggler
   * on connaît xcell et ycell, donc pas besoin de variables
   * globales venant de l'éditeur */
  if (rootKF!=NULL)
     {
       if (visible)
          g_object_set(rootKF,"visibility",GOO_CANVAS_ITEM_VISIBLE,NULL);
       else
          g_object_set(rootKF,"visibility",GOO_CANVAS_ITEM_INVISIBLE,NULL);
	  }
  g_free(path1);
  gtk_tree_path_free(path);
}

/*********************************
 * initialiser les images_clés
 * ligne = coordonnées humaines,
 * kf coordonnées PC
 * ******************************/
GooCanvasItem *timeline_layer_set_index_keyframes(gint ligne, gint kf, gint type_kf)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 gint count;
 GSList *temp;
 GooCanvasItem *rkf=NULL;
 
 if (ligne<0)
       return NULL;
 model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));         	
 path1=g_strdup_printf ("%d:%d",ligne-1,kf);
 path=gtk_tree_path_new_from_string(path1);
 gtk_tree_model_get_iter(model, &pIter, path);
 gtk_list_store_set(GTK_LIST_STORE(model), &pIter,N_COLUMN+kf, type_kf,  -1);	
 /* initialiser les pointeurs sur rootKF si kf>0 */
 gtk_tree_model_get (model, &pIter, LAYER_MOVEMENT_INDEX, (gpointer)&temp, -1);
 if (kf>0)
    {
      rkf= goo_canvas_group_new(rootGroup,NULL);
	  temp=add_liste_keyframes(temp, kf, TRUE, FALSE, FALSE, FALSE,FALSE,FALSE,FALSE,
	                          0, 0, 0, 0,100,100, rkf);
	  gtk_list_store_set(pListStore, &pIter,LAYER_MOVEMENT_INDEX,temp, -1);
	}
 else
   rkf=get_keyframe_group(temp, kf);
 g_free(path1);
 gtk_tree_path_free(path);   
 return rkf;
}
/*********************************
 * initialiser les images non
 * vides
 * ******************************/
void timeline_layer_set_actives_frames(gint ligne, gint max_fr)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 gint count;
 
 if (ligne<0)
       return;
 model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));         	
 path1=g_strdup_printf ("%d:%d",ligne-1,0);
 path=gtk_tree_path_new_from_string(path1);
 gtk_tree_model_get_iter(model, &pIter, path);
 
 for (count=1;count<max_fr;count++)
   {
   	 gtk_list_store_set(GTK_LIST_STORE(model), &pIter,N_COLUMN+count, ELLA_FRAME_USED_EMPTY,  -1);	
   }/* next*/
 g_free(path1);
 gtk_tree_path_free(path);   
}
/*********************************
 * initialisation d'un layer ;
 * aucun numéro de rang n'est
 * vraiment nécessaire, il 
 * va s'ajouter à la racine
 * mais la variable ligne
 * permet l'affichage dans
 * le canvas
 * attention : cette fonction
 * est réservée aux fonctions
 * de lecture sur fichiers,
 * car elle n'affiche RIEN
 * ******************************/
void timeline_new_layer( void)
{
	gchar *sLayerName;
	gint i;
	GtkTreeIter pIter;  
	GooCanvasItem *root_layer;	
  
    /* création du contenu */   
	sLayerName = g_malloc(256);
    /* Insertion des elements */
    sprintf(sLayerName,gettext("Layer %d\0"),LayerCount+1);
    /* Creation de la nouvelle ligne */
    gtk_list_store_append(pListStore, &pIter);
    /* Mise a jour des donnees */
    gtk_list_store_set(pListStore, &pIter,
            LAYER_NAME_COLUMN, sLayerName,
            LAYER_VISIBLE_COLUMN, TRUE, 
            LAYER_VISIBLE_TEXT, "visible", 
            LAYER_MOVEMENT_INDEX,NULL,          
            -1);   
    /* initialiser le pointeur sur le groupe d'items */
    rootGroup = goo_canvas_group_new(rootEditorItems,NULL); /* ancetre= rootEditorItems*/
    g_object_set(rootGroup, "title", "K", NULL);
    /* la ligne suivante sera inutile à terme */
    gtk_list_store_set(pListStore, &pIter, LAYER_GROUP_DRAW, rootGroup,
	                   LAYER_ICON_TYPE,pIco_layer_dessin,LAYER_TYPE,DRAWING_LAYER,-1);
    /* remplir le reflet de chaque image */     
    gtk_list_store_set(pListStore, &pIter,N_COLUMN,ELLA_FRAME_KEY_EMPTY,-1);/* image-clef dans la première par défaut */
    for(i = N_COLUMN+1 ; i < MAX_FRAMES ; i++)
        {          	
             gtk_list_store_set(pListStore, &pIter,i,ELLA_FRAME_NON_USED,-1);
	    }/* for i */	
    g_free(sLayerName);        	
	/* afficher les éléments dans la time line */
	//draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),LayerCount+1,ScrolledWindowTimeLine);
	/* incrémenter le compteur de calques */
	LayerCount=LayerCount+1;
	/* à ce stade, rootGroup pointe sur le groupe de ce layer */
	/* initialiser la liste des images-clés */
	keyframes_list=NULL;
	rootKF= goo_canvas_group_new(rootGroup,NULL);
	keyframes_list=add_liste_keyframes(keyframes_list, 0, TRUE, FALSE, FALSE, FALSE,FALSE,
	            FALSE,FALSE, 0, 0, 0, 0,100,100, rootKF);
	gtk_list_store_set(pListStore, &pIter,LAYER_MOVEMENT_INDEX,keyframes_list, -1);
}
/*********************************
 * initialisation d'un layer ;
 * aucun numéro de rang n'est
 * vraiment nécessaire, il 
 * va s'ajouter à la racine
 * mais la variable ligne
 * permet l'affichage dans
 * le canvas
 * attention : cette fonction
 * est réservée aux fonctions
 * de lecture sur fichiers,
 * car elle n'affiche RIEN
 * ******************************/
void timeline_new_sound_layer( void)
{
	gchar *sLayerName;
	gint i;
	GtkTreeIter pIter;  
	GooCanvasItem *root_layer;	
  
    /* création du contenu */   
	sLayerName = g_malloc(256);
    /* Insertion des elements */
    sprintf(sLayerName,gettext("Layer %d\0"),LayerCount+1);
    /* Creation de la nouvelle ligne */
    gtk_list_store_append(pListStore, &pIter);
    /* Mise a jour des donnees */
    gtk_list_store_set(pListStore, &pIter,
            LAYER_NAME_COLUMN, sLayerName,
            LAYER_VISIBLE_COLUMN, TRUE, 
            LAYER_VISIBLE_TEXT, "visible", 
            LAYER_MOVEMENT_INDEX,NULL,          
            -1);   
    /* initialiser le pointeur sur le groupe d'items */
    rootGroup = goo_canvas_group_new(rootEditorItems,NULL); /* ancetre= rootEditorItems*/
    g_object_set(rootGroup, "title", "K", NULL);
    /* la ligne suivante sera inutile à terme */
    gtk_list_store_set(pListStore, &pIter, LAYER_GROUP_DRAW, rootGroup,
	                   LAYER_ICON_TYPE,pIco_layer_son,LAYER_TYPE,SOUND_LAYER,-1);
    /* remplir le reflet de chaque image */     
    gtk_list_store_set(pListStore, &pIter,N_COLUMN,ELLA_FRAME_KEY_EMPTY,-1);/* image-clef dans la première par défaut */
    for(i = N_COLUMN+1 ; i < MAX_FRAMES ; i++)
        {          	
             gtk_list_store_set(pListStore, &pIter,i,ELLA_FRAME_NON_USED,-1);
	    }/* for i */	
    g_free(sLayerName);        	
	/* afficher les éléments dans la time line */
	//draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),LayerCount+1,ScrolledWindowTimeLine);
	/* incrémenter le compteur de calques */
	LayerCount=LayerCount+1;
	/* à ce stade, rootGroup pointe sur le groupe de ce layer */
	/* initialiser la liste des images-clés */
	keyframes_list=NULL;
	rootKF= goo_canvas_group_new(rootGroup,NULL);
	keyframes_list=add_liste_keyframes(keyframes_list, 0, TRUE, FALSE, FALSE, FALSE,FALSE,
	            FALSE,FALSE, 0, 0, 0, 0,100,100, rootKF);
	gtk_list_store_set(pListStore, &pIter,LAYER_MOVEMENT_INDEX,keyframes_list, -1);
}
/************************************
 * affichage d'un layer sans 
 * paramètres globaux ;
 * peut-être appelé depuis d'autres
 * modules ; attention : ligne doit
 * être en coordonnées humaines
 * *********************************/
void timeline_draw_layer_bg(gint ligne)
{
	draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ligne,ScrolledWindowTimeLine);
}
/**********************************
 * fonction pour détruire le 
 * contenu de TOUS les calques
 * *******************************/
void timeline_clear_layers(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter iter;
 gint count;
 
  if (LayerCount<=0)
       return;
	   printf("layercount %d",LayerCount);
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  path1=g_strdup_printf ("%d:%d",0,0);/* astuce, car l'ordre de la pile est progressivement détruit ! */
  path=gtk_tree_path_new_from_string(path1);
  for (count=0;count<LayerCount;count++)
     {    	   
       gtk_tree_model_get_iter(model, &iter, path);
       /* effacer les items */
	   gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, &rootGroup, -1);
	   goo_canvas_item_remove (rootGroup);/* ne marche pas ! */
	   rootGroup=NULL;
       /* effacer la liste des keyframes */
	   gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX,
	       (gpointer)&keyframes_list, -1);
	   raz_liste_keyframes(keyframes_list);
	   keyframes_list=NULL;
	   gtk_list_store_remove(GTK_LIST_STORE(model),&iter);
	   /* effacer les dessins de la timeline */
	   remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count);   
     }/* next count */       	
  g_free(path1);
  gtk_tree_path_free(path);  
  LayerCount=0;   
  fModified=TRUE;
}
/**********************************
 * fonction pour mettre à zéro les
 * variables utiles de l'extérieur
 * du module
 * *******************************/
void timeline_raz_vars(void)
{
	xcell = 1;
	ycell = 1;
	xruler = 1;
	MovieFreq=timeline_get_default_movie_freq();
    MoviePos=1;
    x1sel=1;
    y1sel=1;
    x2sel=1;
    y2sel=1;
    LayerSelected=0;
}
/*********************************
 * fonction pour connaître la
 * fréquence du film
 * ******************************/
gint timeline_get_movie_freq(void)
{
	return MovieFreq;
}
/***********************************
 * fonction pour régler la fréquence
 * du film
 * ********************************/
void timeline_set_movie_freq(gint fps, gboolean visi)
{
	if (fps<0)
	  fps=12;
	MovieFreq=fps;
	/* modifier l'affichage */
	if (visi)
	   gtk_spin_button_set_value( (GtkSpinButton *)spinbuttonMovieFrequency,fps);	
} 
void timeline_set_default_movie_freq(gint fps)
{
	if (fps<0)
	  fps=12;
	timeline_defaut_MovieFreq=fps;	
} 
gint timeline_get_default_movie_freq(void)
{
	
	return timeline_defaut_MovieFreq;	
}
void timeline_set_default_movie_zoom(gint zoom)
{
	switch (zoom)
	 {
	  case 0:
	   {zoom=100;break;}
	  case 1:
	   {zoom=75;break;}
	  case 2:
	   {zoom=50;break;}
	 }/* end case */ 
	TimelineZoom=zoom;	
}
/*****************************************
 * gestion de la liste des images-clés
 * **************************************/
/**********************/
/* libérer la mémoire */
/*********************/

void free_data_keyframes (effects_data_type *p)
{
    g_free(p);
}
/**********************
 RAZ de la liste
**********************/
void raz_liste_keyframes(GSList *list)
{
   gint    nIndex;
   GSList *node;

   if (list==NULL)
        return;
   for (nIndex = 0; node = g_slist_nth (list, nIndex); nIndex++) 
      {
		/* détruire le groupe, mais cela détruit-il les sous_items ? */
		goo_canvas_item_remove (((effects_data_type *)(node->data))->rootKF);
        free_data_keyframes(((effects_data_type *)(node->data)));
      }/* for */
   g_slist_free (list);
}
/************************************
 * modifier le contenu d'une image-
 * clef existante ; fonctionne un
 * peu comme G_OBJECT_SET ;
 * l'instruction est en mode texte,
 * suivie d'un flag actif ou pas,
 * puis de la valeur du paramètre ; 
 * renvoit TRUE si pas de pb.
 * *********************************/
gboolean set_keyframe_datas(GSList *list, guint kf,
							gchar *instruction,
							gboolean flag,
							gdouble valeur
                            )
{
   gint    nIndex,total;
   GSList *temp;
   gboolean trouve=FALSE;
   gboolean efm,efr, efz,efalpha,eflumi; /* flags des effets */
   gint zoom, alpha, lumi; /* valeur des effets */
   gdouble rot; /* valeur rotation */
   
	/* vérifier que l'image-clé existe ! */
   if (list==NULL)
        return FALSE;
		
		
   /* on cherche le nombre total actuel d'éléments de la liste */ 
   total=g_slist_length(list);	
   nIndex=0;
   while ((!trouve)&&(nIndex<total))
     {
		temp = g_slist_nth (list, nIndex);
		if (((effects_data_type *)(temp->data))->keyframe==kf)
		   {
			   trouve=TRUE;
			   /* aiguiller selon l'instruction */			   
			   /* interpolation */
			    if (strcmp("inter",instruction)==0)
				  {
			        ((effects_data_type *)(temp->data))->effect_motion=flag;	
					//printf("mis en place motion ! \n pour ik %d flag %d",kf,flag);		   
				  }
			   /* effet de rotation */
			   if (strcmp("rotatf",instruction)==0)
				  {
			       ((effects_data_type *)(temp->data))->effect_rotation=flag;
			      }
			   if (strcmp("rotatv",instruction)==0)
				  {
			       ((effects_data_type *)(temp->data))->rotation=valeur;
			      }				  
			   /* effet de zoom */
			    if (strcmp("zoomf",instruction)==0)
				  {			   
			        ((effects_data_type *)(temp->data))->effect_zooming=flag;
				  }
			    if (strcmp("zoomv",instruction)==0)
				  {			   
			        ((effects_data_type *)(temp->data))->zoom=(gint)valeur;
				  }				  
			   /* effet transparence alpha */
			    if (strcmp("alphaf",instruction)==0)
				  {			   
			       ((effects_data_type *)(temp->data))->effect_alpha=flag;
			      }
			    if (strcmp("alphav",instruction)==0)
				  {			   
			       ((effects_data_type *)(temp->data))->alpha=(gint)valeur;
			      }				  
			   /* effet lumière fading */
			    if (strcmp("lumif",instruction)==0)
				  {			   
			        ((effects_data_type *)(temp->data))->effect_lumi=flag;
				  }
			    if (strcmp("lumiv",instruction)==0)
				  {			   
			        ((effects_data_type *)(temp->data))->lumi=(gint)valeur;
				  }				  
			   /* morphing effect */
			    if (strcmp("morpf",instruction)==0)
				  {
			       ((effects_data_type *)(temp->data))->effect_morphing=flag;
			      }	
				if (strcmp("morpv",instruction)==0)
				  {
			       ((effects_data_type *)(temp->data))->morphing=valeur;
			      }	  	  
		   }
		nIndex++;		 
	 }/* wend */
  return trouve;	 
}
/****************************
 * procédure pour connaître
 * la valeur courante du
 * layer (coordonnées 
 * humaines) 
 * *************************/
gint timeline_get_current_frame(void)
{
	return xcell;
}
/****************************
 * procédure pour connaître
 * la valeur courante de la
 * trame (coordonnées 
 * humaines) 
 * *************************/
gint timeline_get_current_layer(void)
{
	return ycell;
}
/****************************
 * obtenir le pointeur sur
 * la keyframes_list depuis
 * l'extérieur ; attention !
 * 
 * Renvoit seulement le
 * pointeur, en supposant 
 * qu'il pointe bien sur
 * la "bonne" liste
 * **************************/
GSList *timeline_get_keyframes_list(void)
{
	return keyframes_list;
}
/************************************
 ajouter à la liste
 - parametres = effets possibles
 * INSERTION INTELLIGENTE, tri
 * automatique
*************************************/
GSList  *add_liste_keyframes(GSList *list,
                    guint kf, gboolean vide,
					gboolean efm, gboolean efr,
					gboolean efz, 
					gboolean efalpha, gboolean eflumi,gboolean efmorph,
					gint xm, gint ym, gint z, gdouble r, 
					gint alpha, gint lumi,
					GooCanvasItem *rKF)
{
 GSList *temp;
 gint nIndex,nearest,total;
 GooCanvasItem *source;
 effects_data_type *temp_data;
 gboolean sortir=FALSE;
 
 /* réservation MEM pour nouvell image-clé */
 temp_data = g_malloc(sizeof(effects_data_type));
 temp_data->keyframe=kf;
 temp_data->empty=vide;
 temp_data->effect_motion=efm;
 temp_data->effect_rotation=efr;
 temp_data->effect_zooming=efz;
 temp_data->effect_alpha=efalpha;
 temp_data->effect_lumi=eflumi;
 temp_data->effect_morphing=efmorph;
 temp_data->sound=FALSE;/* no sound allowed for a standard keyframe */
 temp_data->sound_file=NULL;/* no sound file attached by default */
 temp_data->x_move=xm;
 temp_data->y_move=ym;
 temp_data->zoom=z;
 temp_data->rotation=r;
 temp_data->rootKF=rKF;
 
 /* on cherche le nombre total actuel d'éléments de la liste */
  
 total=g_slist_length(list);	  
 
 /* trier la liste */
 sortir=FALSE;
 nIndex=total-1;/* tj >= 0*/
 source=NULL;
 /* on fait une boucle inversée */
 if (total>0) /* liste déjà crée */
   {
     while (!sortir)
	  {
	  	temp = g_slist_nth (list, nIndex);
	  	source=((effects_data_type *)(temp->data))->rootKF;  
		nearest=((effects_data_type *)(temp->data))->keyframe;
	  	if ((nearest<=kf)||(nearest==0))
          {          	
          	sortir=TRUE;
	      }
		nIndex--;
      }/* wend */
	  /* on compte depuis 0, logique PC */
     //printf("je vais insérer après l'élément %d\n",nIndex+1);
	 temp= g_slist_insert(list,temp_data,nIndex+2);	 
    }/* total>0*/
 else
   /* création de la liste donc pas de tri */
   {
     temp = g_slist_append (list,temp_data);
   }
 return temp;
}
/************************************
 * chercher un item dont le
 * titre est connu dans la pile
 * des images ; si trouvé, renvoit
 * l'adresse du pixbuf, sinon NULL
 * *********************************/
GdkPixbuf *find_item_on_images_stack_tl(GSList *pile,gchar *titre)
{
  typedef struct
      {
		  GdkPixbuf *pixb;
		  gchar *nom;
	  } stack_images;	
	
   gboolean	trouve;
   gint    nIndex;
   GSList *temp;
   gint j;
   GdkPixbuf *pb=NULL;
      
   trouve=FALSE;
   j=0;
   if (pile==NULL)
        return NULL;/* pourquoi la pile peut-être NULL parfois alors qu'elle a un élément ? */
   if (titre==NULL)
	  return NULL;	
   /* début boucle */
	temp = g_slist_nth (pile, j);				  
	while ((temp!=NULL)&&(trouve==FALSE))
	  { 
		if (  strcmp(   ((stack_images *)(temp->data))->nom,titre)==0   )
          {          	
			trouve=TRUE;
			pb=((stack_images *)(temp->data))->pixb;
          }	
		else
		  {	  
		    j++;
		    temp = g_slist_nth (pile, j);
		  }
	  }/* wend */			  
   return pb;
}

/***************************************
 * dupliquer un item vers un groupe 
 * d'items
 * ************************************/
void dup_item(GooCanvasItem *dest, GooCanvasItem *item)
{
   gchararray title,texte,fonte;
   guint32 fcolor,scolor;
   gdouble lw;
   gdouble angle;
   gdouble x,y,width, height;/* pour les rectangles */
   gdouble xc,yc,rx,ry; /* pour les ellipses */
   GooCanvasPoints *l_pts;
   GooCanvasBounds area;
   GooCanvasItem *nouveau;
   GdkPixbuf *pb;
   gchar *path,*diese;   
   
   if (item==NULL)
       {printf("tien à copier ! \n");
        return;}
   /* switcher selon le type d'objet */
   g_object_get(item,"title",&title,NULL);
   if (title==NULL)
     return;
   g_object_get(item, "fill_color_rgba" ,&fcolor,"stroke-color-rgba",&scolor,"line-width",&lw,NULL);
   /* récupérer anciennes coordonnées */
   /* recréer à la nouvelle position */
    if (strncmp("R",title,1)==0)
     {
       g_object_get(item,"x",&x,"y",&y,"width",&width,"height",&height,NULL);
       nouveau=goo_canvas_rect_new(dest,x,y,width,height,
                  "fill-color-rgba" ,fcolor,"stroke-color-rgba",scolor,"line-width",lw,NULL);
       g_object_set(G_OBJECT(nouveau),"title",title,NULL);	
       return;
     }
    if (strncmp("P",title,1)==0)
     {
       diese= g_strrstr(title, "#");
	   if (diese!=NULL)
	     {
			 path=(gchar *)file_str_sub_extension (title, diese-title+1,strlen(title)-1);
			 // printf("path dans dup:%s<<\n",path); 
			  g_object_get(item,"x",&x,"y",&y,"width",&width,"height",&height,NULL); 
	         nouveau= goo_canvas_path_new (dest,path,"line-width",lw, 
	            "stroke-color-rgba", scolor,"fill-color-rgba",fcolor,NULL);
             g_object_set(G_OBJECT(nouveau),"title",title,NULL);
	         g_free(path);
			 /* then we size the object */
			 g_object_set(G_OBJECT(nouveau),"x",x,"y",y,"width",width,"height",height,NULL);	     
		 }
		return; 
     }	 
	if (strncmp("U",title,1)==0)
     {
       diese= g_strrstr(title, "#");
	   if (diese!=NULL)
	     {
			 path=(gchar *)file_str_sub_extension (title, diese-title+1,strlen(title)-1);
			 g_object_get(item,"x",&x,"y",&y,"width",&width,"height",&height,NULL); 
	         nouveau= goo_canvas_path_new (dest,path,"line-width",lw, 
	            "stroke-color-rgba", scolor,"fill-color-rgba",fcolor,NULL);
             g_object_set(G_OBJECT(nouveau),"title",title,NULL);
	         g_free(path);
			 /* then we size the object */
			 g_object_set(G_OBJECT(nouveau),"x",x,"y",y,"width",width,"height",height,NULL);	     
		 }
		return; 
     }	 
	if (strncmp("B",title,1)==0)
     {
       g_object_get(item,"x",&x,"y",&y,"width",&width,"height",&height,NULL);
	   pb=find_item_on_images_stack_tl(pile_images,title);
       nouveau=goo_canvas_image_new(dest,pb,x,y);
       g_object_set(G_OBJECT(nouveau),"title",title,NULL);	
       return;
     }
    if (strncmp("C",title,1)==0)
     {
       g_object_get(item,"center_x",&xc,"center_y",&yc,"radius_x",&rx,"radius_y",&ry,NULL);
       nouveau=goo_canvas_ellipse_new(dest,xc,yc,rx,ry,
                    "fill-color-rgba" ,fcolor,"stroke-color-rgba",scolor,"line-width",lw,NULL);
       g_object_set(G_OBJECT(nouveau),"title",title,NULL); 
       return;
     } 
    if (strncmp("L",title,1)==0)
     {
       l_pts= goo_canvas_points_new(2);/* lignes simples */
       g_object_get(item,"points",&l_pts,NULL);
       nouveau=goo_canvas_polyline_new_line(dest,
                   l_pts->coords[0],l_pts->coords[1],
	               l_pts->coords[2],l_pts->coords[3],
	               "fill-color-rgba" ,fcolor,"stroke-color-rgba",scolor,"line-width",lw,
	               NULL);	              
       goo_canvas_points_unref(l_pts); 
       g_object_set(G_OBJECT(nouveau),"title",title,NULL);
       return;
     }
    if (strncmp("T",title,1)==0)
     {
       g_object_get(item,"x",&x,"y",&y,"text",&texte,"font",&fonte,NULL);
       nouveau=goo_canvas_text_new (dest, texte, x, y, -1,
				   GTK_ANCHOR_CENTER,
				   "font", fonte,
				   "fill-color-rgba" ,fcolor,"stroke-color-rgba",scolor,"line-width",lw,
				   NULL);
       g_object_set(G_OBJECT(nouveau),"title",title,NULL);
       return;
     }   
}
/*************************************
 * dupliquer le contenu de l'image-clé
 * précédente dans l'image-clé
 * fournie en paramètre
 * (coordonnées PC) ; autre
 * paramètre : la keyframes_list
 * et le pointeur, déjà initialisé,
 * sur le groupe d'items de l'image
 * clé courante
 * **********************************/
void dup_keyframe(GSList *list, GooCanvasItem *grp, guint kf)
{
	GSList  *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	gboolean sortir=FALSE;
	GooCanvasItem *source, *dest, *item;
	gchararray title;
			
	if (kf==0)
	   return; /* nous sommes sur la première image-clé ! Donc, rien à faire */
	/* récupérer un pointeur sur le groupe d'items de l'image-clé précédente */
	nIndex=0;
	while (!sortir)
	  {
	  	temp = g_slist_nth (list, nIndex);
	  	source=((effects_data_type *)(temp->data))->rootKF;  
	  	//printf("avant nIndex %d   keyframe %d \n",nIndex,((effects_data_type *)(temp->data))->keyframe);
	    nIndex++;        	
	    temp = g_slist_nth (list, nIndex);
	    //printf("après nIndex %d   keyframe %d \n",nIndex,((effects_data_type *)(temp->data))->keyframe);
	  	if (((effects_data_type *)(temp->data))->keyframe==kf)
          {          	
          	sortir=TRUE;
          	printf("trouveé %d\n",kf);
          }
      }/* wend */
	
	//printf("nombre total d'enfants %d \n",goo_canvas_item_get_n_children (source));
	/* boucle pour transférer les items */
	nIndex=0;
	while (nIndex<goo_canvas_item_get_n_children (source))		
	   {
	   	 item=goo_canvas_item_get_child(source,nIndex);
	   	 //printf("rang %d\n",nIndex);
	   	 if (item!=NULL)
	   	   {
			   /* ici, un gros bug, avec des items sans titre ! */
	   	   	printf("trouvé un item à copier ! \n");
	   	   	g_object_get(item,"title",&title,NULL);
	   	   	printf("titre %s\n",title);
            dup_item(grp,item);
	   	   	//goo_canvas_item_add_child(grp,item,nIndex);// faux car ne fait que depliquer le PERE !
		   }	
		 nIndex++;	
	   }/* wend */	
}
/*********************************
 * retirer une image-clé de la
 * liste 
 * ******************************/
GSList *remove_liste_keyframes(GSList *list, guint kf)
{
	GSList *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	
	if (kf<=0)
	   return list;
	for (nIndex = 0; temp = g_slist_nth (list, nIndex); nIndex++) 
      {
        if (((effects_data_type *)(temp->data))->keyframe==kf)
          {
          	/* retirer les items */
          	goo_canvas_item_remove(((effects_data_type *)(temp->data))->rootKF);
          	/* retirer de la liste */
          	temp=g_slist_remove(list,temp->data);
          	return temp;
          }
      }/* for */
	return temp;
}
/******************************************
 * modify the content of a keyframe_list in
 * order to store a sound
 * be careful : the keyframe_list must be
 * initalized before this function call, i.e
 * the kf must be set to an active keyframe !
 * ****************************************/

void set_liste_keyframes_for_sound(GSList *list, guint kf,gchar *sound_fich)
{
	GSList *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	
	if (kf<0)
	   return;

	for (nIndex = 0; temp = g_slist_nth (list, nIndex); nIndex++) 
      {
        if (((effects_data_type *)(temp->data))->keyframe==kf)
          {
				  if (((effects_data_type *)(temp->data))->sound==TRUE)
				       g_free(((effects_data_type *)(temp->data))->sound_file); 
                  /* the new values are now stored in the keyframe_list */
                  ((effects_data_type *)(temp->data))->sound=TRUE;
                  ((effects_data_type *)(temp->data))->sound_file=g_strdup_printf("%s",g_path_get_basename(sound_fich));
          }
      }/* for */
}
/*********************************
 * récupérer le pointeur sur
 * le GroupItem de la plus proche
 *  image-clef valide pour la
 * colonne fournie
 * coordonnées PC
 * ******************************/
GooCanvasItem *get_nearest_keyframe_group(GSList *list, guint kf)
{
	GooCanvasItem *source;
	GSList *temp;
	effects_data_type *temp_data;
	gint nIndex,nearest,total;
	gboolean sortir=FALSE;
	
	/* on cherche le nombre total d'éléments de la liste */
	
	
	total=g_slist_length(list);
		
	sortir=FALSE;
	nIndex=total-1;
	source=NULL;
	/* on fait une boucle inversée */
	//printf("---------------------\n");
	while (!sortir)
	  {
	  	temp = g_slist_nth (list, nIndex);
		if (temp==NULL)
		   return source;
	  	source=((effects_data_type *)(temp->data))->rootKF;  
		nearest=((effects_data_type *)(temp->data))->keyframe;
		//printf("donnée : %d / nearest = %d\n",kf,nearest);       		    		
		//temp = g_slist_nth (list, nIndex);
	  	if ((nearest<=kf)||(nearest==0))
          {          	
          	sortir=TRUE;
			//printf("trouvé nearest %d \n",nearest);
          }
		nIndex--;
      }/* wend */
	return source;
}
/*********************************
 * récupérer le pointeur sur
 * le GroupItem d'une
 * image-clef ;
 * coordonnées PC ;
 * attention, fonction danregeuse
 * si tests, quand elle renvoit
 * NULL cela ne signifie pas que
 * la liste des keyframes est vide !
 * ********************************/
GooCanvasItem *get_keyframe_group(GSList *list, guint kf)
{
	GooCanvasItem *tempItem=NULL;
	GSList *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	
	for (nIndex = 0; temp = g_slist_nth (list, nIndex); nIndex++) 
      {      	
        if (((effects_data_type *)(temp->data))->keyframe==kf)
          {
            tempItem = ((effects_data_type *)(temp->data))->rootKF;
          	return tempItem;
          }
      }/* for */
	return tempItem;
}
/**************************************
 * obtain the sound file field of a
 * keyframe, in PC coordinates
 * ***********************************/
gchar *get_keyframe_sound_file_field(GSList *list, guint kf)
{
	gchar *tempStr=NULL;	
	GSList *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	
	for (nIndex = 0; temp = g_slist_nth (list, nIndex); nIndex++) 
      {      	
        if (((effects_data_type *)(temp->data))->keyframe==kf)
          {
            tempStr =g_strdup_printf("%s", ((effects_data_type *)(temp->data))->sound_file);
          	return tempStr;
          }
      }/* for */
	return tempStr;
}
/**************************
 * échanger deux valeurs
 * entières
 * ***********************/
void swap(int *i, int *j) 
{
   int t = *i;
   *i = *j;
   *j = t;
}
/**************************************
 * rendre visible ou pas une 
 * image-clé sur le calque courant ;
 * en entrée : la rang en 
 * coordonnées humaines ET
 * le pointeur sur la GSList stockant
 * les images-clés du calque
 * ***********************************/
void set_keyframe_visibility(guint kf, GSList *list, gboolean visi)
{
 GooCanvasItem *item;
 
 item=get_nearest_keyframe_group(list, kf-1);
 if (!item)
   {
	 printf("pas trouvé de précédent à afficher !\n");
    return;
   }
 if (visi)
    g_object_set(item,"visibility",GOO_CANVAS_ITEM_VISIBLE,NULL);
 else
    g_object_set(item,"visibility",GOO_CANVAS_ITEM_INVISIBLE,NULL);    
}
/************************************
 * activer visibilité ou pas de toute 
 * la colonne correspondant à la
 * position x (coordonnées humaines
 * ie 1er = 1
 * )
 * fournie ;
 * keyframes_list pas mise à jour
 * *********************************/
void set_drawings_visibility(guint kf, gboolean visi)
{
 gint count;
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 GSList *temp;
 gboolean visible;

	for (count=0;count<LayerCount;count++)
	   {
	   	  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));     
          path1=g_strdup_printf ("%d:%d",count,0);
          path=gtk_tree_path_new_from_string(path1);      
          gtk_tree_model_get_iter(model, &pIter, path);
          /* on pointe sur le bon élément, reste à récupérer le pointeur sur la liste des keyframes */
          gtk_tree_model_get(model, &pIter, LAYER_MOVEMENT_INDEX, (gpointer)&temp, -1);
		  gtk_tree_model_get(model, &pIter, LAYER_VISIBLE_COLUMN, &visible,-1);
		  /* à ce stade, temp=keyframe_list pointe sur celle du calque courant */
		  if (!visible)
		     set_keyframe_visibility(kf,temp,FALSE);
		  else
		     set_keyframe_visibility(kf,temp,visi);
          g_free(path1);
          gtk_tree_path_free(path);
	   }/* next*/
}
/************************************
 * activate or de-activate the editor
 * window ; human coordinates
 * *********************************/
void set_editor_visibility(gint x,gint y)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint type_layer;
 
	   	  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));     
          path1=g_strdup_printf ("%d:%d",y-1,0);
          path=gtk_tree_path_new_from_string(path1);      
          gtk_tree_model_get_iter(model, &pIter, path);
          /* on pointe sur le bon élément, reste à récupérer le pointeur sur la liste des keyframes */
          gtk_tree_model_get(model, &pIter, LAYER_TYPE, &type_layer, -1);
          if (type_layer==SOUND_LAYER)
		     /* de-activate editor */
			gtk_widget_set_sensitive ( pWinTimelineEditor,FALSE);	
		  else
		    gtk_widget_set_sensitive ( pWinTimelineEditor,TRUE);	 
          g_free(path1);
          gtk_tree_path_free(path);
}
/****************************
 * lire le contenu d'une
 * cellule ;
 * coordonnées humaines
 * entièrement locale
 * *************************/ 
guint frame_cell_get (GtkWidget *w, gint x, gint y)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 guint cell;
 
  if ((x<1)||(x>MAX_FRAMES)||(y<1)||(y>MAX_LAYERS))
       return;
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(w));     
  path1=g_strdup_printf ("%d:%d",y-1,N_COLUMN+x-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+x-1,&cell,  -1); 
  g_free(path1);
  gtk_tree_path_free(path);
  return cell;  
}
/***********************************
 * tester depuis l'extérieur l'état
 * d'une cellule
 * ********************************/
guint timeline_frame_cell_get(void)
{
	return frame_cell_get(pListViewLayers,xcell,ycell);
}
/*********************************
 * procédure pour tester l'état
 * de l'image courante, et la
 * modifier s'il s'agit d'une
 * image-clé vide ...
 * appelé depuis interface.c
 * ******************************/
void set_keyframe()
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;

  efface_curseur_regle();
  efface_curseur_timeline();
  /* récupérer itérateurs depuis le début de la ligne, pour modifier le contenu des cellules  */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  /* poser la nouvelle image-clef */ 
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (cell!=ELLA_FRAME_NON_USED)
         {     
         	/* s'il s'agit d'une image clé vide, le pointeur sur le groupe existe déjà */
         	if (cell==ELLA_FRAME_KEY_EMPTY)
         	   {
				cell=ELLA_FRAME_KEY_USED;
			   }
			else
			  {
			  	/* on doit créer un nouveau groupe */
			  	if (
				((cell & ELLA_FRAME_KEY_USED)!=ELLA_FRAME_KEY_USED)
				&&
				((cell & ELLA_FRAME_MOVEMENT)!=ELLA_FRAME_MOVEMENT)
				)
			  	  {
			  	    rootKF =  goo_canvas_group_new(rootGroup,NULL);
         	        add_liste_keyframes( keyframes_list, xcell-1, FALSE, FALSE, FALSE, FALSE,
					                    FALSE,FALSE,FALSE, 0, 0, 0, 0,100,100, rootKF);
				  }
			  }
            cell= (cell | ELLA_FRAME_KEY_USED);
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);  
		 }/* endif image active */
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell); 
  fTimeLineSelection=FALSE; 
}
/******************************
 * callbacks liées au menu
 * contextuel de la timeline
 * ***************************/ 
void paste_keyframe(GooCanvasItem *dest, GooCanvasItem *source)
{
	gint    nIndex;
	GooCanvasItem  *item;
	gchararray title;
	
	/* rendre le rootgroup invisble */		
	 g_object_set(dest,"visibility",GOO_CANVAS_ITEM_INVISIBLE,NULL); 
	/* boucle pour transférer les items */
	nIndex=0;
	while (nIndex<goo_canvas_item_get_n_children (source))		
	   {
	   	 item=goo_canvas_item_get_child(source,nIndex);
	   	 if (item!=NULL)
	   	   {
	   	   	g_object_get(item,"title",&title,NULL);
            dup_item(dest,item);
		   }	
		 nIndex++;	
	   }/* wend */	
}
/*****************************************
 * décaler un ensemble de pointeurs
 * d'images-clés :
 * *list = pointeur sur la keyframe_list
 * * ksource, kdest = numéros, langage PC,
 * des sources et destinations ;
 * renvoit un pointeur sur la keyframe_list
 * modifiée
 * *****************************************/
void shift_keyframe_items(gint kSource,gint kDest)
{
	GSList *retour=NULL;
	GooCanvasItem *source, *dest=NULL;
	
	if ((kSource<0)||(kDest<0))
	  {
		printf("problème valeur <0 \n");
	    return;
	  }
	/* chercher un pointeur valide sur la source (i.e contient-t-elle des 
	 * éléments graphiques */
	source=get_keyframe_group(keyframes_list,kSource);
	/* chercher un pointeur sur la destination */
	dest=get_keyframe_group(keyframes_list,kDest);
	/* effacer le contenu de la destination qui va être écrasé */
	if (dest!=NULL)
	   keyframes_list=remove_liste_keyframes(keyframes_list,kDest);  
	if (source!=NULL)
	   {	     
	     /* créer une image-clé vide pour la destination */
	     /* mettre à jour la liste des images-clés ! */
         dest =  goo_canvas_group_new(rootGroup,NULL);
	     /* réservation MEM pour nouvelle image-clé */
         add_liste_keyframes( keyframes_list, kDest, TRUE, FALSE, FALSE, FALSE,
			                     FALSE,FALSE,FALSE, 0, 0, 0, 0,100,100, dest);
	     /* transférer le contenu de l'image-clé source! */ 
	     if (source!=NULL)
	       {
		      paste_keyframe(dest, source);
	       }
	   }/*endif */
}
/* *****************************
 * ajouter "n" images depuis
 * la position du curseur
 * ****************************/
void timeline_add_keyframes_from_cursor(gint n_images)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 
  efface_curseur_regle();
  efface_curseur_timeline();
  /* récupérer itérateurs depuis le début de la ligne, pour modifier  le contenu des cellules
   * */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers)); 
  for (count=xcell;count<xcell+n_images-1;count++)
    { 
      path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+count);
      path=gtk_tree_path_new_from_string(path1);      
      gtk_tree_model_get_iter(model, &pIter, path);
      gtk_tree_model_get (model, &pIter,N_COLUMN+count,&cell,  -1);
      if (cell==ELLA_FRAME_NON_USED)
         {
         	cell = ELLA_FRAME_USED_EMPTY;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+count,cell,-1);
		 }
      g_free(path1);
      gtk_tree_path_free(path);
    }/* for count */
  
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell); 
  fModified=TRUE;	
}
/* *****************************
 * ajouter des images jusqu'à 
 * la position du curseur
 * ****************************/
void timeline_add_keyframes_to_cursor(void)
{
GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 
  efface_curseur_regle();
  efface_curseur_timeline();
  /* récupérer itérateurs depuis le début de la ligne, pour modifier  le contenu des cellules
   * */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers)); 
  for (count=0;count<xcell;count++)
    { 
      path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+count);
      path=gtk_tree_path_new_from_string(path1);      
      gtk_tree_model_get_iter(model, &pIter, path);
      gtk_tree_model_get (model, &pIter,N_COLUMN+count,&cell,  -1);
      if (cell==ELLA_FRAME_NON_USED)
         {
         	cell = ELLA_FRAME_USED_EMPTY;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+count,cell,-1);
		 }
      g_free(path1);
      gtk_tree_path_free(path);
    }/* for count */
  
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell); 
  fModified=TRUE;	
}
void cb_new_frames (GtkWidget *p_widget, gpointer user_data)
{
   timeline_add_keyframes_to_cursor();
} 
/* mouchard keyframes_list */
void mouchard(void)
{
	GooCanvasItem *tempItem=NULL;
	GSList *temp;
	effects_data_type *temp_data;
	gint    nIndex;
	
	
	if (keyframes_list==NULL)
	   printf("gros pb kfl \n");
	for (nIndex = 0; temp = g_slist_nth (keyframes_list, nIndex); nIndex++) 
      {      	       
           // tempItem = ((effects_data_type *)(temp->data))->rootKF;
		   if (((effects_data_type *)(temp->data))->sound==TRUE)
		      {
				  printf("trouvé son position :%d morceau %s \n",((effects_data_type *)(temp->data))->keyframe, 
				     ((effects_data_type *)(temp->data))->sound_file);
			  }
      }/* for */	   
}
/***********************************
/* effacer des images sélectionnées.
 * En paramètre, les 4 coins de la 
 * zone à détruire ; coordonnées
 * humaines
 * ********************************/
void timeline_remove_selected_frames(gint x1,gint y1, gint x2, gint y2)
{
  guint cell;
  gint count,diff, count_ligne;
  GtkTreeModel *model,*model2;
  GtkTreePath *path,*path2;
  gchar *path1,*path3;
  GtkTreeIter pIter,iter2;
  GSList *TmpKeyframesList=NULL;
  
  /* swapping */
  if (x2<x1)
    swap(&x1,&x2);
  if (y2<y1)
    swap(&y1,&y2);
    
  efface_curseur_regle();
  efface_curseur_timeline();  
  /* vérifier que la sélection comprend uniquement des images actives */
  cell = frame_cell_get (pListViewLayers, x1, y1); 
  if (cell==ELLA_FRAME_NON_USED)
    return;
  cell = frame_cell_get (pListViewLayers, x2, y2);
  if (cell==ELLA_FRAME_NON_USED)
    return;
  /* zone valide : retirer, décaler les éléments */ 
  diff=x2-x1+1;/* nombre de cases à décaler */

  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers)); 
  model2=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers)); 
  for (count_ligne=y1;count_ligne<=y2;count_ligne++)
    {
	  path3=g_strdup_printf ("%d:%d",count_ligne-1,0);
	  path2=gtk_tree_path_new_from_string(path3);      
      gtk_tree_model_get_iter(model2, &iter2, path2); 
	  gtk_tree_model_get (model2, &iter2,LAYER_MOVEMENT_INDEX,(gpointer)&keyframes_list,-1);	
      for (count=x1;count<=MAX_FRAMES-diff;count++)
        {
    	  cell = frame_cell_get(pListViewLayers, count+diff,count_ligne); /* coord humaines */   	
    	  path1=g_strdup_printf ("%d:%d",count_ligne-1,N_COLUMN+count-1);
          path=gtk_tree_path_new_from_string(path1);      
          gtk_tree_model_get_iter(model, &pIter, path);
		  gtk_tree_model_get (model, &pIter, LAYER_GROUP_DRAW, &rootGroup, -1);
		  /* prévoir un test : si coord =0, alors obligation image-clé */
          if (count-1>0)
              gtk_list_store_set(pListStore, &pIter,N_COLUMN+count-1,cell,-1);    
		  else
		     {
				 if (cell>ELLA_FRAME_USED_EMPTY)
				   /* donc une image non vide */
				    gtk_list_store_set(pListStore, &pIter,N_COLUMN+count-1,cell,-1);
				 else
				   /* mettre par défaut une image-clé vide */
				   gtk_list_store_set(pListStore, &pIter,N_COLUMN+count-1,ELLA_FRAME_KEY_EMPTY,-1);
			 }     
		  g_free(path1);
          gtk_tree_path_free(path);	
        }/* for count */	
	   /* mise à jour des images-clés */
	   for (count=x1;count<=MAX_FRAMES-diff;count++)
	        {			
				gtk_tree_model_get (model, &iter2,LAYER_MOVEMENT_INDEX,&keyframes_list,-1);		
				shift_keyframe_items(count+diff-1,count-1);		
		        gtk_list_store_set(pListStore, &iter2,LAYER_MOVEMENT_INDEX,keyframes_list,-1);		
			}/* for count */	
			/* le pb est cette ligne : la keyframe_list ne semble pas modifiée ! */
	   //gtk_list_store_set(pListStore, &iter2,LAYER_GROUP_DRAW,(gpointer)rootGroup,-1);				
	   g_free(path3);
	   gtk_tree_path_free(path2);
     }/* for count_ligne */
	 
  /* effacer les éléments restants après la fin de zone décalée */
   for (count_ligne=y1;count_ligne<=y2;count_ligne++)
    {
    	for (count=MAX_FRAMES;count>MAX_FRAMES-diff;count--)
    	  {
    	  	path1=g_strdup_printf ("%d:%d",count_ligne-1,N_COLUMN+count-1);
            path=gtk_tree_path_new_from_string(path1);      
            gtk_tree_model_get_iter(model, &pIter, path);
			gtk_tree_model_get (model, &pIter,LAYER_MOVEMENT_INDEX,&TmpKeyframesList,-1);
            gtk_list_store_set(pListStore, &pIter,N_COLUMN+count-1,ELLA_FRAME_NON_USED,-1);
			remove_liste_keyframes(TmpKeyframesList, count-1);
            g_free(path1);
            gtk_tree_path_free(path);
		  } /* for count */
        remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count_ligne-1);
        draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),count_ligne,ScrolledWindowTimeLine);		  
    }/* for count_ligne */
  ycell=y1;
  fTimeLineSelection=FALSE;
  affiche_curseur_timeline(xcell,ycell,xcell,ycell);
  affiche_curseur_regle(rootRuler,xcell); 
  fModified=TRUE;	
}
/******************************************
 * supprimer sélection depuis l'interface
 * ***************************************/
void timeline_remove_selection(void)
{
	timeline_remove_selected_frames(x1sel,y1sel,x2sel,y2sel);
}
/**************************
 * supprimer des images
 * ***********************/
void cb_remove_frames (GtkWidget *p_widget, gpointer user_data)
{
   timeline_remove_selected_frames(x1sel,y1sel,x2sel,y2sel);
} 
/*******************************
 * créer une nouvelle image-clé
 * vide
 * ****************************/
void timeline_new_empty_keyframe(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 	 
  efface_curseur_regle();
  efface_curseur_timeline();
  if (SelectedArea)
	   {
		   printf("existe selected !\n");
		   goo_canvas_item_remove(pDrawings);/* effacer ancien tracé */  
		   timeline_selection_raz();
		   SelectedArea=FALSE;
		   pDrawings=FALSE;
	   }
  /* effacer dessins actuels */
  set_drawings_visibility(xcell,FALSE);
 /* récupérer itérateurs depuis le début de la ligne, pour modifier
  * le contenu des cellules
  * */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  /* poser la nouvelle image-clef */
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (cell!=ELLA_FRAME_NON_USED)
         {     
			/* si l'image était déjà active, effacer la liste des objets */
		    if ((cell==ELLA_FRAME_KEY_USED)||(cell=ELLA_FRAME_MOVEMENT)) 
			    {
					remove_liste_keyframes(keyframes_list,xcell-1);
					
				}
            cell= ELLA_FRAME_KEY_EMPTY;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
         	/* mettre à jour la liste des images-clés ! */
         	rootKF =  goo_canvas_group_new(rootGroup,NULL);
         	add_liste_keyframes( keyframes_list, xcell-1, TRUE, FALSE, FALSE, FALSE,
			                     FALSE,FALSE, FALSE,0, 0, 0, 0,100,100, rootKF);
		 }
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);  
  fModified=TRUE; 	
}
/****************************
 * créer une image-clef vide
 * *************************/
void cb_new_empty_keyframe (GtkWidget *p_widget, gpointer user_data)
{
   timeline_new_empty_keyframe();
}
/****************************
 * créer une image-clef
 * *************************/
void timeline_new_keyframe(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 	 
  efface_curseur_regle();
  efface_curseur_timeline();
  if (SelectedArea)
	   {
		   goo_canvas_item_remove(pDrawings);/* effacer ancien tracé */  
		   timeline_selection_raz();
		   SelectedArea=FALSE;
		   pDrawings=FALSE;
	   }
  /* effacer dessins actuels */
  set_drawings_visibility(xcell,FALSE);
  /* récupérer itérateurs depuis le début de la ligne, 
   * pour modifier le contenu des cellules  */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  /* poser la nouvelle image-clef */
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (cell!=ELLA_FRAME_NON_USED)
         {     
            cell= ELLA_FRAME_KEY_USED;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
         	/* mettre à jour la liste des images-clés ! */
         	rootKF =  goo_canvas_group_new(rootGroup,NULL);
         	add_liste_keyframes( keyframes_list, xcell-1,
			          FALSE, FALSE, FALSE, FALSE,
					  FALSE,FALSE,FALSE,
					   0, 0, 0, 0,100,100, rootKF);
         	/* transférer le contenu de l'image-clé précédente */
         	dup_keyframe(keyframes_list, rootKF, xcell-1);
		 }
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  /* effacer les éléments de dessin antérieurs */  
  set_drawings_visibility(xcell,TRUE);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);   
  //fModified=TRUE;	
}
/****************************
 * créer une image-clef
 * *************************/
void cb_new_keyframe (GtkWidget *p_widget, gpointer user_data)
{
   timeline_new_keyframe();
}
/****************************
 * retirer une image-clé
 * *************************/
void timeline_remove_keyframe(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 	  
  efface_curseur_regle();
  efface_curseur_timeline();
 /* récupérer itérateurs depuis le début de la ligne, pour modifier
  * le contenu des cellules  */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));    
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (((cell==ELLA_FRAME_KEY_EMPTY)||(cell==ELLA_FRAME_KEY_USED))&&(xcell!=1))
         {
         	cell = ELLA_FRAME_USED_EMPTY;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
         	/* retirer l'image-clé de la liste */
         	remove_liste_keyframes(keyframes_list,xcell-1);
		 }
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);   
  fModified=TRUE;	
}
/****************************
 * retirer une image-clef
 * *************************/ 
void cb_remove_keyframe (GtkWidget *p_widget, gpointer user_data)
{
	timeline_remove_keyframe();
}
/*****************************
 * retirer une interpolation
 * **************************/
void timeline_remove_interpolation(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;
 
  efface_curseur_regle();
  efface_curseur_timeline();
  /* récupérer itérateurs depuis le début de la ligne, pour modifier le contenu des cellules */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  /* supprimer l'interpolation*/
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  cell=ELLA_FRAME_KEY_USED;
  gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
  /* mettre à jour la liste des images-clés ? */
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);
  fModified=TRUE;	
}

/************************************************************
/* suppression d'une interpolation de mouvement (motion tween) 
/***********************************************************/
void cb_remove_movement(GtkWidget *p_widget, gpointer user_data)
{
   timeline_remove_interpolation();
}
/**************************************************
 * mettre à blanc une image-clé existante
 * ************************************************/
void timeline_set_keyframe_to_blank(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;	
 gboolean reussi;
 	
  efface_curseur_regle();
  efface_curseur_timeline();
  /* effacer dessins actuels */
  set_drawings_visibility(xcell,FALSE);
  /* récupérer itérateurs depuis le début de la ligne, pour modifier  le contenu des cellules */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));
  /* effacer ancienne image-clé */
  remove_liste_keyframes(keyframes_list,xcell-1);
  /* ajouter une image-clé vide */
  
  /* poser la nouvelle image-clef vide */
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (cell!=ELLA_FRAME_NON_USED)
         {
			 cell = ELLA_FRAME_KEY_EMPTY;
			 gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
			 /* modifier les datas ! avec une fonction de modif des KF */
			 reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"inter",
							FALSE,
							0);
			 reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"lumiv",
							FALSE,
							100);
			 reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"alphav",
							FALSE,
							100);
			 reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"zoomv",
							FALSE,
							100);
		    /* réafficher l'onglet */
		     gtk_widget_set_sensitive (scrolledwindowTransitions,TRUE); 
			 set_transition_page(keyframes_list,xcell-1);
			/* mettre à jour la liste des images-clés ! */
         	rootKF =  goo_canvas_group_new(rootGroup,NULL);
         	add_liste_keyframes( keyframes_list, xcell-1, TRUE, FALSE, FALSE, FALSE,
			                     FALSE,FALSE,FALSE, 0, 0, 0, 0,100,100, rootKF);
		 }
  /* réaffichage */
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);
  fModified=TRUE;  	
}
/********************************************************
 * créer une interpolation
 * *****************************************************/
void timeline_define_interpolation(void)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count;
 guint cell;	
 gboolean reussi;
 
  efface_curseur_regle();
  efface_curseur_timeline();
 /* récupérer itérateurs depuis le début de la ligne, pour modifier  le contenu des cellules */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));  
  /* poser la nouvelle image-clef avec interpolation*/
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell,  -1);
  if (cell!=ELLA_FRAME_NON_USED)
         {
         	cell = cell | ELLA_FRAME_MOVEMENT;
         	gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
			/* modifier les datas ! avec une fonction de modif des KF */
			reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"inter",
							TRUE,
							0);
			reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"lumiv",
							TRUE,
							100);
			reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"alphav",
							TRUE,
							100);
			reussi=set_keyframe_datas(keyframes_list, xcell-1,
							"zoomv",
							TRUE,
							100);
		    /* réafficher l'onglet */
		    gtk_widget_set_sensitive (scrolledwindowTransitions,TRUE); 
			set_transition_page(keyframes_list,xcell-1);
		 }
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);
  fModified=TRUE;	
}
/************************************************************
/* création d'une interpolation de mouvement (motion tween) 
/***********************************************************/
void cb_define_movement(GtkWidget *p_widget, gpointer user_data)
{
	timeline_define_interpolation();
}
/******************************
 * menu POp Up de la timeline
 * entièrement local
 * ***************************/ 
void popup_menu(GtkWidget *w, GdkEventButton *event, gint x, gint y)
{
    GtkWidget *menu, *item, *sep1, *sep2;
    guint cell;  
    
    cell = frame_cell_get (w,x,y);
	menu = gtk_menu_new (); 	
	item = gtk_menu_item_new_with_mnemonic ((gettext("_Add frames to the cursor")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_new_frames), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if (cell!=ELLA_FRAME_NON_USED)
	   gtk_widget_set_sensitive(item,FALSE);
    item = gtk_menu_item_new_with_mnemonic ((gettext("_Remove frames")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_remove_frames), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if (cell==ELLA_FRAME_NON_USED)
	   gtk_widget_set_sensitive(item,FALSE);
	sep1 = gtk_separator_menu_item_new();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), sep1);
	item = gtk_menu_item_new_with_mnemonic ((gettext("_New key-frame")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_new_keyframe),NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if (cell!=ELLA_FRAME_USED_EMPTY)
	   gtk_widget_set_sensitive(item,FALSE);
	item = gtk_menu_item_new_with_mnemonic ((gettext("New blank key-frame")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_new_empty_keyframe), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if (cell!=ELLA_FRAME_USED_EMPTY)
	   gtk_widget_set_sensitive(item,FALSE);
	item = gtk_menu_item_new_with_mnemonic ((gettext("R_emove key-frame")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_remove_keyframe), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if ((cell==ELLA_FRAME_USED_EMPTY)||(cell==ELLA_FRAME_NON_USED))
	   gtk_widget_set_sensitive(item,FALSE);
	sep2 = gtk_separator_menu_item_new();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), sep2);
	/* menus optionnels en cas d'existence d'une image-clé */
	item = gtk_menu_item_new_with_mnemonic ((gettext("Define an in_terpolation")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_define_movement), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if ((cell==ELLA_FRAME_USED_EMPTY)||(cell==ELLA_FRAME_NON_USED))
	   gtk_widget_set_sensitive(item,FALSE);
	item = gtk_menu_item_new_with_mnemonic ((gettext("Remove an interpolation")));
	g_signal_connect_swapped (item, "activate",G_CALLBACK (cb_remove_movement), NULL);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
	if ((cell&ELLA_FRAME_MOVEMENT)!=ELLA_FRAME_MOVEMENT)
	   gtk_widget_set_sensitive(item,FALSE);  
	gtk_widget_show_all (menu); 
	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, 
	               NULL,/* pointeur datas */
	               event->button, /* bouton de la souris, automatique */
	               event->time); /* moment du clic, automatique */
}
 
/**********************************
 * fonction activant un layer donné
 * dans le fenêtre déroulante des
 * calques (layers)
 * locale
 * *******************************/
void  layer_activate_cursor(GtkTreeView *arbre, gint ligne)
{
	GtkTreePath *path;
	gchar *path1;
	
	/* correction n° ligne */
	ligne = ligne-1;
	if (ligne<0)
	   return;
	path1=g_strdup_printf("%d",ligne);
	path=gtk_tree_path_new_from_string(path1);
	gtk_tree_view_set_cursor(arbre,path,FALSE,FALSE);
	g_free(path1);
	gtk_tree_path_free(path);	
}	
/**********************************
 * fonction mettant à jour 
 * l'affichage du calque courant
 * dans la zone d'état
 * *******************************/
void maj_ref_layer(gint calque)
{
 gchar *texte;
 
 texte= g_strdup_printf("%d",calque);
 gtk_label_set_text (GTK_LABEL (labelNumeroCalque), texte);	
 g_free(texte);
}
/*********************************
 * callback pour gérer les
 * sélections
 * avec une variable globale 
 * gérant
 * le n° du calque
 * en cours
 * ******************************/
void on_my_treeview_cursor_changed(GtkTreeView     *treeview,
                                   gpointer         user_data)
{ 
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreePath *path;
	GtkTreeIter iter;
	gint i;
	gchar *calque;
	GooCanvasItem *rg; 
	
	selection = gtk_tree_view_get_selection ( treeview );
	gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );
 
	if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		/* lis le n° du calque */
		gtk_tree_model_get (model, &iter, -1);		
		/* lis le chemin */
		path = gtk_tree_model_get_path(model,&iter);
		calque= gtk_tree_path_to_string (path);
		LayerSelected=atoi(calque);	/* coordonnées ordinateur */			
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, (gpointer)&rg, -1);
		gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		rootGroup=rg;
		rootKF=get_keyframe_group(keyframes_list, xcell-1);
		maj_ref_layer(LayerSelected+1);
		g_free(calque);	
		gtk_tree_path_free(path);
	}
}
/*********************************
 * dupliquer un calque
 * contrôle en entrée sur la
 * limite du nombre de calques
 * Dénomination "intelligente"
 * ******************************/
void timeline_duplicate_layer(void)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter *iter, iter_source;
 gchar *sLayerName;
 gchar *calque_choisi;
 gint i;
 guint valeur;
 
 if ((LayerCount==MAX_LAYERS)||(LayerSelected<0))
     return;
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter_source ) )
	{
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter_source, LAYER_NAME_COLUMN, &calque_choisi,-1);	
		iter = gtk_tree_iter_copy(&iter_source);	
		gtk_list_store_append(GTK_LIST_STORE(model),iter);
		LayerCount=LayerCount+1;	
		/* ajout d'un élément */
		sLayerName=g_strdup_printf(gettext("Copy of %s"),calque_choisi);
		gtk_list_store_set(GTK_LIST_STORE(model), iter,
            LAYER_NAME_COLUMN, sLayerName,
            LAYER_VISIBLE_COLUMN, TRUE, 
            LAYER_VISIBLE_TEXT, "visible",                       
            -1);	
        /* boucle pour passer les valeurs */
        for (i=N_COLUMN;i<MAX_FRAMES;i++)
           {
           	  gtk_tree_model_get (model, &iter_source,i,&valeur,-1);/* ne passe que les valeurs numériques */
           	  gtk_list_store_set(GTK_LIST_STORE(model), iter,i,valeur,-1);
		   }/* for i*/ 
	    /* faire même pour récupérer les images-clés */
        g_free(sLayerName);
        g_free(calque_choisi);
        gtk_tree_iter_free(iter);
        /* modifier l'affichage de la time line */	
        efface_curseur_regle();
        draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),LayerCount,ScrolledWindowTimeLine);	
        affiche_curseur_regle(rootRuler,xcell);
	}
	fModified=TRUE;
}

void
on_button_layer_duplicate_clicked(GtkButton       *button, GtkTreeView     *treeview)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter *iter, iter_source;
 gchar *sLayerName;
 gchar *calque_choisi;
 gint i;
 guint valeur;
 GooCanvasItem *root_layer;
 
 
 if ((LayerCount==MAX_LAYERS)||(LayerSelected<0))
     return;
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter_source ) )
	{
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter_source, LAYER_NAME_COLUMN, &calque_choisi,-1);	
		iter = gtk_tree_iter_copy(&iter_source);	
		gtk_list_store_append(GTK_LIST_STORE(model),iter);
		LayerCount=LayerCount+1;	
		/* ajout d'un élément */
		sLayerName=g_strdup_printf(gettext("Copy of %s"),calque_choisi);
		gtk_list_store_set(GTK_LIST_STORE(model), iter,
            LAYER_NAME_COLUMN, sLayerName,
            LAYER_VISIBLE_COLUMN, TRUE, 
            LAYER_VISIBLE_TEXT, "visible",                       
            -1);	
		/* créer un nouveau groupe */
        /* initialiser le pointeur sur le groupe d'items */
        rootGroup = goo_canvas_group_new(rootEditorItems,NULL); /* ancetre= rootEditorItems*/
        g_object_set(rootGroup, "title", "K", NULL);
        /* la ligne suivante sera inutile à terme */
        gtk_list_store_set(pListStore, iter, LAYER_GROUP_DRAW, rootGroup,-1);	
		/* initialiser la liste des images-clés */
	    keyframes_list=NULL;
	    	
        /* boucle pour passer les valeurs */
        for (i=N_COLUMN;i<MAX_FRAMES;i++)
           {
           	  gtk_tree_model_get (model, &iter_source,i,&valeur,-1);/* ne passe que les valeurs numériques */
           	  gtk_list_store_set(GTK_LIST_STORE(model), iter,i,valeur,-1);
			  /* si valeur = image clé, mettre pointeur à NULL */
			  if ((valeur==ELLA_FRAME_KEY_EMPTY)||(valeur==ELLA_FRAME_KEY_USED))
			     {
					 printf("i=%d\n",i-N_COLUMN);
				   rootKF= goo_canvas_group_new(rootGroup,NULL);	 
                   keyframes_list=add_liste_keyframes(keyframes_list,
				      i-N_COLUMN, FALSE, FALSE, FALSE, FALSE,
					  FALSE,FALSE,FALSE,
					   0, 0, 0, 0,100,100, rootKF);
			   gtk_list_store_set(GTK_LIST_STORE(model), iter,
				               LAYER_MOVEMENT_INDEX,keyframes_list, -1);
				 }
 
		   }/* for i*/ 
        g_free(sLayerName);
        g_free(calque_choisi);
        gtk_tree_iter_free(iter);
        /* modifier l'affichage de la time line */	
        efface_curseur_regle();
        draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),LayerCount,ScrolledWindowTimeLine);	
        affiche_curseur_regle(rootRuler,xcell);
		//printf("ycell dup : %d LayerCount %d \n",ycell,LayerCount);
	}
	fModified=TRUE;
}
/*********************************
 * faire remonter le calque est
 * simple : insérer à la position
 * n-1 ! car l'indice en cours
 * est connu,  puis
 *rechercher le dernier élément
 * ******************************/
void timeline_layer_up(void)
{
GtkTreeSelection *selection;
GtkTreeModel *model;
GtkTreeIter iter, iter_dessus;
gint count;
GooCanvasItem *rg; 

 if ((LayerCount==1)||(LayerSelected<=0))
      return;
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* LayerSelected est connu */
		gtk_tree_model_get_iter_from_string (model,&iter_dessus,g_strdup_printf("%d",LayerSelected-1));
		gtk_list_store_move_before(GTK_LIST_STORE(model),&iter,&iter_dessus);
		/* faire monter le dessin d'un niveau */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, (gpointer)&rootGroup, -1);
		gtk_tree_model_get (model, &iter_dessus, LAYER_GROUP_DRAW, (gpointer)&rg, -1);
		goo_canvas_item_raise(rg,rootGroup);
        /* effacer de LayerSelected à LayerCount-1 */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		   }
        /* tout réafficher */
        for (count=LayerSelected-1;count<LayerCount;count++)
           {
           	 draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW( pListViewLayers),count+1,ScrolledWindowTimeLine);
		   }
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);	                             
	}
	fModified=TRUE;
}
void on_button_layer_up_clicked(GtkButton       *button,GtkTreeView     *treeview)
{
GtkTreeSelection *selection;
GtkTreeModel *model;
GtkTreeIter iter, iter_dessus;
gint count;
GooCanvasItem *rg; 

 if ((LayerCount==1)||(LayerSelected<=0))
      return;
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* LayerSelected est connu */
		gtk_tree_model_get_iter_from_string (model,&iter_dessus,g_strdup_printf("%d",LayerSelected-1));
		gtk_list_store_move_before(GTK_LIST_STORE(model),&iter,&iter_dessus);
		/* faire monter le dessin d'un niveau */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, (gpointer)&rootGroup, -1);
		gtk_tree_model_get (model, &iter_dessus, LAYER_GROUP_DRAW, (gpointer)&rg, -1);
		goo_canvas_item_raise(rg,rootGroup);
        /* effacer de LayerSelected à LayerCount-1 */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		   }
        /* tout réafficher */
        for (count=LayerSelected-1;count<LayerCount;count++)
           {
           	 draw_timeline_bg(rootTimeLine,treeview,count+1,ScrolledWindowTimeLine);
		   }
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);	                             
	}
	fModified=TRUE;
}
/*********************************
 * faire descendre le calque est
 * simple : insérer à la position
 * n+1 ! car l'indice en cours
 * est connu
 * ******************************/
void timeline_layer_down(void)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter, iter_dessous;
 gint count;
 GooCanvasItem *rg; 
 
 if ((LayerCount==LayerSelected+1)||(LayerSelected>=MAX_LAYERS-1))
     return;
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* LayerSelected est connu */
		gtk_tree_model_get_iter_from_string (model,&iter_dessous,g_strdup_printf("%d",LayerSelected+1));
		gtk_list_store_move_after(GTK_LIST_STORE(model),&iter,&iter_dessous);
		/* déplacer les calques */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, (gpointer)&rootGroup, -1);
		gtk_tree_model_get (model, &iter_dessous, LAYER_GROUP_DRAW, (gpointer)&rg, -1);
		/* faire même pour récupérer les images-clés */
		// gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		goo_canvas_item_lower(rg,rootGroup);
        /* effacer de LayerSelected à LayerCount-1 */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		   }
        /* tout réafficher */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),count+1,ScrolledWindowTimeLine);
		   }
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);	   
	}/* endif */
	fModified=TRUE;
}
void
on_button_layer_down_clicked           (GtkButton       *button,
                                        GtkTreeView     *treeview)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter, iter_dessous;
 gint count;
 GooCanvasItem *rg; 
 
 if ((LayerCount==LayerSelected+1)||(LayerSelected>=MAX_LAYERS-1))
     return;
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* LayerSelected est connu */
		gtk_tree_model_get_iter_from_string (model,&iter_dessous,g_strdup_printf("%d",LayerSelected+1));
		gtk_list_store_move_after(GTK_LIST_STORE(model),&iter,&iter_dessous);
		/* déplacer les calques */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, (gpointer)&rootGroup, -1);
		gtk_tree_model_get (model, &iter_dessous, LAYER_GROUP_DRAW, (gpointer)&rg, -1);
		/* faire même pour récupérer les images-clés */
		// gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		goo_canvas_item_lower(rg,rootGroup);
        /* effacer de LayerSelected à LayerCount-1 */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		   }
        /* tout réafficher */
        for (count=LayerSelected;count<LayerCount;count++)
           {
           	 draw_timeline_bg(rootTimeLine,treeview,count+1,ScrolledWindowTimeLine);
		   }
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);	   
	}/* endif */
	fModified=TRUE;
}
/**** supprimer un calque */
void timeline_delete_layer_from_menu(void)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 gint count,ligne;

 if ((LayerCount==1)||(LayerSelected<0))
     return;
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected (selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter, -1);		
		/* il faudrait préserver son contenu */
		/* effacer les items */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, &rootGroup, -1);
		goo_canvas_item_remove (rootGroup);
		rootGroup=NULL;
		/* effacer la liste des keyframes */
		gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		raz_liste_keyframes(keyframes_list);
		keyframes_list=NULL;
		gtk_list_store_remove(GTK_LIST_STORE(model),&iter);
		LayerCount=LayerCount-1;
		LayerSelected=LayerSelected-1;
		if (LayerSelected<0)
		    LayerSelected=0;
		/* effacer toutes les lignes */
		for (count=LayerSelected;count<LayerCount;count++)
		  {
		    remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		  }/* for count */
		/* réafficher les lignes concernées */
		for (count=LayerSelected;count<LayerCount;count++)
		  {
		    draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),count+1,ScrolledWindowTimeLine);
		  }/* for count */  
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);
	}
	fModified=TRUE;
}
/**********************************
 * retirer un calque de la liste
 * *******************************/
void on_button_layer_delete_clicked         (GtkButton       *button,
                                        GtkTreeView     *treeview)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 gint count,ligne;

 if ((LayerCount==1)||(LayerSelected<0))
     return;
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected (selection, &model, &iter ) )
	{
		efface_curseur_regle();
		efface_curseur_timeline();
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter, -1);		
		/* il faudrait préserver son contenu */
		/* effacer les items */
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, &rootGroup, -1);
		goo_canvas_item_remove (rootGroup);
		rootGroup=NULL;
		/* effacer la liste des keyframes */
		gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		raz_liste_keyframes(keyframes_list);
		keyframes_list=NULL;
		gtk_list_store_remove(GTK_LIST_STORE(model),&iter);
		LayerCount=LayerCount-1;
		LayerSelected=LayerSelected-1;
		if (LayerSelected<0)
		    LayerSelected=0;
		/* effacer toutes les lignes */
		for (count=LayerSelected;count<LayerCount;count++)
		  {
		    remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count+1);
		  }/* for count */
		/* réafficher les lignes concernées */
		for (count=LayerSelected;count<LayerCount;count++)
		  {
		    draw_timeline_bg(rootTimeLine,treeview,count+1,ScrolledWindowTimeLine);
		  }/* for count */  
		affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
		affiche_curseur_regle(rootRuler,xcell);
		layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), LayerSelected+1);
	}
	fModified=TRUE;
}
/****************************************************
/* calculer le plus grand calque en termes d'images 
 * coordonnées PC, mais retour en coordonnées 
 * humaines ?
/***************************************************/
gint timeline_get_max_absolute_frames(void)
{
	gint maxi=1;
	gint actuel=0;
	gint ligne=0;
    GtkTreeModel *model;
    GtkTreePath *path;
    gchar *path1;
    GtkTreeIter pIter;
    gint j,k;
    guint cell;
 	
	for (ligne=0;ligne<LayerCount;ligne++)
	   {
		   /* chercher le nombre maxi d'éléments actifs de cette ligne */
		   actuel=0;
		   for (j=0;j<MAX_FRAMES;j++)
             {
				 	 /* récupérer itérateur */
					path1=g_strdup_printf ("%d:%d",ligne,N_COLUMN+j);
					path=gtk_tree_path_new_from_string(path1);
					model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));
					gtk_tree_model_get_iter(model, &pIter, path);
					gtk_tree_model_get (model, &pIter,N_COLUMN+j,&cell,  -1);	
					/* est-ce une image vide ? */
					if (cell>ELLA_FRAME_NON_USED)
						{
							actuel++;
						}
			 }/* next j */
		   if (actuel>maxi)
		      maxi=actuel;
	   }/* next ligne */
	   printf("valeur maxi %d\n",maxi);
 return maxi;
}
/***************************************
 * ajoût d'un nouveau calque
 * ************************************/
/** fonction réelle **/
void timeline_new_layer_from_menu(void)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 gchar *sLayerName;
 gint maxi;
 
 if (LayerCount==MAX_LAYERS)
     return;
 maxi=timeline_get_max_absolute_frames();
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{	
        /* modifier l'affichage de la time line */
        efface_curseur_regle();
        add_tree_list_layer(pListStore, rootEditorItems,maxi,DRAWING_LAYER);
        affiche_curseur_regle(rootRuler,xcell);
	}
 fModified=TRUE;	
}
/*************************************
 * new sound layer : this function
 * is called from menu, i.e. from
 * callbacks module
 * **********************************/
/** fonction réelle **/
void timeline_new_sound_layer_from_menu(void)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 gchar *sLayerName;
 gint maxi;
 
 if (LayerCount==MAX_LAYERS)
     return;
 maxi=timeline_get_max_absolute_frames();
 selection = gtk_tree_view_get_selection (GTK_TREE_VIEW( pListViewLayers) );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{	
        /* modifier l'affichage de la time line */
        efface_curseur_regle();
        add_tree_list_layer(pListStore, rootEditorItems,maxi,SOUND_LAYER);
        affiche_curseur_regle(rootRuler,xcell);
	}
 fModified=TRUE;	
}

void
on_button_layer_new_clicked            (GtkButton       *button,
                                        GtkTreeView     *treeview)
{
 GtkTreeSelection *selection;
 GtkTreeModel *model;
 GtkTreeIter iter;
 gchar *sLayerName;
 gint maxi;
 
 if (LayerCount==MAX_LAYERS)
     return;

 maxi=timeline_get_max_absolute_frames();
 
 selection = gtk_tree_view_get_selection ( treeview );
 gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );  
 if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{	
        /* modifier l'affichage de la time line */
        efface_curseur_regle();
        add_tree_list_layer(pListStore, rootEditorItems,maxi, DRAWING_LAYER);
        affiche_curseur_regle(rootRuler,xcell);
	}
 fModified=TRUE;
}
/****************************************
 * callback suite à l'édition du nom
 * d'un calque
 * *************************************/
void on_layer_name_edited(GtkCellRendererToggle *cell, gchar *path,gchar *new_text,
 GtkTreeView     *treeview) 
{
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreePath *path_tree;
	GtkTreeIter iter;
	gchar *calque;
	
	/* récupérer la ligne concernée */
	selection = gtk_tree_view_get_selection ( treeview );
	gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );
	if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	{
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter,-1);/* &iter avec ampersand obligatoire */		
		/* lis le chemin */
		path_tree = gtk_tree_model_get_path(model,&iter);
		calque= gtk_tree_path_to_string (path_tree);
		LayerSelected=atoi(calque);	/* coordonnées ordinateur */
		/* modifier le bouton à l'écran */
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, LAYER_NAME_COLUMN, new_text,-1);
		g_free(calque);
		gtk_tree_path_free(path_tree);
		/* et passer la valeur au VRAI tableau de stockage */		
	}	
	fModified=TRUE;		
}
/*********************************
 * callback pour gérer les
 * togglings
 * ******************************/
void on_layer_visible_toggled(GtkCellRendererToggle *cell, gchar *path, GtkTreeView  *treeview) 
{ 
	GtkTreeSelection *selection;
	GtkTreeModel *model;
    GtkTreePath *path_tree;
	GtkTreeIter iter;	
	gboolean valeur;
	gchar *calque;
	
	/* récupérer la ligne concernée */
	selection = gtk_tree_view_get_selection ( treeview );
	gtk_tree_selection_set_mode ( selection, GTK_SELECTION_SINGLE );
	if ( gtk_tree_selection_get_selected ( selection, &model, &iter ) )
	  {
		/* lis le n° du calque  */
		gtk_tree_model_get (model, &iter, -1);
		/* lis le chemin */
		path_tree = gtk_tree_model_get_path(model,&iter);
		calque= gtk_tree_path_to_string (path_tree);
		LayerSelected=atoi(calque);	/* coordonnées ordinateur */
		gtk_tree_model_get (model, &iter, LAYER_VISIBLE_COLUMN, &valeur, -1);/* &iter avec ampersand obligatoire */		  		
		gtk_tree_model_get (model, &iter, LAYER_GROUP_DRAW, &rootGroup, -1);/* pointe sur la racine du groupe d'items */
		gtk_tree_model_get (model, &iter, LAYER_MOVEMENT_INDEX, (gpointer)&keyframes_list, -1);
		/* modifier le bouton à l'écran */
		valeur=!valeur;
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, LAYER_VISIBLE_COLUMN, valeur,-1);
		g_free(calque);	
		gtk_tree_path_free(path_tree);	
		timeline_layer_set_visibility(LayerSelected+1,valeur);
	  }
	fModified=TRUE;
} 
/**********************************
 * création dynamique du modèle
 * *******************************/
GtkListStore *init_store(void)
{
	GtkListStore *pListStore;
    gint i;    
    gint nb_cols=N_COLUMN+MAX_FRAMES;
    GType *types;
    
    /* création dynamique du modèle */
    types = g_new0 (GType, nb_cols);
    types[0] = G_TYPE_STRING;/* nom du calque */
    types[1] = G_TYPE_BOOLEAN;
    types[2] = G_TYPE_STRING;/* visible */
    types[3] = GDK_TYPE_PIXBUF;
    types[4] = G_TYPE_POINTER; /* contient pointeur sur racine du groupe de gooitems */
    types[5] = G_TYPE_POINTER; /* contiendra pointeur sur liste des images-clés */
	types[6]=  G_TYPE_INT;/* type de layer */
    for (i=N_COLUMN;i<nb_cols;i++)
       {
       	types[i] = G_TYPE_UINT;/* contenu de l'image sur le calque*/
	   }
    pListStore = gtk_list_store_newv (nb_cols, types);
    g_free (types);
 return pListStore;			
}
/*********************************
 * initialisation d'un layer ;
 * aucune numéro de rang n'est
 * vraiment nécessaire, il 
 * va s'ajouter à la racine
 * mais la variable ligne
 * permet l'affichage dans
 * le canvas
 * le dernier paramètre (maxi)
 * permet de pré-activer les
 * cellules
 * ******************************/
void add_tree_list_layer(GtkListStore *pListStore, GooCanvasItem *ancetre, gint maxi, gint type_layer)
{
	gchar *sLayerName;
	gint i;
	GtkTreeIter pIter;  
	GooCanvasItem *root_layer;	
  
    /* création du contenu */   
	sLayerName = g_malloc(256);
    /* Insertion des elements */
    sprintf(sLayerName,gettext("Layer %d\0"),LayerCount+1);
    /* Creation de la nouvelle ligne */
    gtk_list_store_append(pListStore, &pIter);
    /* Mise a jour des donnees */
    gtk_list_store_set(pListStore, &pIter,
            LAYER_NAME_COLUMN, sLayerName,
            LAYER_VISIBLE_COLUMN, TRUE, 
            LAYER_VISIBLE_TEXT, "visible", 
            LAYER_MOVEMENT_INDEX,NULL,          
            -1);   
			
    /* icones and layer type */
	if (type_layer==DRAWING_LAYER)
	    gtk_list_store_set(pListStore, &pIter,LAYER_ICON_TYPE,pIco_layer_dessin,LAYER_TYPE,DRAWING_LAYER, -1);			
    else
	    gtk_list_store_set(pListStore, &pIter,LAYER_ICON_TYPE,pIco_layer_son,LAYER_TYPE,SOUND_LAYER, -1);
    /* initialiser le pointeur sur le groupe d'items */
    rootGroup = goo_canvas_group_new(ancetre,NULL); /* ancetre= rootEditorItems*/
    g_object_set(rootGroup, "title", "K", NULL);
    /* la ligne suivante sera inutile à terme */
    gtk_list_store_set(pListStore, &pIter, LAYER_GROUP_DRAW, rootGroup,-1);
    /* remplir le reflet de chaque image */     
    gtk_list_store_set(pListStore, &pIter,N_COLUMN,ELLA_FRAME_KEY_EMPTY,-1);/* image-clef dans la première par défaut */
    for(i = N_COLUMN+1 ; i < MAX_FRAMES ; i++)
        {         
		  if (i<maxi+N_COLUMN) 	
              gtk_list_store_set(pListStore, &pIter,i,ELLA_FRAME_USED_EMPTY,-1);
		  else
		      gtk_list_store_set(pListStore, &pIter,i,ELLA_FRAME_NON_USED,-1);
	    }/* for i */	
    g_free(sLayerName);        	
	/* afficher les éléments dans la time line */
	draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),LayerCount+1,ScrolledWindowTimeLine);
	/* incrémenter le compteur de calques */
	LayerCount=LayerCount+1;
	/* à ce stade, rootGroup pointe sur le groupe de ce layer */
	/* initialiser la liste des images-clés */
	keyframes_list=NULL;
	rootKF= goo_canvas_group_new(rootGroup,NULL);
	keyframes_list=add_liste_keyframes(keyframes_list, 0, FALSE, FALSE, FALSE, FALSE,
	       FALSE,FALSE,FALSE, 0, 0, 0, 0,100,100, rootKF);
	gtk_list_store_set(pListStore, &pIter,LAYER_MOVEMENT_INDEX,keyframes_list, -1);
	/* afficher le contenu de l'image correspondant à Xcell */
}
/*********************************
 * créer la listree de type 
 * ListStore, donc sans
 * "enfants" (pas dépliables)
 * "ancetre" est un pointeur
 * sur l'item root de l'éditeur
 * ******************************/
GtkWidget *init_tree_list_layers(GtkListStore *pListStore, gint maxim, GooCanvasItem *ancetre)
{
	GtkTreeViewColumn *pColumn;
    GtkCellRenderer *pCellRenderer;    
    gint total_columns;
    gint i,j,k;
    gint nb_cols=N_COLUMN+MAX_FRAMES;
    
    /* vue des titres&flags des calques */
    pListViewLayers = gtk_tree_view_new_with_model(GTK_TREE_MODEL(pListStore));
    /* interdire l'affichage des en-têtes */
    gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(pListViewLayers), FALSE);   
	/* 1ère colonne : icone correspondant au type de calque */
	pCellRenderer = gtk_cell_renderer_pixbuf_new (); 
	pColumn = gtk_tree_view_column_new_with_attributes("Type",
        				pCellRenderer,
        				"pixbuf", LAYER_ICON_TYPE,
        				NULL);
	/* Ajout de la colonne <image> à la vue */
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewLayers), pColumn); 					
    /* Creation de la 2ème colonne : <nom calque> */
    pCellRenderer = gtk_cell_renderer_text_new();
    /* le rendre éditable  */
    g_object_set(G_OBJECT(pCellRenderer), "editable", TRUE,  NULL);  
    g_object_set(G_OBJECT(pCellRenderer), "width-chars",16, NULL);    
    g_object_set(G_OBJECT(pCellRenderer),"font","sans 10",NULL);  /* forcer la police */     
    pColumn = gtk_tree_view_column_new_with_attributes(NULL,
        			pCellRenderer,
        			"text", LAYER_NAME_COLUMN,
        			NULL);
    /* ajouter la callback */
    g_signal_connect(pCellRenderer, "edited", G_CALLBACK(on_layer_name_edited),pListViewLayers);
    /* Ajout de la colonne <calque name> à la vue */
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewLayers), pColumn);    
    /* Creation de la 2e colonne : état <visible> pour le calque */    
    pCellRenderer = gtk_cell_renderer_toggle_new();
    pColumn = gtk_tree_view_column_new_with_attributes("Visible",
                                                       pCellRenderer,
        												"active", LAYER_VISIBLE_COLUMN, 
        												NULL);
    g_object_set(pCellRenderer,"activatable" ,TRUE,NULL); /* pour gérer la bascule, mais ne suffit pas, car nécessaire de l'imposer ensuite avec une call back */                           
    /* ajouter la callback */
    g_signal_connect(pCellRenderer, "toggled", G_CALLBACK(on_layer_visible_toggled),pListViewLayers);
    /* Ajout de la colonne du texte <visible> à la vue */
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewLayers), pColumn);        
    /* création de la colonne destinée au texte "visible" */
    pCellRenderer = gtk_cell_renderer_text_new();
    g_object_set(G_OBJECT(pCellRenderer),"font","sans 8",NULL);  /* forcer la police */     
    pColumn = gtk_tree_view_column_new_with_attributes(NULL,
        			pCellRenderer,
        			"text", LAYER_VISIBLE_TEXT,
        			NULL);
    /* Ajout de la colonne <visible> à la vue */
    gtk_tree_view_append_column(GTK_TREE_VIEW(pListViewLayers), pColumn);  
    /* initialisation 1ère colonne */
	LayerCount=0;
    add_tree_list_layer(pListStore, ancetre,1,DRAWING_LAYER);    
	return pListViewLayers;
}
/*********************************
 * fonction appelée après un appel
 * à "nouveau" ; recréer un layer
 * *******************************/
void timeline_re_init(GooCanvasItem *ancetre)
{
	/* initialisation 1ère colonne */
	LayerCount=0;
    add_tree_list_layer(pListStore,ancetre,1,DRAWING_LAYER); 
}
/**********************************
 * interconnection des 
 * ajustements des fenêtres 
 * *******************************/
void interconnect_adj(void)
{
	GtkAdjustment *adj_h,*adj_v; 
	/* prendre les ajustements de la fenêtre de la time line */
	adj_h = gtk_scrolled_window_get_hadjustment((GtkScrolledWindow *)ScrolledWindowTimeLine);
    adj_v = gtk_scrolled_window_get_vadjustment((GtkScrolledWindow *)ScrolledWindowTimeLine);
    /* transmettre aux deux autres fenêtres */
    /* passer cette nouvelle valeur, et modifier l'affichage de la règle en conséquence */
    adj_h->upper=MAX_FRAMES*RULER_WIDTH;
 	gtk_scrolled_window_set_hadjustment ((GtkScrolledWindow *)scrolledWindowRuler,adj_h);
 	/* modifier l'ajustement des calques */
 	gtk_scrolled_window_set_vadjustment ((GtkScrolledWindow *)ScrolledWindowLayersList,adj_v);
}
/**********************************/
/* effacer le curseur de la règle */
/**********************************/
void efface_curseur_regle(void)
{
   goo_canvas_item_remove(pRulerCursorItem);   
   goo_canvas_item_remove(pTimeLineCursorItem); 
}
/**********************************
 * effacer le curseur de la
 * timeline
 * *******************************/
void efface_curseur_timeline(void)
{
	goo_canvas_item_remove(pTimeLineSelectionCursor);
}
/****************************
 * relâchement du bouton de
 * la souris sur la timeline
 * *************************/

gboolean on_timeline_button_release(GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win)
{ 

    fTimeLineSelection=FALSE;
    //printf("passé par release ! \n");
    return FALSE;
}
/**************************
 * événement quand on 
 * quitte la timeline
 * ***********************/

gboolean on_timeline_leave(GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win)
{	
	printf("leave ! \n");
	return TRUE;
}		      
/**********************************
 * déplacement de la souris
 * *******************************/
gboolean on_timeline_mouse_move(GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win)
{
	gint xtemp,ytemp;
	gdouble hvaleur,vvaleur,largeur,hauteur;
	GtkAdjustment *adj_h,*adj_v;
	guint cell;
	
	if (fTimeLineSelection==FALSE)
	  {
	  	//printf("dehors ! \n");
	    return TRUE;
	  }
	/* récupérer les valeurs des ajustements */
	adj_h = gtk_scrolled_window_get_hadjustment((GtkScrolledWindow *)win);
	adj_v = gtk_scrolled_window_get_vadjustment((GtkScrolledWindow *)win);
	hvaleur = gtk_adjustment_get_value(adj_h)/RULER_WIDTH+1;/* valeur à gauche */
	vvaleur = gtk_adjustment_get_value(adj_v)/RULER_HEIGHT+1;
	
	//printf("hvaleur = %d --x= %d //",(int)hvaleur,(int)((event->x/RULER_WIDTH)+1));
	xtemp=(int)(event->x/RULER_WIDTH)+1;
	ytemp=(int)(event->y/RULER_HEIGHT)+1;


	if (xtemp<1)
	    xtemp=1;
	if (xtemp>MAX_FRAMES)
	   xtemp=MAX_FRAMES;
	if (ytemp<1)
	  ytemp=1;
	if (ytemp>LayerCount)
	  ytemp= LayerCount;
	  
	/* tester la case, et si pas conforme, sortie */
	cell = frame_cell_get(pListViewLayers, xtemp, ytemp);
	if (cell==ELLA_FRAME_NON_USED)
	   return;
	/* ajuster la fenêtre */
	if (xtemp>hvaleur)
	  {
	  	   hvaleur=xtemp;
	  	   //gtk_adjustment_set_value(adj_h,(hvaleur)*RULER_WIDTH);
	  	   gtk_adjustment_clamp_page(adj_h,(hvaleur)*RULER_WIDTH-adj_h->page_size,
	  	                             (hvaleur)*RULER_WIDTH);
	 
	  }/* endif */
	if (xtemp<hvaleur)
	  {
	   	   hvaleur=xtemp-1;
	   	   if (hvaleur<1)
	   	      hvaleur=1;
	  	   gtk_adjustment_set_value(adj_h,(hvaleur)*RULER_WIDTH);
	  }/* endif */
	/* ajuster la fenêtre en vertical */   	

	efface_curseur_regle();
    efface_curseur_timeline();
    /* tester nouvelle position : contient-elle quelque chose ? */
    if (frame_cell_get (pListViewLayers,xtemp,ytemp)!=ELLA_FRAME_NON_USED)
     {
	   /* calculer nouvelle position */
       x2sel =xtemp; 
       y2sel = ytemp;      
       xruler=x2sel;      
     }/* endif */
    /* afficher la zone de sélection en cours */
    affiche_curseur_timeline(xcell,ycell,x2sel,y2sel);
    affiche_curseur_regle(rootRuler,xruler);
    return TRUE;
}
/**********************************
 * afficher le curseur dans la
 * case sélectionnée de la
 * timeline
 * coordonnées humaines
 * *******************************/
void affiche_curseur_timeline(gint x,gint y, gint x2, gint y2)
{
  gint swap;
  gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
  largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);  
  x=x-1;
  if (x<0)
   x=0;
  y=y-1;
  if (y<0)
    y=0;
  x2=x2-1;
  if (x2<0)
   x2=0;
  y2=y2-1;
  if (y2<0)
    y2=0;
  /* échange éventuel coordonnées */
  if (x2<x)
    {
      swap=x;x=x2;x2=swap;	
	}
  if (y2<y)
    {
      swap=y;y=y2;y2=swap;
	}
  pTimeLineSelectionCursor=goo_canvas_rect_new(rootTimeLine,x*largeur, 
                    y*RULER_HEIGHT,(x2-x+1)*largeur-1,(y2-y+1)*RULER_HEIGHT-1,
				   "line-width", 1.0,"radius-x", 1.0,"radius-y", 1.0,
				   "stroke-color", "darkblue", "fill-color","lightblue",
				   NULL); 
  g_signal_connect (pTimeLineSelectionCursor, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, ScrolledWindowTimeLine);	
  g_signal_connect (pTimeLineSelectionCursor, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, ScrolledWindowTimeLine);	
  /* if the current layer is a 'sound layer', we inhibit the editor */	
  //  gtk_widget_set_sensitive ( pWinTimelineEditor,FALSE);	             		             			   
}
/**********************************
 * mettre à jour le contenu de
 * m'onglet transitions 
 * *******************************/
void set_transition_page(GSList *list, gint kf)
{
   gint    nIndex,total;
   GSList *temp;
   gboolean trouve=FALSE;
   gboolean efm,efr, efz,efalpha,eflumi; /* flags des effets */
   gint zoom, alpha, lumi; /* valeur des effets */
   gdouble rot; /* valeur rotation */
   
	/* vérifier que l'image-clé existe ! */
   if (list==NULL)
        return;	
  /* on cherche le nombre total actuel d'éléments de la liste */ 
   total=g_slist_length(list);	
   nIndex=0;
   while ((!trouve)&&(nIndex<total))
     {
		temp = g_slist_nth (list, nIndex);
		if (((effects_data_type *)(temp->data))->keyframe==kf)
		   {
			   trouve=TRUE;
			   /* aiguiller selon l'instruction */			   
			   /* interpolation */
 
			    if   ( ((effects_data_type *)(temp->data))->effect_motion)
				   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbuttonInterpola),TRUE);
				else 
                   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbuttonInterpola),FALSE);
			   /* effet de rotation */
                if (((effects_data_type *)(temp->data))->effect_rotation)
				  {
				    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonRotation),TRUE);
				  }
				else 
				  {
                    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonRotation),FALSE);
			      }

			   /* effet de zoom */
			    if (((effects_data_type *)(temp->data))->effect_zooming)
				   {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonZoom),TRUE);					 
				   }
			     else
				    {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonZoom),FALSE);
				   }

			   /* effet transparence alpha */
			    if (((effects_data_type *)(temp->data))->effect_alpha)
				   {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonAlphaT),TRUE);
					 // gtk_spin_button_set_value(GTK_SPIN_BUTTON (spinbuttonAlphaT),
					   //      ((effects_data_type *)(temp->data))->alpha);
				   }
			     else
				    {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonAlphaT),FALSE);
					//  gtk_spin_button_set_value(GTK_SPIN_BUTTON (spinbuttonAlphaT),
					  //       ((effects_data_type *)(temp->data))->alpha);
				   }		   
                /* morphing effect */
			    if (((effects_data_type *)(temp->data))->effect_morphing)
				   {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonMorphing),TRUE);					
				   }
			     else
				    {
					  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonMorphing),FALSE);					
				   }	
			   /* effet lumière fading */
		   
			    if (((effects_data_type *)(temp->data))->effect_lumi)
				   {
					//  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonFading),TRUE);
					 // gtk_spin_button_set_value(GTK_SPIN_BUTTON (spinbuttonFading),
					   //      ((effects_data_type *)(temp->data))->lumi);
				   }
			     else
				    {
					 // gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbuttonFading),FALSE);
					 // gtk_spin_button_set_value(GTK_SPIN_BUTTON (spinbuttonFading),
					   //      ((effects_data_type *)(temp->data))->lumi);
				   }
		   }
		nIndex++;		 
	 }/* wend */   		
}
/**********************************
* afficher le curseur de la règle 
* la coordonnée est humaine      
**********************************/
void affiche_curseur_regle(GooCanvasItem *root, gint position)
{	  
  gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
  largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);	 	  
  position=position-1;
  pRulerCursorItem = goo_canvas_image_new(root,GDK_PIXBUF(pIcoRulerCursor),
                                    position*largeur+(largeur/2)-6,
                                    RULER_HEIGHT-12,NULL);    
  /* afficher la position sur la timeline */
  pTimeLineCursorItem= goo_canvas_rect_new (rootTimeLine,
                    position*largeur+(largeur/2)-1, 
                    0,2, 
                    MAX_LAYERS*RULER_HEIGHT,
				   "line-width", 1.0,"radius-x", 1.0,"radius-y", 1.0,
				   "stroke-color", "red", "fill-color", "red",
				   NULL); 
  g_signal_connect (pTimeLineCursorItem, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, ScrolledWindowTimeLine);		
  /* récupérer pointeur sur le dessin associé */
  rootKF=get_keyframe_group(keyframes_list, position);  	
  /* si retour ==NULL, alors bloquer l'onglet 'transitions' 
  * plutôt : voir le contenu de 'cell'
  * */
  if ((rootKF==NULL)||(frame_cell_get (pListViewLayers, x1sel, y1sel)<ELLA_FRAME_MOVEMENT))
   {
     gtk_widget_set_sensitive (scrolledwindowTransitions,FALSE);	
	 set_transition_page(keyframes_list,xcell-1);
   }
  else
   {
	 gtk_widget_set_sensitive (scrolledwindowTransitions,TRUE);  
	 /* mettre à jour le contenu de l'onglet */                              
	 set_transition_page(keyframes_list,xcell-1);
   }
}
/****************************
 * réponse aux clics-souris 
 * sur la règle 
 * *************************/
static gboolean on_ruler_button_press (GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win)
{
 gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
  largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);
  	
  /* effacer la sélection en cours */
	if (SelectedArea)
	   {
		   goo_canvas_item_remove(pDrawings);/* effacer ancien tracé */  
		   timeline_selection_raz();
		   SelectedArea=FALSE;
		   pDrawings=FALSE;
	   }	
  /* effacer */
  efface_curseur_regle();
  /* calculer nouvelle position */
  xruler =(gint)(event->x/largeur)+1;
  if (xruler>MAX_FRAMES)
      xruler=MAX_FRAMES;  
  affiche_curseur_regle(goo_canvas_item_get_parent(item),xruler);
  xcell = xruler;
  gtk_spin_button_set_value( (GtkSpinButton *)spinbuttonMoviePosition,(gfloat) xcell);	
  /* effacer zone de sélection de la timeline */
  goo_canvas_item_remove(pTimeLineSelectionCursor);
  affiche_curseur_timeline(xcell,ycell,xcell,ycell);
  return TRUE;
}
/*********************************
 * fonction renvoyant sous forme
 * de chaîne la position temps
 * dans l'animation
 * locale
 * ******************************/
gchar *position_to_time(gfloat position, gint freq)
{
	gchar *retour=NULL;
	gint reste;
	gfloat dixiemes=0.0;
	reste = (int)position % freq;
	dixiemes = reste/(gfloat)freq*10;	
	retour = g_strdup_printf("%d:0%d secs",(int)position/freq,(int)dixiemes);
    return retour;	
}
/*********************************
 * réactions aux changements de
 * fréquence/image du projet
 * locale
 * ******************************/
void on_spin_button_frequence_changed(GtkWidget *spf, GtkWidget *tps)
{
	gint frq;
	gchar *chaine = NULL;
	MovieFreq  = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spf));	
	chaine = position_to_time((gfloat)(xcell+1),MovieFreq);
    gtk_label_set_text (GTK_LABEL (tps), chaine);
    g_free (chaine);	
	fModified=TRUE;
	/* changing the ruler display in order to reflect frequency changes */
	remove_ruler_bg(GOO_CANVAS(canvasRuler),scrolledWindowRuler);
    draw_ruler(rootRuler,scrolledWindowRuler, timeline_get_movie_freq());	
}
/*********************************
 * réaction aux changements 
 * dans le spin button de 
 * position
 * astuce : on passe un
 * pointeur sur le label du
 * "temps" pour le calculer en
 * même temps
 * ******************************/
void on_spin_button_position_changed(GtkWidget *spb, GtkWidget *tps)
{
	gint position;
	GtkAdjustment *adj_h;
	gchar *chaine = NULL;
	/* lire la valeur du spinbutton */
	position = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spb));	
	efface_curseur_regle();
	xcell = position;
	affiche_curseur_regle(rootRuler,xcell);
	/* modifier les ajustements */
	adj_h = gtk_scrolled_window_get_hadjustment((GtkScrolledWindow *)scrolledWindowRuler);
	//gtk_adjustment_set_value((GtkAdjustment*) adj_h,(gdouble) (xcell*RULER_WIDTH));
    /* modifier l'échelle de temps */
    chaine = position_to_time( (gfloat)(xcell+1),MovieFreq);
    gtk_label_set_text (GTK_LABEL (tps), chaine);
    g_free (chaine);
}

/****************************
 * réponse aux clics-souris
 * sur la timeline
 * *************************/
gboolean on_timeline_button_press(GooCanvasItem  *item,
		      GooCanvasItem  *target,
		      GdkEventButton *event,
		      GtkWidget        *win)
{
  gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
  largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);	
	
 /* double_clic ? */
 if (event->type==GDK_2BUTTON_PRESS	)
   {
   	 printf("double-clic ! \n");
     return TRUE;
   }
 /* clic-gauche ou clic-droit ? */
 if (event->button==3)
   /* clic droit */
   {
   	popup_menu(pListViewLayers, event, xcell, ycell);
   	return TRUE;
   }	
 else
   {
	/* effacer la sélection en cours */
	if (SelectedArea)
	   {
		   goo_canvas_item_remove(pDrawings);/* effacer ancien tracé */  
		   timeline_selection_raz();
		   SelectedArea=FALSE;
		   pDrawings=FALSE;
	   }
    efface_curseur_regle();
    efface_curseur_timeline();
    /* effacer le dessin du calque courant, de la position xcell courante */
    set_drawings_visibility(xcell,FALSE);
    /* calculer nouvelle position */
    xruler =(gint)(event->x/largeur)+1;
    xcell = xruler;
    ycell = (gint)(event->y/RULER_HEIGHT)+1;
    x1sel=xcell;
    y1sel=ycell;
    x2sel=x1sel;
    y2sel=y1sel;
    fTimeLineSelection=!fTimeLineSelection;/* permet d'éviter le bug des double-clics ! */
    affiche_curseur_timeline(xcell,ycell,x2sel,y2sel);
    affiche_curseur_regle(rootRuler,xruler);
    maj_ref_layer(ycell);
    gtk_spin_button_set_value( (GtkSpinButton *)spinbuttonMoviePosition,(gfloat)xcell);	
    layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), ycell);    
    /*  la keyframe_list est sur la bonne valeur après 'affiche_curseur_regle()'! */  	              
    /* afficher le dessin du calque courant, de la position xcell courante */ 
    set_drawings_visibility(xcell,TRUE);     
	set_editor_visibility(xcell,ycell);
    return TRUE;    
   }
  return TRUE;
}
/*******************************
 * initialiser icones du 
 * programme
 * ****************************/
void init_icones(void)
{ 
  pIcoRulerCursor = gdk_pixbuf_new_from_xpm_data((const char **)pointeur_regle_xpm);
}
/*******************************
 * libérer la mémoire des
 * icones utilisées
 * ****************************/
void free_icones(void)
{
    g_object_unref(pIcoRulerCursor);
}
/**************************************
 * effacer une ligne de la timeline
 * (partie de fond)
 * coordonnées PC
 * ************************************/
void remove_timeline_bg(GooCanvas  *root, gint ligne)
{
 GooCanvasItem *time_line_item;
 GooCanvasBounds area;
 gint j;
 gdouble x,y;
 gint    nIndex;
 GList *node, *list;
 gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
 largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);
 area.x1=0;
 area.y1=(gdouble)(ligne*RULER_HEIGHT)+1;
 area.x2=MAX_FRAMES*largeur;
 area.y2=(gdouble)(ligne*RULER_HEIGHT)+RULER_HEIGHT-1;
 list=goo_canvas_get_items_in_area(root,&area,TRUE,TRUE,FALSE);
 if (list)
   	   {   	   	
   	   	for (nIndex = 0; node = g_list_nth (list, nIndex); nIndex++) 
          {
          		goo_canvas_item_remove((GooCanvasItem *)(node->data)); 
          }/* for */   	     	   	
	   }/* endif*/
}
/**************************************
 * effacer la règle
 * ************************************/
void remove_ruler_bg(GooCanvas  *root, GtkWidget *win)
{
 GooCanvasBounds area;
 gint    nIndex;
 GList *node, *list;
 gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
 largeur=(gint)((100*RULER_WIDTH)/100);
 area.x1=0;
 area.y1=0;
 area.x2=MAX_FRAMES*largeur;
 area.y2=(gdouble)(3*RULER_HEIGHT)+RULER_HEIGHT-1;
 list=goo_canvas_get_items_in_area(root,&area,TRUE,TRUE,FALSE);
 if (list)
   	   {   	   	
   	   	for (nIndex = 0; node = g_list_nth (list, nIndex); nIndex++) 
          {
          		goo_canvas_item_remove((GooCanvasItem *)(node->data)); 
          }/* for */   	     	   	
	   }/* endif*/
}
/**************************************
 * dessiner une zone de rotation
 * ***********************************/
GooCanvasItem  *draw_rotation_tween(GooCanvasItem *root,gint ligne, gint first, gint last)
{
  gchar *svgpath;	
  GooCanvasItem *dessin=NULL;
  gint largeur;/* largeur des cases en prenant en compte le zooming */
  
  svgpath = g_strdup_printf(
  "M %d %d L %d %d L %d %d L %d %d L %d %d L %d %d L %d %d L %d %d L %d %d L %d %d",
  
  first*RULER_WIDTH+RULER_WIDTH+RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4,
  first*RULER_WIDTH+RULER_WIDTH+RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4,
  first*RULER_WIDTH+RULER_WIDTH+RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2, 
  last*RULER_WIDTH-RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  last*RULER_WIDTH-RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4,
  last*RULER_WIDTH-RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4
  );
 /* on trace le dessin approprié */
  dessin= goo_canvas_path_new(root,svgpath, "stroke-color", "blue",NULL);
  g_free(svgpath);
  return dessin;
}  
/**************************************
 * dessiner la ligne d'un zooming
 * ***********************************/
GooCanvasItem  *draw_zoom_tween(GooCanvasItem *root,gint ligne, gint first, gint last)
{
  gchar *svgpath;	
  GooCanvasItem *dessin=NULL;
  static const double dashed1[] = {1.0, 1.0};
  static int len1  = sizeof(dashed1) / sizeof(dashed1[0]);
  GooCanvasLineDash *style_trait; 
  
  //style_trait=goo_canvas_line_dash_newv(len1,(gdouble *)dashed1);
  svgpath = g_strdup_printf("M %d %d L %d %d L %d %d L %d %d  L%d %d L%d %d M %d %d L %d %d L %d %d L %d %d L %d %d",
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  last*RULER_WIDTH-RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4,
  last*RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4,
  first*RULER_WIDTH+RULER_WIDTH+RULER_WIDTH-1,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2+4,
  first*RULER_WIDTH+RULER_WIDTH,ligne*RULER_HEIGHT+RULER_HEIGHT/2-4);
  /* on trace le dessin approprié */
  dessin= goo_canvas_path_new(root,svgpath, "stroke-color", "blue",NULL);
  g_free(svgpath);
  return dessin;
}
/*** create stipple ***/
static cairo_pattern_t*
create_stipple (const char *color_name, guchar stipple_data[16])
{
  cairo_surface_t *surface;
  cairo_pattern_t *pattern;
  GdkColor color;

  gdk_color_parse (color_name, &color);
  stipple_data[2] = stipple_data[14] = color.red >> 8;
  stipple_data[1] = stipple_data[13] = color.green >> 8;
  stipple_data[0] = stipple_data[12] = color.blue >> 8;
  surface = cairo_image_surface_create_for_data (stipple_data,
						 CAIRO_FORMAT_ARGB32,
						 2, 2, 8);
  pattern = cairo_pattern_create_for_surface (surface);
  cairo_surface_destroy (surface);
  cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REPEAT);

  return pattern;
}
/**** patterns sous forme de gradients */
static cairo_pattern_t *patron_son_utilise(gdouble x,gdouble y,gdouble xf,gdouble yf)
{
	cairo_pattern_t *pattern;
	/* marche, mais il faut maîtriser ! */
	pattern = cairo_pattern_create_linear(x, y, x, yf);
	cairo_pattern_add_color_stop_rgb(pattern, 0.1, 0.56, 0.93, 0.56);
	cairo_pattern_add_color_stop_rgb(pattern, 0.5, 0.56, 0.93, 0.56);
	cairo_pattern_add_color_stop_rgb(pattern, 0.6, 0.56, 0.93, 0.56);
    cairo_pattern_add_color_stop_rgb(pattern, 0.9, 0.3, 0.7, 0.6);
    
	return pattern;
}

static cairo_pattern_t *patron_utilise(gdouble x,gdouble y,gdouble xf,gdouble yf)
{
	cairo_pattern_t *pattern;
	/* marche, mais il faut maîtriser ! */
	pattern = cairo_pattern_create_linear(x, y, x, yf);
	cairo_pattern_add_color_stop_rgb(pattern, 0.1, 0.87, 0.8, 0.6);
	cairo_pattern_add_color_stop_rgb(pattern, 0.3, 0.87, 0.8, 0.6);
	cairo_pattern_add_color_stop_rgb(pattern, 0.6, 0.87, 0.8, 0.6);
    cairo_pattern_add_color_stop_rgb(pattern, 0.9, 0.76, 0.6, 0.2);
    
	return pattern;
}
static cairo_pattern_t *patron_mouvement(gdouble x,gdouble y,gdouble xf,gdouble yf)
{
	cairo_pattern_t *pattern;
	/* marche, mais il faut maîtriser ! */
	pattern = cairo_pattern_create_linear(x, y, x, yf);
	cairo_pattern_add_color_stop_rgb(pattern, 0.1, 0.68, 0.85, 0.9);
	cairo_pattern_add_color_stop_rgb(pattern, 0.5, 0, 0.66, 1);
    cairo_pattern_add_color_stop_rgb(pattern, 0.9, 0, 0.48, 0.65);
    
	return pattern;
}
/**************************************
 * dessiner la ligne d'une motion 
 * tween
 * ************************************/
GooCanvasItem  *draw_motion_tween(GooCanvasItem *root,
                     gint ligne, gint first, gint last, 
					 GtkWidget *win)
{
  gchar *svgpath;	
  GooCanvasItem *dessin=NULL;
  cairo_pattern_t *pat3,*pat4;
  gint largeur;/* largeur des cases en prenant en compte le zooming */
 
  largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);
   
  pat4=patron_mouvement((first+1)*largeur,
                       ligne*RULER_HEIGHT,
					   last*largeur,
					   ligne*RULER_HEIGHT+RULER_HEIGHT-1);  
  dessin=goo_canvas_rect_new (root,
	                (first+1)*largeur,
					 ligne*RULER_HEIGHT, 
					 last*largeur-(first+1)*largeur,
					 RULER_HEIGHT-3,
				   "line-width", 1.0,"radius-x", 2.0,"radius-y", 2.0,
				   "stroke-color", "darkblue","fill-pattern", pat4,
				   NULL); 
  
    /* Connect a signal handler for each timeline case item. */
  	     g_signal_connect (dessin, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		 g_signal_connect (dessin, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		 g_signal_connect (dessin, "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win);
  
  svgpath = g_strdup_printf("M %d %d  L %d %d L %d %d M %d %d L %d %d",
			                 first*largeur+largeur,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
			                 last*largeur-2,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
			                 last*largeur-5,ligne*RULER_HEIGHT+RULER_HEIGHT/2-3,
			                 last*largeur-2,ligne*RULER_HEIGHT+RULER_HEIGHT/2,
			                 last*largeur-5,ligne*RULER_HEIGHT+RULER_HEIGHT/2+3);
  /* on trace le dessin approprié */
  dessin= goo_canvas_path_new(root,svgpath,"stroke-color", "white",NULL);
  g_free(svgpath); 
  return dessin; 
} 


/***************************************
 * dessiner une ligne de la timeline
 * (partie de fond)
 * coordonnées humaines
 * ************************************/
void draw_timeline_bg(GooCanvasItem *root,GtkTreeView *treeview, gint ligne, GtkWidget *win)
{
 GooCanvasItem *time_line_item,*tl2,*text_item;
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1, *svgpath;
 GtkTreeIter pIter;
 gint j,k,type_layer;
 guint cell;
 gint first_kf, last_kf;/* coordonnées pc */
 gchar *couleur;
 gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 /* gradients */
  
  cairo_pattern_t *pat3,*pat4;
  static guchar stipple_data[16] = {
    255, 255, 255, 255,   255, 255, 255, 255,   255, 255, 255, 255,    255, 255, 255, 255
  };

//pat3 = create_stipple ("#D08A3F", stipple_data);
 
 largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);
 ligne= ligne-1; 
 first_kf=-1;/* au départ, rien de trouvé */
 last_kf=-1;
 /* récupérer un pointeur sur la ligne de la GTkTreeList */
 k=0;
 for (j=0;j<MAX_FRAMES;j++)
   {
   	 /* récupérer itérateur */
   	 path1=g_strdup_printf ("%d:%d",ligne,N_COLUMN+j);
   	 path=gtk_tree_path_new_from_string(path1);
   	 model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));
   	 gtk_tree_model_get_iter(model, &pIter, path);
   	 gtk_tree_model_get (model, &pIter,LAYER_TYPE,&type_layer,N_COLUMN+j,&cell,  -1);	
	 /* est-ce une image vide ? */
	 if (cell==ELLA_FRAME_NON_USED)
	   {
   	     if (k==4)
   	      {
   	   	    k=0; 
	        /* tracer un rectangle foncé */
	        time_line_item= goo_canvas_rect_new (root,
	                j*largeur, ligne*RULER_HEIGHT, largeur, RULER_HEIGHT-1,
				   "line-width", 1.0,"radius-x", 2.0,"radius-y", 2.0,
				   "stroke-color", "darkgrey","fill-color", "lightblue",NULL); 
	       }
	     else
	       {
	         k++;		
	         /* tracer un rectangle clair */
	         time_line_item= goo_canvas_rect_new (root,
	                j*largeur, ligne*RULER_HEIGHT, largeur, RULER_HEIGHT-1,
				   "line-width", 1.0,"radius-x", 2.0,"radius-y", 2.0,
				   "stroke-color", "lightgrey","fill-color", "white", NULL);
	        }/* else */
         /* Connect a signal handler for each timeline case item. */
  	     g_signal_connect (time_line_item, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		 g_signal_connect (time_line_item, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		 g_signal_connect (time_line_item, "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win); 
	   }/* endif frame non used */					 
    g_free(path1);
    gtk_tree_path_free(path);
    /* image utilisée ? */
    if (cell>ELLA_FRAME_NON_USED)
      {
		if (k==4)
		  k=0;
		else
		  k++;		 
		if (type_layer==SOUND_LAYER)
		    pat3=patron_son_utilise(j*largeur+1,
		                   ligne*RULER_HEIGHT,
						   j*largeur+1,
						   ligne*RULER_HEIGHT+RULER_HEIGHT-2
		                   );  
		else
		       pat3=patron_utilise(j*largeur+1,
		                   ligne*RULER_HEIGHT,
						   j*largeur+1,
						   ligne*RULER_HEIGHT+RULER_HEIGHT-2
		                   );  
		/* prévoir une autre couleur si piste son */				   
      	time_line_item= goo_canvas_rect_new (root,
	                j*largeur+1, ligne*RULER_HEIGHT, largeur, RULER_HEIGHT-3,
				   "line-width", 1.0,"radius-x", 2.0,"radius-y", 2.0,
				   "stroke-color", "#CAB99D","fill-pattern", pat3,NULL); 
		g_object_set(time_line_item,"fill-pattern",pat3,NULL);
		tl2=goo_canvas_polyline_new_line (root,
		                   j*largeur,ligne*RULER_HEIGHT+RULER_HEIGHT-1,
						   j*largeur+largeur,ligne*RULER_HEIGHT+RULER_HEIGHT-1,
						   "line-width", 1.0,"stroke-color","black",NULL);
	    g_signal_connect (time_line_item, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		g_signal_connect (time_line_item, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		g_signal_connect (time_line_item, "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win);		           		   
	  }
    /* image-clef ? */
    if (((cell&ELLA_FRAME_KEY_EMPTY)==ELLA_FRAME_KEY_EMPTY)||((cell&ELLA_FRAME_KEY_USED)==ELLA_FRAME_KEY_USED)
	     ||((cell&ELLA_FRAME_KEY_USED_FOR_SOUND)==ELLA_FRAME_KEY_USED_FOR_SOUND))
      {
      	if ((cell&ELLA_FRAME_KEY_EMPTY)==ELLA_FRAME_KEY_EMPTY)
      	   couleur=g_strdup_printf("%s","white");
      	else
      	   couleur=g_strdup_printf("%s","black");
      		 
		time_line_item=goo_canvas_ellipse_new (root,j*largeur+largeur/2,
                                               ligne*RULER_HEIGHT+RULER_HEIGHT/2,
                                                         largeur/4,
                                                         RULER_HEIGHT/4,
														 "line-width", 1.0,
														 "stroke-color","black","fill-color", couleur, NULL); 										 
         /* tracer une ligne noire verticale juste avant la zone */	                                                 
	     tl2=goo_canvas_polyline_new_line (root,
		                   j*largeur-1,ligne*RULER_HEIGHT,
						   j*largeur-1,
						   ligne*RULER_HEIGHT+RULER_HEIGHT-3,
						   "line-width", 1.0,
						   "stroke-color","black",
						   NULL);

	    g_signal_connect (time_line_item, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		g_signal_connect (time_line_item, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		g_signal_connect (time_line_item, "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win);    
		/* gestion des flags first/last on ne gère que le côté first, car pour l'interpolation, il faut une paire */
		if (first_kf==-1)
		  {
	        first_kf=j;
	        last_kf=-1;	
		  }
		else
		  {
		  	/* donc, le 1er a déjà une valeur */
		  	last_kf=j;
		  	if (((cell&ELLA_FRAME_MOVEMENT)==ELLA_FRAME_MOVEMENT)&&(last_kf!=-1))
	          {	  		           
	           last_kf=j;	   
			   /* attention, il faut des décimaux pour les svgpaths */
			   time_line_item=draw_motion_tween(root, ligne, first_kf, last_kf,win);
	           g_signal_connect (time_line_item, "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		       g_signal_connect (time_line_item, "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		       g_signal_connect (time_line_item, "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win); 		       
	          }/*endif test movement flag */	 
	        /* on remet à zéro les valeurs */
	        first_kf=j;
	        last_kf=-1;
		  }/* endif paire de valeurs */
	  }/* endif image clef vide */	 
   }/* for j*/	
 /* récupérer un pointeur sur la ligne de la GTkTreeList */
 k=0;
 for (j=0;j<MAX_FRAMES;j++)
   {
   	 /* récupérer itérateur */
   	 path1=g_strdup_printf ("%d:%d",ligne,N_COLUMN+j);
   	 path=gtk_tree_path_new_from_string(path1);
   	 model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));
   	 gtk_tree_model_get_iter(model, &pIter, path);
	 /* indispensable de connaître keyframe_list */
   	 gtk_tree_model_get (model, &pIter,LAYER_TYPE,&type_layer,N_COLUMN+j,&cell,LAYER_MOVEMENT_INDEX,&keyframes_list,  -1);	
     g_free(path1);
     gtk_tree_path_free(path);
     /* for a sound layer, we can print the name of sound file */
	 if (cell==ELLA_FRAME_KEY_USED_FOR_SOUND)
	   {
		 if (type_layer==SOUND_LAYER)
		     { 
				 text_item = goo_canvas_text_new (root, (gchar *)get_keyframe_sound_file_field(keyframes_list, j),
				  j*largeur+largeur, ligne*RULER_HEIGHT+RULER_HEIGHT/2, -1,
				   GTK_ANCHOR_WEST,
				   "font", "Sans 8",NULL);											 
	             g_signal_connect (text_item , "button_press_event",
		             (GtkSignalFunc) on_timeline_button_press, win);			   
		         g_signal_connect (text_item , "button_release_event",
		             (GtkSignalFunc) on_timeline_button_release, win);             
		         g_signal_connect (text_item , "motion_notify_event",
		             (GtkSignalFunc) on_timeline_mouse_move, win);    	
	         }/* endif sound keyframe */	 
	   }/* endif */
   }/* for j*/	
}
/***************************************
 * dessiner la règle
 * en retour, pointeur sur la règle
 * permettant de brancher le signal
 * ************************************/
void draw_ruler(GooCanvasItem *root, GtkWidget *win,gint freq )
{
 GooCanvasItem *ruler_item, *text_item, *grad_item,*duree_item;
 gint j,k,d;
 gchar *valeur, *duree;
 gint largeur;/* largeur des cases en prenant en compte le zooming */
 
 
 largeur=(gint)((TimelineZoom*RULER_WIDTH)/100);
 
 ruler_item = goo_canvas_rect_new (root, 0, 0, MAX_FRAMES*largeur+(largeur/2), RULER_HEIGHT,
				   "line-width", 2.0,"radius-x", 2.0,"radius-y", 2.0,
				   "stroke-color", "darkgrey","fill-color", "lightgrey",
				   NULL);	

 /* dessin des graduations */
 k=1;
 d=1;
 for (j=0;j<MAX_FRAMES;j++)
   {
	 if (d==freq)
	    {
			duree=g_strdup_printf("%d\"",j/freq+1);
			duree_item = goo_canvas_text_new (root, duree, j*largeur+(largeur/2), 8, -1,
				   GTK_ANCHOR_CENTER,
				   "fill-color","red",
				   "font", "Sans 7",
				   NULL);	
			g_signal_connect (duree_item, "button_press_event",
		                  (GtkSignalFunc) on_ruler_button_press, win);	   
			g_free(duree);	   
			d=0;
		}  
	 d++;	
   	 if (k==5)
   	   {
   	   	k=0;
   	   	/* écrire la valeur */
   	   	valeur=g_strdup_printf ("%d",j+1);
   	   	text_item = goo_canvas_text_new (root, valeur, j*largeur+(largeur/2), 18, -1,
				   GTK_ANCHOR_CENTER,
				   "fill-color","black",
				   "font", "Sans 7",
				   NULL);			   
	    g_free(valeur);
	    /* obligé, car chaque item est indépendant */
	    g_signal_connect (text_item, "button_press_event",
		                  (GtkSignalFunc) on_ruler_button_press, win);
	    /* tracer un grand trait vertical */
	    grad_item=goo_canvas_polyline_new_line(root,j*largeur+(largeur/2),RULER_HEIGHT-6,
	    											j*largeur+(largeur/2),RULER_HEIGHT,
	                                           		"stroke-color", "black",
	                                           		NULL); 
	   }
	k++;
	/* tracer un petit trait vertical */
	grad_item=goo_canvas_polyline_new_line(root,j*largeur+(largeur/2),
	                                           RULER_HEIGHT-4,
	                                           j*largeur+(largeur/2),RULER_HEIGHT,
	                                           "stroke-color", "black",NULL); 
   }/* for j*/
   /* Connect a signal handler for the ruler item. */
   g_signal_connect (ruler_item, "button_press_event",
		             (GtkSignalFunc) on_ruler_button_press, win);
}

/*************************
 * création icones de la
 * des layers
 * *********************/
void init_ico_layers(void)
{
	pIco_layer_dessin= gdk_pixbuf_new_from_xpm_data((const char **)ico_layer_draw_xpm);
    pIco_layer_son=gdk_pixbuf_new_from_xpm_data((const char **)ico_layer_sound_xpm);
}
/*******************************
 * initialisation des tableaux
 * et pointeurs de l'IHM ;
 * attention : "ritem" est
 * l'ancetre des items
 * sur le canvas de l'éditeur !
 * ****************************/
GtkWidget *init_ihm(GtkWidget *ScrolledWindowTimeLine, GooCanvasItem *ritem, GtkWidget *winEditor)
{	  
  gchar *sLayerName;
  gchar *sIndexVal;    
  gint i,j,k;
  GtkWidget *canvasTL;
  
  /* store a pointer on the Scrolled window of the editor */
  pWinTimelineEditor=winEditor;
  /* initialise variables */
  timeline_raz_vars();
  /* icones utilisées sur la timeline */
  init_icones();
  init_ico_layers();
  PangoFontDescription *desc =  pango_font_description_new ();
  /* dessin de la table de montage */   
  canvasTL = goo_canvas_new ();
  goo_canvas_set_bounds (GOO_CANVAS (canvasTL),0,0,MAX_FRAMES*RULER_WIDTH, MAX_LAYERS*RULER_HEIGHT);
  gtk_widget_show (canvasTL);
  gtk_container_add (GTK_CONTAINER (ScrolledWindowTimeLine), canvasTL);
  rootTimeLine = goo_canvas_get_root_item (GOO_CANVAS (canvasTL));     
  /* affichage de la règle */
  canvasRuler = goo_canvas_new ();
  gtk_widget_set_size_request (canvasRuler, 600, RULER_HEIGHT+6); 
  goo_canvas_set_bounds (GOO_CANVAS (canvasRuler), 0, 0, MAX_FRAMES*RULER_WIDTH, RULER_HEIGHT+6);/* dimensions virtuelles maximum */
  gtk_widget_show (canvasRuler);
  gtk_container_add (GTK_CONTAINER (scrolledWindowRuler), canvasRuler);
  rootRuler = goo_canvas_get_root_item (GOO_CANVAS (canvasRuler)); 
  draw_ruler(rootRuler,scrolledWindowRuler, timeline_get_movie_freq());
  /* création dynamique du modèle */
  pListStore = init_store();
  /* pListViewLayers : GtkWidget qui sera mis dans la scrolledwindow */
  pListViewLayers = init_tree_list_layers(pListStore,MAX_LAYERS,ritem);        
  /* pack the table into the scrolled window */
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (ScrolledWindowLayersList), pListViewLayers);  
  /* brancher événements souris */
  gtk_widget_add_events (ScrolledWindowTimeLine, GDK_BUTTON_PRESS_MASK |GDK_POINTER_MOTION_MASK
  							| GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_RELEASE_MASK 
  							| GDK_LEAVE_NOTIFY_MASK );
  g_signal_connect(G_OBJECT(pListViewLayers),
                      "cursor-changed", 
                      G_CALLBACK(on_my_treeview_cursor_changed), 
                      (gpointer *) pListViewLayers );
    
  affiche_curseur_timeline(xcell,ycell,xcell,ycell);
  affiche_curseur_regle(rootRuler,xruler);
  layer_activate_cursor(GTK_TREE_VIEW(pListViewLayers), ycell);     
  return canvasTL;
}
/******************************/
/******************************
 * changement du coefficient 
 * de zooming de la timeline
 * ***************************/
void timeline_set_zooming(gint z)
{
	TimelineZoom=z;
}
/* effacer toute la timeline suite à un changement de zooming */
void timeline_wipe_before_zooming(void)
{
  gint count;
 
  if (LayerCount<=0)
       return;
  efface_curseur_timeline();
  efface_curseur_regle();	   
  for (count=0;count<LayerCount;count++)
     {    	   
	   /* effacer les dessins de la timeline */
	   remove_timeline_bg(GOO_CANVAS(canvasTimeLine),count);   
     }/* next count */       
  /* effacer la régle */	
  remove_ruler_bg(GOO_CANVAS(canvasRuler),scrolledWindowRuler);
}
/* réafficher la timeline avec le nouveau coefficient de zooming */
void timeline_redraw_after_zooming(void)
{
  gint count;
 
  if (LayerCount<=0)
       return;
  for (count=0;count<LayerCount;count++)
     {    	   
	   /* effacer les dessins de la timeline */
	  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),count+1,ScrolledWindowTimeLine); 
     }
  /* afficher la règle */	
  draw_ruler(rootRuler,scrolledWindowRuler,timeline_get_movie_freq());   
  timeline_put_cursors();
}
/***********************************
 * add a new sound object by DnD
 * ********************************/
void timeline_add_sound_DnD(gchar *file_name)
{
 GtkTreeModel *model;
 GtkTreePath *path;
 gchar *path1;
 GtkTreeIter pIter;
 gint count,type_layer;
 guint cell;
 
  /* is the current position is in a sound layer and a keyframe ? */
  printf("layer =%d / image =%d fichier:%s<\n",ycell,xcell,file_name);/* valeurs en coordonnées humaines */
	  
  efface_curseur_regle();
  efface_curseur_timeline();
  /* récupérer itérateurs depuis le début de la ligne, pour modifier le contenu des cellules  */
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(pListViewLayers));    
  path1=g_strdup_printf ("%d:%d",ycell-1,N_COLUMN+xcell-1);
  path=gtk_tree_path_new_from_string(path1);      
  gtk_tree_model_get_iter(model, &pIter, path);
  gtk_tree_model_get (model, &pIter,N_COLUMN+xcell-1,&cell, LAYER_TYPE,&type_layer, -1);
  if (type_layer!=SOUND_LAYER)
     /* we can't achieve the DnD, because isn't a 'sound layer' */
     printf("interdit, ce calque n'est pas sonore ! \n");
  else
    {
      if ((cell!=ELLA_FRAME_KEY_USED)&&(xcell!=1)&&(cell!=ELLA_FRAME_KEY_USED_FOR_SOUND))
         {
			 /* we can't achieve the DnD because the cursor is on a 'non keyframe' frame */
			printf("problème ! Le curseur n'est pas sur une image-clé !\n");
		 }
      else
         {
			 /* is it possible to achieve the DnD */
			cell=ELLA_FRAME_KEY_USED_FOR_SOUND;
			gtk_list_store_set(pListStore, &pIter,N_COLUMN+xcell-1,cell,-1);
			/* we're now storing the sound */
			set_liste_keyframes_for_sound(keyframes_list, xcell-1,file_name);
			/* il faut maintenant le mettre sur la pile */
		 }
     }/*elseend*/
	 
  g_free(path1);
  gtk_tree_path_free(path);
  remove_timeline_bg(GOO_CANVAS(canvasTimeLine),ycell-1);
  draw_timeline_bg(rootTimeLine,GTK_TREE_VIEW(pListViewLayers),ycell,ScrolledWindowTimeLine);
  affiche_curseur_timeline(xcell,LayerSelected+1,xcell,LayerSelected+1);
  affiche_curseur_regle(rootRuler,xcell);   
  fModified=TRUE;		
}
